/***********************************************************************
 * TEho͏ (VXeˑ)
 *
 *      ڍׂ́A snddrv.h / mame-quasi88.h Q
 ************************************************************************/

/*----------------------------------------------------------------------*
 * Classico[W̃\[XR[h̑啔́A                          *
 * Koichi NISHIDA  Classic iP6 PC-6001/mk2/6601 emulator ̃\[X *
 * QlɂĂ܂B                                         *
 *                                                   (c) Koichi NISHIDA *
 *                                       based on MESS/MAME source code *
 *----------------------------------------------------------------------*/


#include <OSUtils.h>
#include <Sound.h>
#include <Timer.h>
#include <QuickTime.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#ifdef	USE_SOUND

#include "mame-quasi88.h"

#include "snddrv.h"
static	int use_audiodevice = 1;	/* use audio-devide for audio output */


static Boolean InitializeSound(void);
static void TearDownSound(void);
static void PauseSound(Boolean inPause);
static Boolean isFullSoundStream(int dataNum);
static Boolean isLessSoundStream(int dataNum, long tick);


static Boolean alreadyInit = false;

#define	REFRESH_RATE	60.0
#define	CHANNELS		sNumOfChannles

/*----------------------------------------------------------------------*/
int		attenuation = 0;		/* {[ -32`0 [db] */

/*===========================================================================*/
/*              QUASI88 ĂяoAMAME ̏֐                    */
/*===========================================================================*/

/******************************************************************************
 * TEhnIvV̏^I֐
 *
 * int xmame_config_init(void)
 *      config_init() AIvV̉͂JnOɌĂяoB
 *      MAMEˑ[N̏ȂǂKvȏꍇ́AōsB
 *
 * void xmame_config_exit(void)
 *      config_exit() A̍ŌɌĂяoB
 *      xmame_config_init() ̏̌ЕtKvȂAōsB
 *
 *****************************************************************************/
int		xmame_config_init(void)
{
	return 0;		/*OSD_OK;*/
}
void	xmame_config_exit(void)
{
}


/******************************************************************************
 * TEhnIvṼIvVe[u擾
 *
 * const T_CONFIG_TABLE *xmame_config_get_opt_tbl(void)
 *      config_init() A xmame_config_init() ̌ɌĂяoB
 *
 *      TEhnIvV̉͏ɂāA QUASI88 ̃IvVe[u
 *      T_CONFIG_TABLE gpꍇÃ|C^ԂB
 *      Ǝŉ͂ꍇ́A NULL ԂB
 *****************************************************************************/
static	int	invalid_arg;			/* ȃIvVp̃_~[ϐ */
static	const	T_CONFIG_TABLE xmame_options[] =
{
  /* 350`399: TEhˑIvV */

  { 351, "sound",        X_FIX,  &use_sound,       TRUE,                  0,0, OPT_SAVE },
  { 351, "nosound",      X_FIX,  &use_sound,       FALSE,                 0,0, OPT_SAVE },

  { 352, "audio",        X_FIX,  &use_audiodevice, TRUE,                  0,0, OPT_SAVE },
  { 352, "noaudio",      X_FIX,  &use_audiodevice, FALSE,                 0,0, OPT_SAVE },

  { 353, "fmgen",        X_FIX,  &use_fmgen,       TRUE,                  0,0, OPT_SAVE },
  { 353, "nofmgen",      X_FIX,  &use_fmgen,       FALSE,                 0,0, OPT_SAVE },

  { 354, "volume",       X_INT,  &attenuation,     -32, 0,                  0, OPT_SAVE },

  { 355, "fmvol",        X_INT,  &fmvol,           0, 100,                  0, OPT_SAVE },
  { 356, "psgvol",       X_INT,  &psgvol,          0, 100,                  0, OPT_SAVE },
  { 357, "beepvol",      X_INT,  &beepvol,         0, 100,                  0, OPT_SAVE },
  { 358, "rhythmvol",    X_INT,  &rhythmvol,       0, 200,                  0, OPT_SAVE },
  { 359, "adpcmvol",     X_INT,  &adpcmvol,        0, 200,                  0, OPT_SAVE },
  { 360, "fmgenvol",     X_INT,  &fmgenvol,        0, 100,                  0, OPT_SAVE },
  { 361, "samplevol",    X_INT,  &samplevol,       0, 100,                  0, OPT_SAVE },

  { 362, "samplefreq",   X_INT,  &options.samplerate, 8000, 44100,          0, OPT_SAVE },

  { 363, "samples",      X_FIX,  &options.use_samples, 1,                 0,0, OPT_SAVE },
  { 363, "nosamples",    X_FIX,  &options.use_samples, 0,                 0,0, OPT_SAVE },

  /* I[ */
  {   0, NULL,           X_INV,                                       0,0,0,0, 0        },
};

const T_CONFIG_TABLE *xmame_config_get_opt_tbl(void)
{
	return xmame_options;
}


/******************************************************************************
 * TEhnIvṼwvbZ[W\
 *
 * void xmame_config_show_option(void)
 *      config_init() AIvV -help ̏̍ۂɌĂяoB
 *      Wo͂ɃwvbZ[W\B
 *****************************************************************************/
#ifdef	XMAME_SNDDRV_071
#define	XMAME_VER "0.71.1"
#else	/* ver 0.106 */
#define	XMAME_VER " 0.106"
#endif

void	xmame_config_show_option(void)
{
  fprintf(stdout,
  "\n"
  "==========================================\n"
  "== SOUND OPTIONS ( dependent on XMAME ) ==\n"
  "==                     [ XMAME " XMAME_VER " ] ==\n"
  "==========================================\n"
  "    -[no]sound              Enable/disable sound (if available) [-sound]\n"
  "    -[no]fmgen              Use/don't use cisc's fmgen library\n"
  "                                               (if compiled in)  [-nofmgen]\n"
  "    -volume <n>             Set volume to <n> db, (-32 (soft) - 0(loud)) [0]\n"
  "    -fmvol <level>          Set FM     level to <level> %%, (0 - 100) [100]\n"
  "    -psgvol <level>         Set PSG    level to <level> %%, (0 - 100) [20]\n"
  "    -beepvol <level>        Set BEEP   level to <level> %%, (0 - 100) [60]\n"
  "    -rhythmvol <level>      Set RHYTHM level to <level> %%, (0 - 100) [100]\n"
  "    -adpcmvol <level>       Set ADPCM  level to <level> %%, (0 - 100) [100]\n"
  "    -fmgenvol <level>       Set fmgen  level to <level> %%, (0 - 100) [100]\n"
  "    -samplevol <level>      Set SAMPLE level to <level> %%, (0 - 100) [100]\n"
  "    -samplefreq <rate>      Set the playback sample-frequency/rate [44100]\n"
  "    -[no]samples            Use/don't use samples (if available) [-nosamples]\n"
  );
}


/******************************************************************************
 * TEhnIvV̉͏
 *
 * int xmame_config_check_option(char *opt1, char *opt2, int priority)
 *      config_init() Aݒt@C̉͂sȂۂɁA
 *      K̃IvV̂ɂvȂꍇÅ֐ĂяoB
 *
 *              opt1     c ŏ̈()
 *              opt2     c ̂̈( Ȃ NULL)
 *              priority c Dx (l傫قǗDx)
 *
 *      ߂l  1  c 1 (opt1 ̂ݏB opt2 ͖)
 *              2  c 2 (opt1  opt2 )
 *              0  c opt1 m̈̂߁A opt1 opt2 Ƃɖ
 *              -1 c ŒvIȈُ킪
 *
 *      ُ̈ (̎wl͈͊OȂ) ADxɂ菈XLbv
 *      ꂽ悤ȏꍇ́AłꍇƓlɁA 1  2 ԂB
 *
 *       ̊֐́AƎŃIvV͂邽߂̊֐Ȃ̂ŁA
 *         IvVe[u T_CONFIG_TABLE gpꍇ́A_~[ł悢B
 *****************************************************************************/
int		xmame_config_check_option(char *opt1, char *opt2, int priority)
{
	return 0;
}


/******************************************************************************
 * TEhnIvVۑ邽߂̊֐
 *
 * int  xmame_config_save_option(void (*real_write)
 *                                 (const char *opt_name, const char *opt_arg))
 *
 *      ݒt@C̕ۑ̍ۂɁAĂяoB
 *              uopt_name ɃIvVA opt_arg ɃIvV
 *                ZbgAreal_write Ăяov
 *              ƂAۑSIvVɑ΂ČJԂsȂB
 *
 *              () "-sound" ݒt@Cɕۑꍇ
 *                      (real_write)("sound", NULL) ĂяoB
 *              () "-fmvol 80" ݒt@Cɕۑꍇ
 *                      (real_write)("fmvol", "80") ĂяoB
 *
 *      ߂l   0 Ԃ
 *
 *       ̊֐́AƎŃIvV͂邽߂̊֐Ȃ̂ŁA
 *         IvVe[u T_CONFIG_TABLE gpꍇ́A_~[ł悢B
 *****************************************************************************/
int		xmame_config_save_option(void (*real_write)
								   (const char *opt_name, const char *opt_arg))
{
	return 0;
}


/******************************************************************************
 * TEhnIvVj[ύX邽߂̃e[u擾֐
 *
 * T_SNDDRV_CONFIG *xmame_config_get_sndopt_tbl(void)
 *
 *      j[[h̊JnɌĂяoB
 *              ύX\ȃTEhnIvV̏AT_SNDDRV_CONFIG ^
 *              zƂėpӂA̐擪|C^ԂB
 *              z͍ő5܂ŁAɖɂ͏I[f[^ZbgĂB
 *
 *              ɕύX^ł̂ꍇ NULL ԂB
 *****************************************************************************/
T_SNDDRV_CONFIG *xmame_config_get_sndopt_tbl(void)
{
	return NULL;
}


/******************************************************************************
 * TEh@\̏擾֐
 *
 * int xmame_has_audiodevice(void)
 *      TEhIfoCXo͂̉ۂԂB
 *      ^ȂfoCXo͉BUȂsB
 *
 * int xmame_has_mastervolume(void)
 *      TEhfoCX̉ʂύX\ǂԂB
 *      ^ȂύX\BUȂsB
 *
 *****************************************************************************/
int		xmame_has_audiodevice(void)
{
    if (use_audiodevice) return TRUE;
    else                 return FALSE;
}

int		xmame_has_mastervolume(void)
{
	return TRUE;
}


/*===========================================================================*/
/*              MAME ̏֐ĂяoAVXeˑ֐        */
/*===========================================================================*/

/******************************************************************************
 * TEhfoCX
 *      ̊֐́AO[oϐ use_sound Ȕꍇ́AĂяoȂB
 *
 * int osd_start_audio_stream(int stereo)
 *      TEhfoCXB
 *          stereo ^ȂXeIóAUȂ烂mo͂ŏB
 *          (mo͂́AÂo[W MAME/XMAME  YM2203 
 *           ꍇ̂݁AgpĂBȊOׂ͂ăXeIo͂gpB)
 *      ̊֐́AG~[V̊JnɌĂяoB
 *          ́A1t[̃TvԂB
 *          śA0 ԂB
 *              A 0 Ԃ QUASI88 IĂ܂̂ŁA
 *              TEhfoCX̏ɎsꍇłATEho͂Ȃ
 *              i߂ƂꍇAƂɂKȒlԂKvB
 *
 * int osd_update_audio_stream(INT16 *buffer)
 *      TEhfoCXɏo͂B
 *      ̊֐́A1t[ɌĂяoBbuffer ɂ1t[
 *      (Machine->sample_rate / Machine->drv->frames_per_second) ̃TEh
 *      f[^i[ĂBf[^ 16bittŁAXeȈꍇ
 *      ƉẼTv݂ɕłB
 *
 *      ۂɂ̊֐Ăяoꂽ^C~OŃfoCXɏo͂邩A邢
 *      Ńobt@Oĕʓro͂邩́AłB
 *
 *      ߒĺA osd_start_audio_stream() Ɠ
 *
 * void osd_stop_audio_stream(void)
 *      TEhfoCXIB
 *      ̊֐́AG~[V̏IɌĂяoB
 *      ȍ~A osd_update_audio_stream() Ȃǂ͌ĂяoȂBG~[V
 *      ĊJꍇ́A osd_start_audio_stream() ĂяoB
 *
 * void osd_update_video_and_audio(void)
 *      TEhfoCX̏o͂̂Q
 *      ^C~OIɂ́A osd_update_audio_stream() ̒ɌĂяoB
 *      XMAME 0.106 ɍ킹Ē`Ă邪A osd_update_audio_stream() 
 *      Ǝłꂢ΁Å֐̓_~[ł悢B
 *
 * void osd_sound_enable(int enable)
 *      TEhfoCXւ̏o͂EȂݒ肷B
 *          enable ^Ȃo͂AUȂo͂ȂB
 *      ̊֐́AO[oϐ close_device ^̏ꍇ̂݁AĂяoB
 *          j[[hɓۂɁAUƂČĂяoB
 *          j[[hoۂɁA^ƂČĂяoB
 *      ̊֐́AȔꍇɁATEhfoCX (close) A
 *      ^̏ꍇɊm (open) 悤Ȏ҂Ă邪ATEhfoCX
 *      펞mۂ܂܂ɂ悤Ȏł΁A_~[̊֐ł悢B
 *      ȂATEhfoCXւ̏o͂Ȃ̏ꍇ osd_update_audio_stream() 
 *      Ȃǂ̊֐͌ĂяoB
 *
 *****************************************************************************/

/******************************************************************************
 * ʐ
 *
 * void osd_set_mastervolume(int attenuation)
 *      TEhfoCX̉ʂݒ肷B attenuation  ʂŁA -32`0 
 *      (Pʂ db)B ʕύX̂łȂfoCXł΁A_~[ł悢B
 *
 * int osd_get_mastervolume(void)
 *      ݂̃TEhfoCX̉ʂ擾B ߒl -32`0 (Pʂ db)B
 *      ʕύX̂łȂfoCXł΁A_~[ł悢B
 *
 *****************************************************************************/

static int sound_samples_per_frame = 0;


// C string <> Pascal string conversion
static void CopyCStringToPascal(const char *src, unsigned char *dst)
{
	int num = 0;
	int i;
	const char *srcBak = src;

	while (*(src++) != '\0') {
		num++;
	}
	src = srcBak;
	dst[0] = num;
	for (i=0; i<num; i++) {
		dst[i+1]=*(src++);
	}
}
static void CopyPascalStringToC(const unsigned char *src, char *dst)
{
	int i;
	for (i=0; i < src[0]; i++) {
		*(dst++) = src[i+1];
	}
	*(dst) = '\0';
}



// constants
enum
{
	kSoundStreamFramesAt44kHz	= 12288*1,
	kTotalSoundBuffers			= 2,
	kQueuedSoundBuffers			= 2
};

// our buffered data
static SInt16	sSoundStream[kSoundStreamFramesAt44kHz * 2];
static UInt32	sSoundStreamFrames;
static UInt32	sSoundIn;
static UInt32	sSoundOut;

// the sound channel
static SndChannelPtr sSoundChannel;

// sound timing
ComponentInstance 	gSoundClock;

// sound buffer parameters
static UInt32			sSoundBufferFrames;
static UInt32			sSoundBufferBytes;
static Boolean			sSoundIsPaused;

// sound buffers
static SndCallBackUPP	sSoundCallback;
static ExtSoundHeader	*sSoundBuffer[kTotalSoundBuffers];
static SndCommand		sSoundBufferCmd[kTotalSoundBuffers];
static SndCommand		sSoundCallbackCmd[kTotalSoundBuffers];

static int				sNumOfChannles = 2;

// function prototypes
static pascal void SoundCallback(SndChannelPtr inChannel, SndCommand *inCommand);
static void FillSoundBuffer(SInt16 *inBuffer);
static Boolean InitializeSoundChannel(void);
static Boolean InitializeSoundBuffers(void);
static void FreeSoundBuffers(void);

//#pragma segment SegMain

static void memcpyW(register void *dst, register void *src, register unsigned long num)
{
	register int i;
	if (num&1) {
		for (i = 0; i < num; i++)
			*(((short *)dst)++) = *(((short *)src)++);
	} else {
		for (i = 0; i < num>>1; i++)
			*(((long *)dst)++) = *(((long *)src)++);
	}
}

// examine whether the sSoundStreamFrames is full or not
static Boolean isFullSoundStream(int dataNum)
{
	UInt32		soundIn = sSoundIn;
	Boolean		updateOk = false;

	// check	
	if (soundIn < sSoundOut) {
		if ((soundIn + dataNum) <= sSoundOut) updateOk = true;
	} else if ((soundIn + dataNum) > sSoundStreamFrames) {
		if ((soundIn + dataNum - sSoundStreamFrames) <= sSoundOut) updateOk = true;
	} else updateOk = true;
	if (!updateOk) return true;
	else return false;
}

// examine whether the sSoundStreamFrames will be empty soon or not
static Boolean isLessSoundStream(int dataNum, long tick)
{
	Boolean		updateOk = false;

	// check	
	if (sSoundOut < sSoundIn) {
		return sSoundIn - sSoundOut <= dataNum*tick;
	} else if (sSoundIn < sSoundOut) {
		return sSoundIn - (sSoundOut - sSoundStreamFrames) <= dataNum*tick;
	} else return true;
}

//#pragma segment SegInit

// start the audio system going
int osd_start_audio_stream(int stereo)
{
	CHANNELS = (stereo) ? 2 : 1;

	if (Machine->sample_rate < 8000) {
		Machine->sample_rate = 8000;
	} else if (Machine->sample_rate > 44100) {
		Machine->sample_rate = 44100;
	}

#ifdef	XMAME_SNDDRV_071

#if 0
	sound_samples_per_frame = (int)(Machine->sample_rate /
         Machine->drv->frames_per_second);
#else
	sound_samples_per_frame = (int)(Machine->sample_rate / REFRESH_RATE);
#endif

#else	/* ver 0.106 */

#if 0
	sound_samples_per_frame = Machine->sample_rate / Machine->refresh_rate;
#else
	sound_samples_per_frame = (int)(Machine->sample_rate / REFRESH_RATE);
#endif

#endif


	if (use_audiodevice == FALSE) { return sound_samples_per_frame; }

	if (alreadyInit) return sound_samples_per_frame;
	alreadyInit = true;

	InitializeSound();

	////////
	sSoundIsPaused = false;
	
	// reset the sound buffer
	sSoundIn = sSoundOut = 0;
	sSoundStreamFrames = kSoundStreamFramesAt44kHz * CHANNELS * Machine->sample_rate / 44100;

	// pick the appropriate sound buffer size
	sSoundBufferFrames = 512 * Machine->sample_rate / 44100;
	sSoundBufferBytes = sSoundBufferFrames << CHANNELS;
	
	// allocate the sound channel and initialize the buffering
	if (!InitializeSoundBuffers())
	{
		return 0;
	}
	
	// set the initial volume (-0 dB)
	osd_set_mastervolume(attenuation);
	////////

	osd_sound_enable(1);

	return sound_samples_per_frame;
}

//#pragma segment SegMain

// pushes data into the audio stream
int osd_update_audio_stream(INT16 *buffer)
{
	register UInt32	soundIn = sSoundIn;
	register UInt32	framesToCopy;
	int dataNum;
	INT16 *bufferX;

	static long prevTick = 0;
	register int times;

	if (use_audiodevice == FALSE) { return sound_samples_per_frame; }

#if 1
	{
		register long tick = TickCount() - prevTick;
		if (tick > 4) tick = 4;
		prevTick = TickCount();

		if (isFullSoundStream(sound_samples_per_frame * CHANNELS)) return sound_samples_per_frame;
		times = isLessSoundStream(sound_samples_per_frame * CHANNELS, tick+1) ? (tick+1) : 1;
	}
#else
	times = 1;
#endif

	for (; times; times--) {

		bufferX = buffer;
		dataNum = sound_samples_per_frame * CHANNELS;

		// copy up to the end of the stream buffer
		while (dataNum > 0)
		{
			// determine how many frames we can copy
			framesToCopy = sSoundStreamFrames - soundIn;
			if (framesToCopy > dataNum)
				framesToCopy = dataNum;

			// copy and count the samples
			memcpyW(&sSoundStream[soundIn], bufferX, framesToCopy);
			dataNum -= framesToCopy;
			bufferX += framesToCopy;

			// adjust the output pointer
			soundIn += framesToCopy;
			if (soundIn >= sSoundStreamFrames)
				soundIn -= sSoundStreamFrames;
		}
	}
	sSoundIn = soundIn;

	/* return the samples to play this next frame */
	return sound_samples_per_frame;
}

void osd_stop_audio_stream(void)
{
	if (use_audiodevice == FALSE) { return; }

	if (!alreadyInit) return;
	alreadyInit = false;

	osd_sound_enable(0);
	TearDownSound();
}

void osd_update_video_and_audio(void)
{
	/* nothing */
}

void osd_sound_enable(int enable_it)
{
	if (use_audiodevice == FALSE) { return; }

	PauseSound(!enable_it);
}

//#pragma segment SegInit

//	sets the main volume ( -Attenuation dB )
static int now_attenuation = 0;
void osd_set_mastervolume(int attenuation)
{
	float multiplier = 1.0;
	UInt32 volume;

	if (use_audiodevice == FALSE) { return; }

	now_attenuation = attenuation;

	// compute a multiplier from the original volume
	while (attenuation++ < 0)
		multiplier *= 1.0 / 1.122018454;	// = (10 ^ (1/20)) = 1dB

	// apply it
	volume = (UInt32)(multiplier * 0x100);
	if (volume > 0x100) volume = 0x100;

	{
		SndCommand mySndCmd;
		//OSErr myErr;

		mySndCmd.cmd = volumeCmd;
		mySndCmd.param1 = 0;		// unused with volumeCmd
		mySndCmd.param2 = (volume << 16) | volume;
		SndDoCommand(sSoundChannel, &mySndCmd, false);
	}
}

int osd_get_mastervolume (void)
{
	if (use_audiodevice == FALSE) { return -32; }

	return now_attenuation;
}

// allocates a sound channel and starts it running
// first this must be called ?
static Boolean InitializeSound(void)
{
	SndCommand 		command;
	OSErr			err;
	
	// attempt to initialize the sound buffers
	if (!InitializeSoundChannel()) return false;

	// nuke any existing clock references
	gSoundClock = NULL;

	// first turn on the clock
	command.cmd = clockComponentCmd;
	command.param1 = true;
	err = SndDoImmediate(sSoundChannel, &command);
	if (err != noErr)
		return false;
		
	// then get a component instance
	command.cmd = getClockComponentCmd;
	command.param2 = (SInt32)&gSoundClock;
	err = SndDoImmediate(sSoundChannel, &command);
	if (err != noErr)
	{
		sSoundChannel = NULL;
		return false;
	}
	return true;
}

// tearDownSound
static void TearDownSound(void)
{
	// free the channel
	if (sSoundChannel != NULL)
		SndDisposeChannel(sSoundChannel, true);
	sSoundChannel = NULL;

	// attempt to free the sound buffers
	FreeSoundBuffers();
}

// pauses/resumes sound output
static void PauseSound(Boolean inPause)
{
	sSoundIsPaused = inPause;
}

//#pragma segment SegMain

// common code to fill a sound buffer.
// called from call back
static void FillSoundBuffer(register SInt16 *inBuffer)
{
	register SInt32		framesAvailable;
	register UInt32		framesToCopy;

	if (sSoundIsPaused) {
		memset(inBuffer, 0, sSoundBufferFrames << CHANNELS);
		return;
	}
	
#if 1
	{
		static UInt16 skipCounter = 0;

		if (sSoundIn == sSoundOut) {
			if (skipCounter > 20) {
				memset(inBuffer, 0, sSoundBufferFrames << CHANNELS);
				return;
			}
			skipCounter ++;
		} else {
			skipCounter = 0;
		}
	}
#endif

	framesAvailable = sSoundIn - sSoundOut;

	// account for the circular buffer
	if (framesAvailable < 0)
		framesAvailable += sSoundStreamFrames;

	// if we have more than enough data, clip to the maximum per buffer
	if (framesAvailable >= sSoundBufferFrames * CHANNELS)
		framesAvailable = sSoundBufferFrames * CHANNELS;

	// copy up to the end of the stream buffer
	while (framesAvailable > 0)
	{
		// determine how many frames we can copy
		framesToCopy = sSoundStreamFrames - sSoundOut;
		if (framesToCopy > framesAvailable)
			framesToCopy = framesAvailable;

		// copy and count the samples
		memcpyW(inBuffer, &sSoundStream[sSoundOut], framesToCopy);
		
		framesAvailable -= framesToCopy;
		inBuffer += framesToCopy;

		// adjust the output pointer
		sSoundOut += framesToCopy;

		// wrap the output pointer
		if (sSoundOut >= sSoundStreamFrames)
			sSoundOut -= sSoundStreamFrames;
	}
}

//#pragma segment SegInit

// initialize the sound channel and any other one-shot data
static Boolean InitializeSoundChannel(void)
{
	OSErr err;
	long initOptions;

	// allocate a UPP callback
	sSoundCallback = NewSndCallBackUPP(SoundCallback);
	
	// now allocate the channel
	sSoundChannel = NULL;

    if (CHANNELS == 1) {
		initOptions = initMono   + initNoInterp + initNoDrop;
	} else {
		initOptions = initStereo + initNoInterp + initNoDrop;
	}
	err = SndNewChannel(&sSoundChannel, sampledSynth, initOptions, sSoundCallback);
	return (err == noErr);
}

// initialize the sound buffers and create the sound channel
static Boolean InitializeSoundBuffers(void)
{
	extended80 extFreq;
	int i;
	OSErr err;
	Handle itlHandle;               // The 'itl4' resource handle
	long offset, length;            // Offset-length of parts table
	NumFormatStringRec myFormatRec; // Canonical format record
	Str15 pRate;
	char cRate[16];
	
	sprintf(cRate, "%5d", Machine->sample_rate); 
	CopyCStringToPascal(cRate, pRate);
	GetIntlResourceTable (smCurrentScript, smNumberPartsTable, &itlHandle, &offset, &length);
	StringToFormatRec ("\p#####", (NumberParts *)(*itlHandle + offset), &myFormatRec);
	StringToExtended (pRate, &myFormatRec, (NumberParts *)(*itlHandle + offset), &extFreq);

	for (i = 0; i < kTotalSoundBuffers; i++)
	{
		// allocate and clear the sound buffer
		sSoundBuffer[i] = malloc(sizeof(ExtSoundHeader) + sSoundBufferBytes);
		// R. Nabet 0001212 : added error handling
		if (sSoundBuffer[i] == NULL)
		{
			while (--i >= 0)
				free(sSoundBuffer[i]);
			return false;
		}
		memset(sSoundBuffer[i], 0, sizeof(ExtSoundHeader) + sSoundBufferBytes);
		
		// intialize the buffer structures
		sSoundBuffer[i]->numChannels 	= CHANNELS;
		sSoundBuffer[i]->sampleRate 	= (UInt32)Machine->sample_rate << 16;
		sSoundBuffer[i]->encode 		= extSH;
		sSoundBuffer[i]->numFrames 		= sSoundBufferFrames;
		sSoundBuffer[i]->AIFFSampleRate = extFreq;
		sSoundBuffer[i]->sampleSize 	= 16;
		
		// initialize the sound commands
		sSoundBufferCmd[i].cmd 			= bufferCmd;
		sSoundBufferCmd[i].param2 		= (SInt32)sSoundBuffer[i];
		sSoundCallbackCmd[i].cmd 		= callBackCmd;
		sSoundCallbackCmd[i].param1 	= (i + kQueuedSoundBuffers) % kTotalSoundBuffers;
	}
	
	// start stuff playing
	for (i = 0; i < kQueuedSoundBuffers; i++)
	{
		err = SndDoCommand(sSoundChannel, &sSoundBufferCmd[i], true);
		if (err != noErr)
			return false;
		err = SndDoCommand(sSoundChannel, &sSoundCallbackCmd[i], true);
		if (err != noErr)
			return false;
	}
	return true;
}

// free the sound buffers and the sound channel
static void FreeSoundBuffers(void)
{
	UInt32 i;
	
	// free the buffers
	for (i = 0; i < kTotalSoundBuffers; i++)
	{
		if (sSoundBuffer[i] != NULL)
			free(sSoundBuffer[i]);
		sSoundBuffer[i] = NULL;
	}
}

//#pragma segment SegMain

// Callback command to stream data
static pascal void SoundCallback(SndChannelPtr inChannel, SndCommand *inCommand)
{
	UInt32		bufferIndex = inCommand->param1;

	// fill the sound buffer
	FillSoundBuffer((SInt16 *)sSoundBuffer[bufferIndex]->sampleArea);

	// queue up the commands

	SndDoCommand(sSoundChannel, &sSoundBufferCmd[bufferIndex], true);
	SndDoCommand(sSoundChannel, &sSoundCallbackCmd[bufferIndex], true);
}

#endif		/* USE_SOUND */
