/************************************************************************/
/*									*/
/*				QUASI88					*/
/*									*/
/************************************************************************/

/*----------------------------------------------------------------------*
 * Classico[W̃\[XR[h̑啔́A                          *
 * Koichi NISHIDA  Classic iP6 PC-6001/mk2/6601 emulator ̃\[X *
 * QlɂĂ܂B                                         *
 *                                                   (c) Koichi NISHIDA *
 *----------------------------------------------------------------------*/

#include "quasi88.h"
#include "device.h"

#include "getconf.h"	/* config_init */
#include "keyboard.h"	/* romaji_type */
#include "suspend.h"	/* stateload_system */
#include "menu.h"	/* menu_about_osd_msg */

#include "intr.h"
#include "screen.h"


/***********************************************************************
 * IvV
 ************************************************************************/
static	int	invalid_arg;
static	const	T_CONFIG_TABLE classic_options[] =
{
  /* 300`349: VXeˑIvV */

  /*  -- GRAPHIC -- */
  { 300, "8bpp",         X_FIX,  &mac_8bpp,        TRUE,                  0,0, 0        },
  { 300, "15bpp",        X_FIX,  &mac_8bpp,        FALSE,                 0,0, 0        },
  { 300, "16bpp",        X_FIX,  &mac_8bpp,        FALSE,                 0,0, 0        },

  /*  --  -- (VXëIvV) */
  {   0, "cmap",         X_INV,  &invalid_arg,                          0,0,0, 0        },
  {   0, "keyboard",     X_INV,  &invalid_arg,                          0,0,0, 0        },
  {   0, "keyconf",      X_INV,  &invalid_arg,                          0,0,0, 0        },
  {   0, "sleepparm",    X_INT,  &invalid_arg,                          0,0,0, 0        },
  {   0, "videodrv",     X_INV,  &invalid_arg,                          0,0,0, 0        },
  {   0, "audiodrv",     X_INV,  &invalid_arg,                          0,0,0, 0        },

  /* I[ */
  {   0, NULL,           X_INV,                                       0,0,0,0, 0        },
};



/***********************************************************************
 * C
 ************************************************************************/
static	void	finish(void);

int	main(void)
{
    /* ֘A̐ݒ */

    /* gX^bÑTCYw        ǂꂾmۂׂȂ́H	*/
    SetApplLimit(GetApplLimit() - 65536*2);	/* X^bNTCYg	*/
    MaxApplZone();				/* q[v̈g	*/
    MoreMasters();				/* Ȃ̂܂ȂH	*/



    /* ꕔ̏l (͂Ȃȁc) */
    romaji_type = 1;			/* [}ϊ̋K MS-IME */


    if (config_init(0, NULL,		/*  &  */
		    classic_options,
		    NULL)) {

	mac_init();			/* CLASSIC֘Ȁ */

	{   /* CLASSICɍœK(H) ȐݒlɏĂ */
	    vsync_freq_hz  = 60.0;  /* Ԍo߂̌v1/60bPʌŒȂ̂ */
	    file_coding = 1;        /* SJISŒ */
	}

	quasi88_atexit(finish);		/* quasi88() sɋIۂ
					   R[obN֐o^ */
	quasi88();			/* PC-8801 G~[V */

	mac_exit();			/* CLASSIC֘An */

	config_exit();			/* n */
    }

    return 0;
}



/*
 * ĨR[obN֐ (quasi88_exit()ďoɁA)
 */
static	void	finish(void)
{
    mac_exit();				/* CLASSIC֘An */
    config_exit();			/* n */
}








/***********************************************************************
 * Xe[g[h^Xe[gZ[u
 ************************************************************************/

/*	̏񂷂ׂĂ[h or Z[uꂽɌĂяoB
 *	KvɉāAVXeŗL̏tĂƁB
 */

int	stateload_system( void )
{
  return TRUE;
}
int	statesave_system( void )
{
  return TRUE;
}



/***********************************************************************
 * j[ʂɕ\AVXeŗLbZ[W
 ************************************************************************/

int	menu_about_osd_msg(int        req_japanese,
			   int        *result_code,
			   const char *message[])
{
    static const char *about_en =
    {
	"Mouse and joystick are not supported.\n"
	"\n"
	"Many many menu items are not available.\n"
    };

    static const char *about_jp =
    {
	"xɊւݒ͕ύXł܂\n"
	"}EXAWCXeBbN͎gpł܂\n"
	"}EXJ[\̕\̓T|[gĂ܂\n"
	"\tgEFA NumLock ̓T|[gĂ܂\n"
	"L[ݒt@C̓ǂݍ݂̓T|[gĂ܂\n"
    };


    *result_code = -1;				/* R[hwȂ */

    if (req_japanese == FALSE) {
	*message = about_en;
    } else {
	*message = about_jp;
    }

    return TRUE;
}
