#ifndef INITVAL_H_INCLUDED
#define INITVAL_H_INCLUDED


/*----------------------------------------------------------------------*/
/* 萔									*/
/*----------------------------------------------------------------------*/
#define	CONST_4MHZ_CLOCK	(3.9936)
#define	CONST_8MHZ_CLOCK	(CONST_4MHZ_CLOCK*2.0)
#define	CONST_VSYNC_FREQ	(55.4)


/*----------------------------------------------------------------------*/
/* N̏ݒl							*/
/*----------------------------------------------------------------------*/

enum BasicMode { BASIC_AUTO=-1, BASIC_N,    BASIC_V1S,  BASIC_V1H,  BASIC_V2 };
enum CpuClock  {                CLOCK_8MHZ, CLOCK_4MHZ  };
enum BootDevice{ BOOT_AUTO =-1, BOOT_DISK,  BOOT_ROM    };
enum SoundBoard{                SOUND_I,    SOUND_II    };
enum JishoRom  {                NOT_JISHO,  EXIST_JISHO };
enum MenuLang  {                MENU_ENGLISH, MENU_JAPAN };
enum BaudRate  { BAUDRATE_75,   BAUDRATE_150,   BAUDRATE_300,  BAUDRATE_600,
		 BAUDRATE_1200, BAUDRATE_2400,  BAUDRATE_4800, BAUDRATE_9600,
		 BAUDRATE_19200 };


/* DEFAULT_BASIC    BASIC [h       -1: / 0:N / 1:V1S / 2:V1H / 3:V2  */
/* DEFAULT_CLOCK    CPUNbN        -1: / 0:8MHz / 1:4MHz             */
/* DEFAULT_BOOT     NfoCX       -1: / 0:DISK / 1:ROM              */
/* DEFAULT_EXTRAM   gRAM             0:Ȃ / 1`4:(J[h)         */
/* DEFAULT_JISHO    ROM             0:Ȃ / 1:                      */
/* DEFAULT_SOUND    TEh{[h      0: / 1:TEh{[hII      */
/* DEFAULT_DIPSW    fBbvXCb`   16bitlw                         */
/* DEFAULT_BAUDRATE {[[g         BADU_RATE_75 ` BADU_RATE_19200w */

/* DEFAULT_VERBOSE         -verbose   ̏l */
/* DEFAULT_FRAMESKIP       -frameskip ̏l */
/* DEFAULT_CPU             -cpu       ̏l */


#define	DEFAULT_BASIC		( BASIC_AUTO )
#define	DEFAULT_CLOCK		( CLOCK_4MHZ )
#define	DEFAULT_BOOT		( BOOT_AUTO  )
#define	DEFAULT_SOUND		( SOUND_I    )
#define	DEFAULT_JISHO		( NOT_JISHO  )
#define	DEFAULT_EXTRAM		( 0 )
#define	DEFAULT_DIPSW		( 0x391a )
#define	DEFAULT_BAUDRATE	( BAUDRATE_1200 )

#define	DEFAULT_VERBOSE		(0x00)
#define	DEFAULT_FRAMESKIP	(1)
#define	DEFAULT_CPU		(0)


/*----------------------------------------------------------------------*/
/* DEFAULT_CPU_CLOCK_MHZ	C CPŨNbN     doublel [MHz] */
/* DEFAULT_SOUND_CLOCK_MHZ	TEh`bṽNbN doublel [MHz] */
/* DEFAULT_VSYNC_FREQ_HZ	VSYNC 荞݂̎     intl    [Hz]  */
/* DEFAULT_WAIT_FREQ		EGCgpg     intl    [Hz]  */

#define	DEFAULT_CPU_CLOCK_MHZ		CONST_4MHZ_CLOCK
#define	DEFAULT_SOUND_CLOCK_MHZ		CONST_4MHZ_CLOCK
#define	DEFAULT_VSYNC_FREQ_HZ		CONST_VSYNC_FREQ
#define	DEFAULT_WAIT_FREQ_HZ		CONST_VSYNC_FREQ


/*----------------------------------------------------------------------*/
/* hCu̐  t@C̃C[W̍ő吔			*/
/*	hCu̐  2ȊO̒l͖ΉBݒςȂ悤ɁII	*/
/*----------------------------------------------------------------------*/
enum {
  DRIVE_1,
  DRIVE_2,
  NR_DRIVE
};
#define	MAX_NR_IMAGE	(32)

enum {
  CLOAD,
  CSAVE,
  NR_TAPE
};

#endif		/* INITVAL_H_INCLUDED */
