#ifndef PC88MAIN_H_INCLUDED
#define PC88MAIN_H_INCLUDED

#include <stdio.h>
#include "file-op.h"


#if 0	/*  file-op.h */
extern char file_tape[2][QUASI88_MAX_FILENAME];	/* e[vo͂̃t@C */
extern char file_prn[QUASI88_MAX_FILENAME];	/* po͂̃t@C */
extern char file_sin[QUASI88_MAX_FILENAME];	/* VAo͂̃t@C */
extern char file_sout[QUASI88_MAX_FILENAME];	/* VA͂̃t@C */
#endif

	/**** u[g (I/Oɔf) ****/

extern	int	boot_basic;			/* N BASIC[h	*/
extern	int	boot_dipsw;			/* ÑfBbvݒ	*/
extern	int	boot_from_rom;			/* NfoCX̐ݒ	*/
extern	int	boot_clock_4mhz;		/* N CPUNbN	*/

extern	int	monitor_15k;			/* 15k j^[ 1:Yes 0:No  */

extern	int	high_mode;			/* [h 1:Yes 0:No     */

	/**** fBbvXCb` ****/

#define SW_1_MASK	(0x3e)
#define	SW_2_MASK	(0x3f)
#define	SW_N88		(0x01)			/* 1: N88  / 0: N	*/
#define	SW_V1		(0x80)			/* 1: V1   / 0: V2	*/
#define	SW_H		(0x40)			/* 1: H    / 0: S	*/
#define	SW_ROMBOOT	(0x08)			/* 1: ROM  / 0: DISK	*/
#define	SW_4MHZ		(0x80)			/* 1: 4MHz / 0: 8MHz	*/

	/**** h^n|[g ****/

/*extern byte	dipsw_1;			 * IN[30] fBbvXCb` 1 */
/*extern byte	dipsw_2;			 * IN[31] fBbvXCb` 2 */
/*extern byte	ctrl_boot;			 * IN[40] fBXNu[g */
/*extern byte	cpu_clock;			 * IN[6E] CPU NbN       */
extern	int	memory_bank;			/* OUT[5C-5F] IN[5C] oN  */

extern	byte	misc_ctrl;			/* I/O[32] eCtrl       */
extern	byte	ALU1_ctrl;			/* OUT[34] ALU Ctrl 1     */
extern	byte	ALU2_ctrl;			/* OUT[35] ALU Ctrl 2     */
extern	byte	ctrl_signal;			/* OUT[40] Rg[M*/
extern	byte	baudrate_sw;			/* I/O[6F] {[[g     */
extern	word	window_offset;			/* I/O[70] WINDOW ItZbg*/
extern	byte	ext_rom_bank;			/* I/O[71] gROM BANK   */
extern	byte	ext_ram_ctrl;			/* I/O[E2] gRAM	  */
extern	byte	ext_ram_bank;			/* I/O[E3] gRAMZNg*/

extern	byte	jisho_rom_bank;			/* OUT[F0] ROMZNg*/
extern	byte	jisho_rom_ctrl;			/* OUT[F1] ROMoN  */


#define	MISC_CTRL_EBANK		(0x03)		/* EROM BANK 00..11        */
#define	MISC_CTRL_AVC		(0x0c)		/* AVC                     */
#define	MISC_CTRL_TEXT_MAIN	(0x10)		/* TEXT   MAIN-RAM/HIGH-RAM*/
#define	MISC_CTRL_ANALOG	(0x20)		/* PALETTE  ANALOG/DEGITAL */
#define	MISC_CTRL_EVRAM		(0x40)		/* VRAM     EXTEND/STANDARD*/
#define INTERRUPT_MASK_SOUND	(0x80)		/* SND INT  Disable/Enable */

#define	ALU1_CTRL_BLUE		(0x11)		/* ALUΏۃv[ B   */
#define	ALU1_CTRL_RED		(0x22)		/*                     R   */
#define	ALU1_CTRL_GREEN		(0x44)		/*                     G   */

#define	ALU2_CTRL_DATA		(0x07)		/* ALUFrf[^    0..7 */
#define	ALU2_CTRL_MODE		(0x30)		/* ALU[h  00B..11B */
#define	ALU2_CTRL_VACCESS	(0x80)		/* ANZX VRAM/MAIN*/

#define	MEMORY_BANK_MAIN	(3)		/* oNw        MAIN  */
#define	MEMORY_BANK_GRAM0	(0)		/*		       B   */
#define	MEMORY_BANK_GRAM1	(1)		/*		       R   */
#define	MEMORY_BANK_GRAM2	(2)		/*		       G   */

#define	CPU_CLOCK_4HMZ		(0x80)		/* CPU CLOCK 4MHz / 8MHz   */

#define	EXT_ROM_NOT		(0x01)		/* g ROM ZNg	   */

#define INTERRUPT_MASK_RTC	(0x01)		/* 1/600 荞      */
#define INTERRUPT_MASK_VSYNC	(0x02)		/* VSYNC 荞      */
#define INTERRUPT_MASK_SIO	(0x04)		/* COM   荞      */

#define	JISHO_NOT_SELECT	(0x01)		/* ROMZNg	   */
#define	JISHO_BANK		(0x1f)		/* ROMoN	   */


	/**** J_[ ****/

extern	int	calendar_stop;			/* v~tO	*/


	/**** VAAp ****/

extern	int	cmt_speed;	/* e[vx 0Ŏ   */
extern	int	cmt_intr;	/* Ńe[v */
extern	int	cmt_wait;	/* ^ŁAe[vǍEFCg(T88̂) */


	/****  BASIC [h ****/

#define EndofBasicAddr 0xffff
#define HS_BASIC_COUNT 50000000	/* 荞݂Ȃŉ񂷃Xe[g */

extern word highspeed_routine[];

extern int highspeed_flag;
extern int highspeed_mode;	/*  BASIC  Ȃ ^      */


	/**** VA}EX ****/

extern int use_siomouse;	/* ^ŁAVA}EX	*/





	/**** ֐ ****/

void	pc88main_init( int init );
void	pc88main_term( void );
void	pc88main_bus_setup( void );
void	power_on_ram_init( void );

byte	main_mem_read( word addr );
void	main_mem_write( word addr, byte data );
byte	main_io_in( byte port );
void	main_io_out( byte port, byte data );


int	sio_open_tapeload( const char *filename );
void	sio_close_tapeload( void );
int	sio_open_tapesave( const char *filename );
void	sio_close_tapesave( void );
int	sio_open_serialin( const char *filename );
void	sio_close_serialin( void );
int	sio_open_serialout( const char *filename );
void	sio_close_serialout( void );
int	printer_open( const char *filename );
void	printer_close( void );
void	sio_mouse_init(int initial);
int	sio_tape_rewind( void );

int	sio_tape_pos( long *cur, long *end );
int	sio_com_pos( long *cur, long *end );
int	sio_intr( void );
void	sio_data_clear(void);

int	tape_exist( void );
int	tape_readable(void);
int	tape_writable(void);
int	tape_reading( void );
int	tape_writing( void );

#endif	/* PC88MAIN_H_INCLUDED */
