/************************************************************************/
/*									*/
/* PIO  								*/
/*									*/
/************************************************************************/

#include <stdio.h>

#include "quasi88.h"
#include "pio.h"

#include "pc88cpu.h"

#include "emu.h"
#include "suspend.h"


/*
  PIOANZXƁATuCPŰ쓮
	  PC88 ́A{̑ CCPUAfBXNhCu TuCPU ƁA
	2CPUĂBfBXNANZXꍇ́ACCPU 
	TuCPU  PIOoRŃR}h𑗐MAM TuCPU 
	ۂɏsāAʂCCPU ɑM悤ɂȂĂB
	܂ATuCPU̓fBXNȊO̎Ԃ͑SāACCPU 
	̃R}h̎M҂ƂƂɂȂB
	  ȏ̂ƂATuCPU펞G~[ĝ͖ʂȂ̂ŁA
	KvȎ̂݃G~[g邱ƂɂB

	  ʏACETuCPUƂʐMɂ́APIO  C|[g[hB
	ŁACCPU  C|[g[hȍ~́ATuCPU ݂̂
	쓮ATuCPU  C|[g[hȍ~́ACCPU ݂̂
	쓮悤ɂB
		(-cpu 0 IvVw肵͏L̓)

	  Aɂ C|[gɁAʐMsAvP[V
	݂B(2CPȔx̓ɈˑĂ)B̑΍ƂāA
	A/B/C |[ĝꂩɃCCPUANZX_
	(Wł 4000Xebv)ATuCPUɋ쓮B
		(-cpu 1 IvVw肵͏L̓)

	  ł܂ȂAvP[V̂ŁȂ΍ƂāA
	CCPU ƃTuCPU 펞Aɋ쓮B
		(-cpu 2 IvVw肵͏L̓)
*/

/*---------------------------------------------------------------------------*/
/* 									     */
/*					A  ######## --\/-- ######## A	     */
/*	ECg͎̃[N	B  ######## --/\-- ######## B	     */
/*	  ΂čsȂB		CH ####     --\/-- ####	    CH	     */
/*	E[h͑̃[N		CL     #### --/\--     #### CL	     */
/*	  sȂB							     */
/*	  ̃[NREADݒȂA					     */
/*	  ̃[NǂށB						     */
/*	|[gC̃[hCg͗OsȂB			     */
/*---------------------------------------------------------------------------*/


pio_work	pio_AB[2][2], pio_C[2][2];


static	z80arch	*z80[2] = { &z80main_cpu, &z80sub_cpu };




/*----------------------------------------------------------------------*/
/* PIO 								*/
/*	PA / PCL M ^ PB / PCH M					*/
/*----------------------------------------------------------------------*/
void	pio_init( void )
{
  int	side;

  for( side=0; side<2; side++ ){
    pio_AB[ side ][ PIO_PORT_A ].type    = PIO_READ;
    pio_AB[ side ][ PIO_PORT_A ].exist   = PIO_EMPTY;
/*  pio_AB[ side ][ PIO_PORT_A ].cont_f  = not used ! */
    pio_AB[ side ][ PIO_PORT_A ].data    = 0x00;

    pio_AB[ side ][ PIO_PORT_B ].type    = PIO_WRITE;
    pio_AB[ side ][ PIO_PORT_B ].exist   = PIO_EMPTY;
/*  pio_AB[ side ][ PIO_PORT_B ].cont_f  = not used ! */
    pio_AB[ side ][ PIO_PORT_B ].data    = 0x00;

    pio_C[ side ][ PIO_PORT_CH ].type    = PIO_WRITE;
    pio_C[ side ][ PIO_PORT_CH ].cont_f  = 1;
    pio_C[ side ][ PIO_PORT_CH ].data    = 0x00;

    pio_C[ side ][ PIO_PORT_CL ].type    = PIO_READ;
    pio_C[ side ][ PIO_PORT_CL ].cont_f  = 1;
    pio_C[ side ][ PIO_PORT_CL ].data    = 0x00;
  }

}


/* verbose w莞̃bZ[W\}N					*/

#define	pio_mesAB( s )							\
	if( verbose_pio )						\
	  printf( s " : side = %s : port = %s\n",			\
		 (side==PIO_SIDE_M)?"M":"S", (port==PIO_PORT_A)?"A":"B" )

#define	pio_mesC( s )							\
	if( verbose_pio )						\
	  printf( s " : side = %s\n",					\
		 (side==PIO_SIDE_M)?"M":"S" )

/*----------------------------------------------------------------------*/
/* PIO A or B 烊[h						*/
/*	[h̍ۂ̃f[^́Ȃ^t̃|[gǂݏoB	*/
/*		̃|[g̐ݒ肪  READ ȂG[\		*/
/*		̃|[g̐ݒ肪 WRITE ȂG[\		*/
/*		A[h̍ۂ́AJE^JEg_EB	*/
/*			JE^ 0 Ȃ߂āAA[hB	*/
/*			JE^ 1 ȏȂACPU ؑւB		*/
/*----------------------------------------------------------------------*/
byte	pio_read_AB( int side, int port )
{
		/* |[gsv */

  if( pio_AB[ side^1 ][ port^1 ].type == PIO_READ  ){	/* |[g READ */
    pio_mesAB( "PIO AB READ PORT Mismatch" );
  }
  if( pio_AB[ side   ][ port   ].type == PIO_WRITE ){	/* |[g WRITE*/
    pio_mesAB( "PIO Read from WRITE-PORT" );
    return (pio_AB[ side ][ port ].data);
  }
		/* ǂ݂ */

  if( pio_AB[ side^1 ][ port^1 ].exist == PIO_EXIST ){	/* -- ŏ̓ǂ݂ */

    pio_AB[ side^1 ][ port^1 ].exist   = PIO_EMPTY;

  }else{						/* -- A̓ǂ݂ */

    switch( cpu_timing ){
    case 1:						/*     1:TuCPUN */
      if( side==PIO_SIDE_M ){
	dual_cpu_count = CPU_1_COUNT;
	CPU_BREAKOFF();
      } /*No Break*/
    case 0:						/*     0:̂܂ܓǂ*/
    case 2:						/*     2:̂܂ܓǂ*/
      pio_mesAB( "PIO Read continuously" );
      break;
    }

  }
  return (pio_AB[ side^1 ][ port^1 ].data);
}


/*----------------------------------------------------------------------*/
/* PIO A or B ɃCg							*/
/*	CǵȂ^̃|[gɑ΂čsȂB		*/
/*		̃|[g̐ݒ肪 WRITE ȂG[\		*/
/*		̃|[g̐ݒ肪  READ ȂG[\		*/
/*		ACg̍ۂ́AJE^JEg_EB	*/
/*			JE^ 0 Ȃ߂āAACgB	*/
/*			JE^ 1 ȏȂACPU ؑւB		*/
/*----------------------------------------------------------------------*/
void	pio_write_AB( int side, int port, byte data )
{
		/* |[gsv */

  if( pio_AB[ side^1 ][ port^1 ].type == PIO_WRITE ){	/* ̃|[g WRITE*/
    pio_mesAB( "PIO AB Write PORT Mismatch" );
  }
  if( pio_AB[ side   ][ port   ].type == PIO_READ ){	/* ̃|[g READ */
    pio_mesAB( "PIO Write to READ-PORT" );
  }
		/*  */

  if( pio_AB[ side ][ port ].exist == PIO_EMPTY ){	/* -- ŏ̏ */

    pio_AB[ side ][ port ].exist   = PIO_EXIST;
    pio_AB[ side ][ port ].data    = data;

  }else{						/* -- Ȁ */

    switch( cpu_timing ){
    case 1:						/*     1:TuCPUN */
      if( side==PIO_SIDE_M ){
	dual_cpu_count = CPU_1_COUNT;
	CPU_BREAKOFF();
      } /*No Break*/
    case 0:						/*     0:̂܂܏*/
    case 2:						/*     2:̂܂܏*/
      pio_mesAB( "PIO Write continuously" );
      pio_AB[ side ][ port ].data    = data;
      break;
    }

  }
  return;
}








/*----------------------------------------------------------------------*/
/* PIO C 烊[h							*/
/*	[h̍ۂ̃f[^́Ȃ^t̃|[gǂݏoB	*/
/*		̃|[g̐ݒ肪  READ ȂG[\		*/
/*		̃|[g̐ݒ肪 WRITE ȂG[\		*/
/*		[h̍ۂɁACPUؑւ			*/
/*----------------------------------------------------------------------*/
byte	pio_read_C( int side )
{
  byte	data;

		/* |[gsv */
  if( pio_C[ side^1 ][ PIO_PORT_CH ].type == PIO_READ  &&
      pio_C[ side^1 ][ PIO_PORT_CL ].type == PIO_READ  ){
    pio_mesC( "PIO C READ PORT Mismatch" );
  }
  if( pio_C[ side   ][ PIO_PORT_CH ].type == PIO_WRITE &&
      pio_C[ side   ][ PIO_PORT_CL ].type == PIO_WRITE ){
    pio_mesC( "PIO C Read from WRITE-PORT" );
  }
		/* [h */

  if( pio_C[ side ][ PIO_PORT_CH ].type == PIO_READ ){
    data  = pio_C[ side^1 ][ PIO_PORT_CL ].data << 4;
  }else{
    data  = pio_C[ side   ][ PIO_PORT_CH ].data << 4;
  }

  if( pio_C[ side ][ PIO_PORT_CL ].type == PIO_READ ){
    data |= pio_C[ side^1 ][ PIO_PORT_CH ].data;
  }else{
    data |= pio_C[ side   ][ PIO_PORT_CL ].data;
  }

  pio_C[ side ][ PIO_PORT_CL ].cont_f ^= 1;
  if( pio_C[ side ][ PIO_PORT_CL ].cont_f == 0 ){	/* -- A̓ǂ݂ */

    switch( cpu_timing ){
    case 0:						/*     0:CPUؑւ*/
      select_main_cpu ^= 1;
      CPU_BREAKOFF();        /* PC-=2 */
      break;
    case 1:						/*     1:TuCPUN */
      if( side==PIO_SIDE_M ){
	dual_cpu_count = CPU_1_COUNT;
	CPU_BREAKOFF();
      }
      break;
    case 2:						/*     2:ȂɂȂ*/
      break;
    }

  }

  return data;
}


/*----------------------------------------------------------------------*/
/* PIO C ɃCg							*/
/*	CǵȂ^̃|[gɑ΂čsȂB		*/
/*		̃|[g̐ݒ肪 WRITE ȂG[\		*/
/*		̃|[g̐ݒ肪  READ ȂG[\		*/
/*		Cg̍ۂɁACPUؑւ			*/
/*----------------------------------------------------------------------*/
void	pio_write_C( int side, byte data )
{
  int port;

  if( data & 0x08 ) port = PIO_PORT_CH;
  else              port = PIO_PORT_CL;
  data &= 0x07;

		/* |[gsv */

  if( pio_C[ side^1 ][ port^1 ].type == PIO_WRITE ){	/* ̃|[g WRITE*/
    pio_mesC( "PIO C Write PORT Mismatch" );
  }
  if( pio_C[ side   ][ port   ].type == PIO_READ ){	/* ̃|[g READ */
    pio_mesC( "PIO C Write to READ-PORT" );
  }
		/* Cg */

  if( data & 0x01 ) pio_C[ side ][ port ].data |=  ( 1 << (data>>1) );
  else              pio_C[ side ][ port ].data &= ~( 1 << (data>>1) );

  switch( cpu_timing ){
  case 0:						/*     0:̂܂܏*/
  case 2:						/*     2:̂܂܏*/
    break;
  case 1:						/*     1:TuCPUN */
    if( side==PIO_SIDE_M ){
      dual_cpu_count = CPU_1_COUNT;
      CPU_BREAKOFF();
    }
    break;
  }
  return;
}


/*--------------------------------------------------------------*/
/*  Port C ɏ					*/
/*--------------------------------------------------------------*/
void	pio_write_C_direct( int side, byte data )
{
		/* |[gsv */
  if( pio_C[ side^1 ][ PIO_PORT_CH ].type == PIO_WRITE &&
      pio_C[ side^1 ][ PIO_PORT_CL ].type == PIO_WRITE ){
    pio_mesC( "PIO C WRITE PORT Mismatch" );
  }
  if( pio_C[ side   ][ PIO_PORT_CH ].type == PIO_READ  &&
      pio_C[ side   ][ PIO_PORT_CL ].type == PIO_READ  ){
    pio_mesC( "PIO C Write to READ-PORT" );
  }
		/* Cg */

  pio_C[ side ][ PIO_PORT_CH ].data = data >> 4;
  pio_C[ side ][ PIO_PORT_CL ].data = data & 0x0f;

  switch( cpu_timing ){
  case 0:						/*     0:̂܂܏*/
  case 2:						/*     2:̂܂܏*/
    break;
  case 1:						/*     1:TuCPUN */
    if( side==PIO_SIDE_M ){
      dual_cpu_count = CPU_1_COUNT;
      CPU_BREAKOFF();
    }
    break;
  }
  return;
}







/*----------------------------------------------------------------------*/
/* PIO ݒ								*/
/*	PA / PB / PCH / PCL ̑MwB				*/
/*	[hݒ ([h 0 ɌBڍוs)			*/
/*----------------------------------------------------------------------*/
void	pio_set_mode( int side, byte data )
{
  if( data & 0x60 ){
    if( verbose_pio )
      printf("PIO mode A & CH not 0 : side = %s : mode = %d\n",
	     (side!=PIO_SIDE_M)?"M":"S", (data>>5)&0x3 );
  }
	/* PIO A */

  if( data & 0x10 ){
    pio_AB[ side ][ PIO_PORT_A ].type  = PIO_READ;
  }else{
    pio_AB[ side ][ PIO_PORT_A ].type   = PIO_WRITE;
  }
  pio_AB[ side ][ PIO_PORT_A ].data    = 0;
  pio_AB[ side ][ PIO_PORT_A ].exist   = PIO_EMPTY;

	/* PIO C-H */

  if( data & 0x08 ){
    pio_C[ side ][ PIO_PORT_CH ].type  = PIO_READ;
  }else{
    pio_C[ side ][ PIO_PORT_CH ].type  = PIO_WRITE;
  }
  pio_C[ side ][ PIO_PORT_CH ].data    = 0;
  pio_C[ side ][ PIO_PORT_CH ].cont_f  = 1;

  if( data & 0x04 ){
    if( verbose_pio )
      printf("PIO mode B & CL not 0 : side = %s : mode = %d\n",
	     (side!=PIO_SIDE_M)?"M":"S", (data>>2)&0x1 );
  }
	/* PIO B */

  if( data & 0x02 ){
    pio_AB[ side ][ PIO_PORT_B ].type  = PIO_READ;
  }else{
    pio_AB[ side ][ PIO_PORT_B ].type  = PIO_WRITE;
  }
  pio_AB[ side ][ PIO_PORT_B ].data    = 0;
  pio_AB[ side ][ PIO_PORT_B ].exist   = PIO_EMPTY;

	/* PIO C-L */

  if( data & 0x01 ){
    pio_C[ side ][ PIO_PORT_CL ].type  = PIO_READ;
  }else{
    pio_C[ side ][ PIO_PORT_CL ].type  = PIO_WRITE;
  }
  pio_C[ side ][ PIO_PORT_CL ].data    = 0;
  pio_C[ side ][ PIO_PORT_CL ].cont_f  = 1;

}






/***********************************************************************
 * Xe[g[h^Xe[gZ[u
 ************************************************************************/

#define	SID	"PIO "

static	T_SUSPEND_W	suspend_pio_work[]=
{
  { TYPE_INT,	&pio_AB[0][0].type,	},
  { TYPE_INT,	&pio_AB[0][0].exist,	},
  { TYPE_INT,	&pio_AB[0][0].cont_f,	},
  { TYPE_BYTE,	&pio_AB[0][0].data,	},

  { TYPE_INT,	&pio_AB[0][1].type,	},
  { TYPE_INT,	&pio_AB[0][1].exist,	},
  { TYPE_INT,	&pio_AB[0][1].cont_f,	},
  { TYPE_BYTE,	&pio_AB[0][1].data,	},

  { TYPE_INT,	&pio_AB[1][0].type,	},
  { TYPE_INT,	&pio_AB[1][0].exist,	},
  { TYPE_INT,	&pio_AB[1][0].cont_f,	},
  { TYPE_BYTE,	&pio_AB[1][0].data,	},

  { TYPE_INT,	&pio_AB[1][1].type,	},
  { TYPE_INT,	&pio_AB[1][1].exist,	},
  { TYPE_INT,	&pio_AB[1][1].cont_f,	},
  { TYPE_BYTE,	&pio_AB[1][1].data,	},

  { TYPE_INT,	&pio_C[0][0].type,	},
  { TYPE_INT,	&pio_C[0][0].exist,	},
  { TYPE_INT,	&pio_C[0][0].cont_f,	},
  { TYPE_BYTE,	&pio_C[0][0].data,	},

  { TYPE_INT,	&pio_C[0][1].type,	},
  { TYPE_INT,	&pio_C[0][1].exist,	},
  { TYPE_INT,	&pio_C[0][1].cont_f,	},
  { TYPE_BYTE,	&pio_C[0][1].data,	},

  { TYPE_INT,	&pio_C[1][0].type,	},
  { TYPE_INT,	&pio_C[1][0].exist,	},
  { TYPE_INT,	&pio_C[1][0].cont_f,	},
  { TYPE_BYTE,	&pio_C[1][0].data,	},

  { TYPE_INT,	&pio_C[1][1].type,	},
  { TYPE_INT,	&pio_C[1][1].exist,	},
  { TYPE_INT,	&pio_C[1][1].cont_f,	},
  { TYPE_BYTE,	&pio_C[1][1].data,	},

  { TYPE_END,	0			},
};


int	statesave_pio( void )
{
  if( statesave_table( SID, suspend_pio_work ) == STATE_OK ) return TRUE;
  else                                                       return FALSE;
}

int	stateload_pio( void )
{
  if( stateload_table( SID, suspend_pio_work ) == STATE_OK ) return TRUE;
  else                                                       return FALSE;
}
