#ifndef SCREEN_H_INCLUDED
#define SCREEN_H_INCLUDED



typedef struct {
    unsigned	char	blue;			/* BʋPx (0`7/255)	*/
    unsigned	char	red;			/* RʋPx (0`7/255)	*/
    unsigned 	char	green;			/* GʋPx (0`7/255)	*/
    unsigned 	char	padding;
} PC88_PALETTE_T;


/*
 *	PC-88 Related
 */

extern	PC88_PALETTE_T	vram_bg_palette;	/* wipbg	*/
extern	PC88_PALETTE_T	vram_palette[8];	/* epbg	*/

extern	byte	sys_ctrl;			/* OUT[30] SystemCtrl     */
extern	byte	grph_ctrl;			/* OUT[31] GraphCtrl      */
extern	byte	grph_pile;			/* OUT[53] dˍ킹     */

#define	SYS_CTRL_80		(0x01)		/* TEXT COLUMN80 / COLUMN40*/
#define	SYS_CTRL_MONO		(0x02)		/* TEXT MONO     / COLOR   */

#define	GRPH_CTRL_200		(0x01)		/* VRAM-MONO 200 / 400 line*/
#define	GRPH_CTRL_64RAM		(0x02)		/* RAM   64K-RAM / ROM-RAM */
#define	GRPH_CTRL_N		(0x04)		/* BASIC       N / N88     */
#define GRPH_CTRL_VDISP		(0x08)		/* VRAM  DISPLAY / UNDISP  */
#define GRPH_CTRL_COLOR		(0x10)		/* VRAM  COLOR   / MONO    */
#define	GRPH_CTRL_25		(0x20)		/* TEXT  LINE25  / LINE20  */

#define	GRPH_PILE_TEXT		(0x01)		/* dˍ킹 \ TEXT  */
#define	GRPH_PILE_BLUE		(0x02)		/*		       B   */
#define	GRPH_PILE_RED		(0x04)		/*		       R   */
#define	GRPH_PILE_GREEN		(0x08)		/*		       G   */



/*
 *	`揈p[N
 */

	/* `捷Ǘ */

extern	char	screen_dirty_flag[ 0x4000*2 ];	/* C̈ XV	*/
extern	int	screen_dirty_all;		/* C̈ SXV	*/
extern	int	screen_dirty_palette;		/* F XV		*/
extern	int	screen_dirty_status;		/* Xe[^Ẍ XV	*/
extern	int	screen_dirty_status_hide;	/* Xe[^Ẍ 	*/
extern	int	screen_dirty_status_show;	/* Xe[^Ẍ */
extern	int	screen_dirty_frame;		/* S̈ XV		*/

#define	screen_set_dirty_flag(x)	screen_dirty_flag[x] = 1
#define	screen_set_dirty_all()		screen_dirty_all = TRUE
#define	screen_set_dirty_palette()	do {				\
					  screen_dirty_palette = TRUE;	\
					  screen_dirty_all = TRUE;	\
					} while(0)
#define	screen_set_dirty_status()	screen_dirty_status = 0xff
#define	screen_set_dirty_status_hide()	screen_dirty_status_hide = TRUE
#define	screen_set_dirty_status_show()	screen_dirty_status_show = TRUE
#define	screen_set_dirty_frame()	screen_dirty_frame = TRUE;


	/* ̑ */

extern	int	frameskip_rate;		/* ʕ\̍XVԊu		*/
extern	int	monitor_analog;		/* AiOj^[		*/
extern	int	use_auto_skip;		/* t[XLbv		*/



/*
 *	\ݒ
 */

enum {
    SCREEN_INTERLACE_NO = 0,		/* C^[X\Ȃ	*/
    SCREEN_INTERLACE_YES = 1,		/* C^[X\		*/
    SCREEN_INTERLACE_SKIP = -1		/* 1C\		*/
};
extern	int	use_interlace;		/* C^[[X\		*/

extern	int	use_half_interp;	/* ʃTCYAFԂ */

enum {					/* ʃTCY			*/
    SCREEN_SIZE_HALF,			/*		320 x 200	*/
    SCREEN_SIZE_FULL,			/*		640 x 400	*/
#ifdef	SUPPORT_DOUBLE
    SCREEN_SIZE_DOUBLE,			/*		1280x 800	*/
#endif
    SCREEN_SIZE_END
};
extern	int	screen_size;		/* ʃTCYw		*/

extern	int	use_fullscreen;		/* Sʕ\w		*/

extern	double	mon_aspect;		/* j^[̃AXyNg	*/

extern	int	status_fg;		/* Xe[^XOiF		*/
extern	int	status_bg;		/* Xe[^XwiF		*/

extern	int	show_status;		/* Xe[^X\L		*/


/*
 *
 */

enum {
    SHOW_MOUSE = 0,
    HIDE_MOUSE = 1,
    AUTO_MOUSE = 2
};
extern	int	hide_mouse;		/* }EXBǂ		*/
enum {
    UNGRAB_MOUSE = 0,
    GRAB_MOUSE   = 1
};
extern	int	grab_mouse;		/* Ou邩ǂ		*/

extern	int	use_swcursor;		/* j[pJ[\\H*/
extern	int	now_swcursor;		/* ݐpJ[\\?	*/


/*
 *	\foCXp[N
 */

#define	STATUS_HEIGHT	(20)

extern	int	WIDTH;			/* `obt@TCY		*/
extern	int	HEIGHT;			/* `obt@cTCY		*/
extern	int	DEPTH;			/* Frbg	(8/16/32)	*/
extern	int	SCREEN_W;		/* ʉTCY (320/640/1280)	*/
extern	int	SCREEN_H;		/* ʏcTCY (200/400/800)	*/

extern	int	SCREEN_DX;		/* EChEƁA		*/
extern	int	SCREEN_DY;		/* ʃGAƂ̃ItZbg	*/

extern	char	*screen_buf;		/* `obt@擪		*/
extern	char	*screen_start;		/* ʐ擪			*/

extern	char	*status_buf;		/* Xe[^XS 擪		*/
extern	char	*status_start[3];	/* Xe[^X` 擪		*/
extern	int	status_sx[3];		/* Xe[^X`TCY		*/
extern	int	status_sy[3];




extern	Ulong	color_pixel[16];		/* FR[h		*/
extern	Ulong	color_half_pixel[16][16];	/* F⊮̐FR[h	*/
extern	Ulong	black_pixel;			/* ̐FR[h		*/
enum {						/* Xe[^XɎgF	*/
    STATUS_BG,					/*	wiF()	*/
    STATUS_FG,					/*	OiF()	*/
    STATUS_BLACK,				/*	F		*/
    STATUS_WHITE,				/*	F		*/
    STATUS_RED,					/*	ԐF		*/
    STATUS_GREEN,				/*	ΐF		*/
    STATUS_COLOR_END
};
extern	Ulong	status_pixel[STATUS_COLOR_END];	/* Xe[^X̐FR[h	*/



/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
                          WIDTH
	 
	 
	                                       
	              SCREEN_DY                
	                                       
	     
	   SCREEN_DX                       
	                   HEIGHT
	                   SCREEN_W        
	                                   
	                SCREEN_H           
	                                   
	                   
	                                         
	 
	Xe[^X0 Xe[^X1 Xe[^X2  STATUS_HEIGHT
	 
	    Xe[^X0`2̃TCY䗦́A 1:3:1

	screen_buf	`obt@ŚA擪|C^
	WIDTH		`obt@ŚAsNZ
	HEIGHT		        V          csNZ

	screen_size	ʃTCY
	screen_start	ʃobt@́A擪|C^
	SCREEN_W	ʃobt@́AsNZ (320/640/1280)
	SCREEN_H	      V        csNZ (200/400/800)

	DEPTH		F[x (obt@̃rbgA8/16/32)

	status_buf	Xe[^Xobt@ŚA擪|C^
	status_start[3]	Xe[^X 0`2 ̃obt@́A擪|C^
	status_sx[3]		V		      sNZ
	status_sy[3]		V		      csNZ


	 EChE\̏ꍇA
		WIDTH * (HEIGHT + STATUS_HEIGHT) ̃TCYŁA
		EChE𐶐܂B
			(Xe[^X\ȂA WIDTH * HEIGHT)

	 Sʕ\̏ꍇA
		SCREEN_SX * (SCREEN_SY + STATUS_HEIGHT) ȏ̃TCY
		Sʉ܂B
			(Xe[^X\ȂA͍̕œhԂ)

   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/***********************************************************************
 * ʏ̏EI
 *	screen_init()	ʂ𐶐BNɌĂ΂B
 *	screen_exit()	ォÂBIɌĂ΂B
 ************************************************************************/
int	screen_init(void);
void	screen_exit(void);


/***********************************************************************
 * [h؂ւ́AeĐݒ
 *	SGA`悷Kv̂ŁȀB
 * 	grab_mouse A hide_mouse ȂǂɊÂA}EX̐ݒB
 *	L[s[gAXe[^Xݒ肷B
 ************************************************************************/
void	screen_switch(void);


/***********************************************************************
 *
 ************************************************************************/
void	screen_attr_mouse_move(void);
void	screen_attr_mouse_click(void);
int	screen_attr_mouse_debug(void);


/***********************************************************************
 * PC-8801̍ŏIIȐF擾
 ************************************************************************/
void	screen_get_emu_palette(PC88_PALETTE_T pal[16]);
void	screen_get_menu_palette(PC88_PALETTE_T pal[16]);


/***********************************************************************
 * `
 ************************************************************************/
void	screen_update(void);		/* `   (1/60sec)  */
void	screen_update_immidiate(void);	/* ` (j^[p) */


/***********************************************************************
 * t[XLbv
 ************************************************************************/
void	frameskip_blink_reset(void);	/* _ŏ ď		*/
void	frameskip_counter_reset(void);	/* t[XLbv ď	*/
void	frameskip_check(int on_time);	/* t[XLbv 	*/

int	quasi88_cfg_now_frameskip_rate(void);
void	quasi88_cfg_set_frameskip_rate(int rate);



/***********************************************************************
 * HALFTCY̐F⊮̗LE֘Å֐
 ***********************************************************************/
int	quasi88_cfg_can_interp(void);
int	quasi88_cfg_now_interp(void);
void	quasi88_cfg_set_interp(int enable);

/***********************************************************************
 * INTERLACE̐ݒ֘Å֐
 ***********************************************************************/
int	quasi88_cfg_now_interlace(void);
void	quasi88_cfg_set_interlace(int interlace_mode);

/***********************************************************************
 * Xe[^X\ݒ֘Å֐
 ***********************************************************************/
int	quasi88_cfg_can_showstatus(void);
int	quasi88_cfg_now_showstatus(void);
void	quasi88_cfg_set_showstatus(int show);

/***********************************************************************
 * SʐݒEʃTCYݒ֘Å֐
 ***********************************************************************/
int	quasi88_cfg_can_fullscreen(void);
int	quasi88_cfg_now_fullscreen(void);
void	quasi88_cfg_set_fullscreen(int fullscreen);
int	quasi88_cfg_max_size(void);
int	quasi88_cfg_min_size(void);
int	quasi88_cfg_now_size(void);
void	quasi88_cfg_set_size(int new_size);
void	quasi88_cfg_set_size_large(void);
void	quasi88_cfg_set_size_small(void);

/***********************************************************************
 * ???
 ***********************************************************************/
int	quasi88_info_draw_count(void);

#endif	/* SCREEN_H_INCLUDED */
