#ifndef Z80_H_INCLUDED
#define Z80_H_INCLUDED



/* --- Z80 CPU ̃G~[g\ --- */

typedef struct{

  pair	AF, BC, DE, HL;			/* ėpWX^ */
  pair	IX, IY, PC, SP;			/* pWX^ */
  pair	AF1,BC1,DE1,HL1;		/*   WX^	*/
  byte	I, R;				/* ꃌWX^ */
  byte	R_saved;			/* R reg - bit7 ۑp */
  Uchar	IFF,IFF2;			/* IFF1 AIFF2	*/
  Uchar	IM;				/* [h	*/
  Uchar	HALT;				/* HALT tO	*/

  int	INT_active;
  int	icount;				/* ̊܂ł̃Xe[g	*/
  int	state0;				/* Xe[g	*/
					/* (z80->intr_update)()ďoɏ*/

  int	skip_intr_chk;

  Uchar	log;				/* ^ȂfobOp̃OL^	*/
  Uchar	break_if_halt;			/* HALTɏ[v狭Eo*/

  byte	(*fetch)(word);
  byte	(*mem_read)(word);		/* [h֐	*/
  void	(*mem_write)(word,byte);	/* Cg֐	*/
  byte	(*io_read)(byte);		/* I/O ͊֐		*/
  void	(*io_write)(byte,byte);		/* I/O o͊֐		*/

  void	(*intr_update)(void);		/* XV֐	*/
  int	(*intr_ack)(void);		/* ֐		*/

  pair  PC_prev;			/* O PC (j^p)	*/

} z80arch;


/* IFF ̒g */
#define INT_DISABLE	(0)
#define INT_ENABLE	(1)



/*------------------------------------------------------------------------
 * ݏ CPU ̓IɎ~߂邽߂̃}N
 *------------------------------------------------------------------------*/

extern	int z80_state_goal;	/* stateAJԂ(0Ŗ) */
extern	int z80_state_intchk;	/* statesA肷	  */


/* PIOɂCPUؑ֎Aj[JڎȂǂɁACPUIɒ~ */
   
#define	CPU_BREAKOFF()	do{ z80_state_intchk = 0; z80_state_goal = 1; }while(0)

/* ύXɁACPUI XVɕ */

#define	CPU_REFRESH_INTERRUPT()		do{ z80_state_intchk = 0; }while(0)




extern	void	z80_reset( z80arch *z80 );
extern	int	z80_emu( z80arch *z80, int state_of_exec );
extern	void	z80_debug( z80arch *z80, char *mes );
extern	int	z80_line_disasm( z80arch *z80, word addr );

extern	void	z80_logging( z80arch *z80 );



#endif		/* Z80_H_INCLUDED */
