/************************************************************************/
/*									*/
/* QUASI88 j[p Tool Kit						*/
/*									*/
/*	GTK+  API ^č܂B₱āAhLg	*/
/*	܂cccB						*/
/*									*/
/************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "quasi88.h"

#include "q8tk.h"
#include "q8tk-glib.h"

#include "menu-screen.h"

#include "file-op.h"
#include "wait.h"

#include "keyboard.h"	/* mouse_x, mouse_y */
#include "event.h"
#include "menu.h"
#include "screen.h"


/*#define OLD_FOCUS_CHANGE*/


/* R[obN֐̈ (Q8tkWidget*, void*) gp̏ꍇA
 * [jOoğT̂ŁA gcc ɗŋĂ炤B */
#if defined(__GNUC__)
#define	UNUSED_WIDGET	__attribute__((__unused__)) Q8tkWidget *dummy_0
#define	UNUSED_PARM	__attribute__((__unused__)) void *dummy_1
#else
#define	UNUSED_WIDGET	Q8tkWidget *dummy_0
#define	UNUSED_PARM	void *dummy_1
#endif



/************************************************************************/
/* fobOEG[							*/
/************************************************************************/

#define	Q8tkAssert(e,s)		\
		((e) ? (void)0 : _Q8tkAssert(__FILE__, __LINE__, #e, s))

static	void	_Q8tkAssert(char *file, int line, char *exp, const char *s)
{
    fprintf(stderr, "Fatal Error | %s <%s:%d>\n", exp, file, line);
    fprintf(stderr, "message = %s\n",(s)?s:"---");
    quasi88_exit(-1);
}

static const char *debug_type(int type) {
    switch (type) {
    case Q8TK_TYPE_WINDOW:		return "window  :";
    case Q8TK_TYPE_BUTTON:		return "button  :";
    case Q8TK_TYPE_TOGGLE_BUTTON:	return "t-button:";
    case Q8TK_TYPE_CHECK_BUTTON:	return "c-button:";
    case Q8TK_TYPE_RADIO_BUTTON:	return "r-button:";
    case Q8TK_TYPE_FRAME:		return "frame   :";
    case Q8TK_TYPE_LABEL:		return "label   :";
    case Q8TK_TYPE_LOGO:		return "logo    :";
    case Q8TK_TYPE_NOTEBOOK:		return "notebook:";
    case Q8TK_TYPE_NOTEPAGE:		return "page    :";
    case Q8TK_TYPE_VBOX:		return "vbox    :";
    case Q8TK_TYPE_HBOX:		return "hbox    :";
    case Q8TK_TYPE_VSEPARATOR:		return "vsep    :";
    case Q8TK_TYPE_HSEPARATOR:		return "hsep    :";
    case Q8TK_TYPE_COMBO:		return "combo   :";
    case Q8TK_TYPE_LISTBOX:		return "listbox :";
    case Q8TK_TYPE_LIST_ITEM:		return "listitem:";
    case Q8TK_TYPE_ADJUSTMENT:		return "adjust  :";
    case Q8TK_TYPE_HSCALE:		return "hscale  :";
    case Q8TK_TYPE_VSCALE:		return "vscale  :";
    case Q8TK_TYPE_SCROLLED_WINDOW:	return "scrolled:";
    case Q8TK_TYPE_ENTRY:		return "entry   :";
    case Q8TK_TYPE_DIALOG:		return "dialog  :";
    case Q8TK_TYPE_FILE_SELECTION:	return "f-select:";
    }
    return "UNDEF TYPE:";
}



/************************************************************************/
/* [N								*/
/************************************************************************/

static	int		MAX_WIDGET;
static	Q8tkWidget	**widget_table;


static	int		MAX_LIST;
static	Q8List		**list_table;


#define	MAX_WINDOW_LAYER	(8)
static	Q8tkWidget		*window_layer[ MAX_WINDOW_LAYER ];
static	int			window_layer_level;
static	Q8tkWidget		*focus_widget[ MAX_WINDOW_LAYER ];
#define	get_focus_widget()	(focus_widget[ window_layer_level ])



static	struct {
    int	x, y;
    int	x_old, y_old;
} mouse;


static	int	kanji_code = Q8TK_KANJI_ANK;
static	int	disp_cursor = FALSE;

static	int	now_shift_on;
static	int	now_mouse_on;

/*----------------------------------------------------------------------*/

static	void	widget_map(Q8tkWidget *widget);
static	void	widget_construct(void);
static	void	widget_signal_do(Q8tkWidget *widget, const char *name);



/************************************************************************/
/* I[N̊mہ^J						*/
/************************************************************************/
/*--------------------------------------------------------------
 *	Widget
 *--------------------------------------------------------------*/
static	Q8tkWidget	*malloc_widget(void)
{
    int		i;
    Q8tkWidget	**t, *w;
    int		add;

    t = NULL;
    for (i=0; i<MAX_WIDGET; i++) {
	if (widget_table[i] == NULL) {
	    t = &widget_table[i];
	    break;
	}
    }

    if (t == NULL) {
	add = 512;
	if (MAX_WIDGET == 0) {
	    widget_table = malloc((MAX_WIDGET + add) * sizeof(Q8tkWidget*));
	} else {
	    widget_table = realloc(widget_table,
				   (MAX_WIDGET + add) * sizeof(Q8tkWidget*));
	}
	if (widget_table) {
	    for (i=0; i<add; i++) {
		widget_table[ MAX_WIDGET + i ] = NULL;
	    }
	    t = &widget_table[ MAX_WIDGET ];
	    MAX_WIDGET += add;
	}
    }

    if (t) {
	w = (Q8tkWidget *)calloc(1, sizeof(Q8tkWidget));
	if (w) {
	    /* l SoƂ 0 */
	    *t = w;
	    return w;
	} else {
	    Q8tkAssert(FALSE, "memory exhoused");
	}
    }

    Q8tkAssert(FALSE, "work 'widget' exhoused");
    return NULL;
}
static	void	free_widget(Q8tkWidget *w)
{
    int i;
    for (i=0; i<MAX_WIDGET; i++) {
	if (widget_table[i] == w) {
	    free(w);
	    widget_table[i] = NULL;
	    return;
	}
    }
    Q8tkAssert(FALSE, "pointer is not malloced widget");
}
/*--------------------------------------------------------------
 *	List
 *--------------------------------------------------------------*/
static	Q8List	*malloc_list(void)
{
    int		i;
    Q8List	**t, *l;
    int		add;

    t = NULL;
    for (i=0; i<MAX_LIST; i++) {
	if (list_table[i] == NULL) {
	    t = &list_table[i];
	    break;
	}
    }

    if (t == NULL) {
	add = 512;
	if (MAX_LIST == 0) {
	    list_table = malloc((MAX_LIST + add) * sizeof(Q8List*));
	} else {
	    list_table = realloc(list_table,
				 (MAX_LIST + add) * sizeof(Q8List*));
	}
	if (list_table) {
	    for (i=0; i<add; i++) {
		list_table[ MAX_LIST + i ] = NULL;
	    }
	    t = &list_table[ MAX_LIST ];
	    MAX_LIST += add;
	}
    }

    if (t) {
	l = (Q8List *)calloc(1, sizeof(Q8List));
	if (l) {
	    *t = l;
	    return l;
	} else {
	    Q8tkAssert(FALSE, "memory exhoused");
	}
    }

    Q8tkAssert(FALSE, "work 'list' exhoused");
    return NULL;
}
static	void	free_list(Q8List *l)
{
    int	i;
    for (i=0; i<MAX_LIST; i++) {
	if (list_table[i] == l) {
	    free(l);
	    list_table[i] = NULL;
	    return;
	}
    }
    Q8tkAssert(FALSE, "pointer is not malloced list");
}



#if 0
/************************************************************************/
/* Q8TK p 񏈗							*/
/*	q8_strncpy(s, ct, n)						*/
/*		 ct   s  Rs[B			*/
/*		s ̕I[́AK '\0' ƂȂAs ̒ n-1 	*/
/*		ȉɎ܂B						*/
/*	q8_strncat(s, ct, n)						*/
/*		 ct   s  tB			*/
/*		s ̕I[́AK '\0' ƂȂAs ̒ n-1 	*/
/*		ȉɎ܂B						*/
/************************************************************************/
static	void	q8_strncpy(char *s, const char *ct, size_t n)
{
    strncpy(s, ct, n-1);
    s[ n-1 ] = '\0';
}
static	void	q8_strncat(char *s, const char *ct, size_t n)
{
    if (n > strlen(s) + 1)
	strncat(s, ct, n - strlen(s) -1);
}
#endif


/************************************************************************/
/* Xg								*/
/************************************************************************/
/*--------------------------------------------------------------
 * Xg̖ɂ炵vfǉ (܂̓XgVK쐬)
 *	߂ĺAXg̐擪
 *--------------------------------------------------------------*/
Q8List	*q8_list_append(Q8List *list, void *data)
{
    Q8List	*new_list;

    new_list  = malloc_list();		/* [Nm */

    if (list) {				/* ̃XgɂȂꍇ */
	list = q8_list_last(list);		/* ƃN */
	list->next     = new_list;
	new_list->prev = list;
	new_list->next = NULL;
    }else{				/* VK̃Xg̏ꍇ */
	new_list->prev = NULL;
	new_list->next = NULL;
    }
    new_list->data   = data;

    return q8_list_first(new_list);	/* ̃Xg擪Ԃ   */
}
/*--------------------------------------------------------------
 * Xg̓rɂ炵vfǉ (position==0Ő擪)
 *	߂ĺAXg̐擪
 *--------------------------------------------------------------*/
#if 0
Q8List	*q8_list_insert(Q8List *list, void *data, int position)
{
    /* 쐬 */
    return NULL;
}
#endif
/*--------------------------------------------------------------
 * Xg̗vfЂƂ폜
 *	߂ĺAXg̐擪
 *--------------------------------------------------------------*/
Q8List	*q8_list_remove(Q8List *list, void *data)
{
    list = q8_list_first(list);

    while (list) {			/* Xg擪珇ɂǂ */
	if (list->data == data) {	/* data ̈v̂T  */
	    list->prev->next = list->next;	/* ݂΃N */
	    list->next->prev = list->prev;	/* Ȃς       */
	    free_list(list);			/* g͍폜         */
	    break;
	}
	list = list->next;
    }

    return q8_list_first(list);		/* ̃Xg擪Ԃ   */
}
/*--------------------------------------------------------------
 * Xg̏
 *--------------------------------------------------------------*/
void	q8_list_free(Q8List *list)
{
    Q8List *l;

    list = q8_list_first(list);		/* Xg̐擪 */

    while (list) {			/* ǂȂ */
	l = list->next;
	free_list(list);
	list = l;
    }
}
/*--------------------------------------------------------------
 * Xg擪
 *--------------------------------------------------------------*/
Q8List	*q8_list_first(Q8List *list)
{
    if (list) {
	while (list->prev) {		/* XgOɂǂ */
	    list = list->prev;
	}				/* ǂȂȂ */
    }					/* ꂪ擪         */
    return list;
}
/*--------------------------------------------------------------
 * Xg
 *--------------------------------------------------------------*/
Q8List	*q8_list_last(Q8List *list)
{
    if (list) {
	while (list->next) {		/* Xgɂǂ */
	    list = list->next;
	}				/* ǂȂȂ */
    }					/* ꂪ         */
    return list;
}
/*--------------------------------------------------------------
 * Xg
 *--------------------------------------------------------------*/
Q8List	*q8_list_find(Q8List *list, void *data)
{
    list = q8_list_first(list);		/* Xg̐擪   */

    while (list) {			/* ǂȂ       */
	if (list->data == data) break;	/* v̂T */
	list = list->next;
    }
    return list;
}


/************************************************************************/
/* R[h								*/
/************************************************************************/
int	q8tk_set_kanjicode(int code)
{
    int ret = kanji_code;

    if (code != Q8TK_KANJI_ANK &&
	code != Q8TK_KANJI_EUC &&
	code != Q8TK_KANJI_SJIS &&
	code != Q8TK_KANJI_UTF8) {

	code = Q8TK_KANJI_ANK;
    }

    kanji_code = code;

    return ret;
}
/************************************************************************/
/* J[\\̗L							*/
/************************************************************************/
void	q8tk_set_cursor(int enable)
{
    disp_cursor = (enable) ? TRUE : FALSE;
}





/************************************************************************/
/* ƏI								*/
/************************************************************************/

static	int		q8tk_disp_init_flag;
static	int		q8tk_main_loop_flag;
static	int		q8tk_construct_flag;

#define	set_main_loop_flag(f)	q8tk_main_loop_flag = (f)
#define	get_main_loop_flag()	q8tk_main_loop_flag
#define	set_construct_flag(f)	q8tk_construct_flag = (f)
#define	get_construct_flag()	q8tk_construct_flag


static	Q8tkWidget	*q8tk_drag_widget;
#define	set_drag_widget(w)	q8tk_drag_widget = (w)
#define	get_drag_widget()	q8tk_drag_widget



static	void		widget_focus_list_init(void);
static	Q8tkWidget	*widget_focus_list_get_next(Q8tkWidget *widget,
						    int back);



static	void	widget_scrollin_init(void);
static	void	widget_scrollin_register(Q8tkWidget *widget);
static	void	widget_scrollin_drawn(Q8tkWidget *widget);


static	int		delay_timer;
static	Q8tkWidget	*q8tk_delay_widget;
#define	set_delay_widget(w, n)	do {				\
				    if (w == NULL) {		\
					delay_timer = 0;	\
				    } else {			\
					delay_timer = n;	\
				    }				\
				    q8tk_delay_widget = w;	\
				} while (0)
#define	get_delay_widget()	q8tk_delay_widget




/*--------------------------------------------------------------
 *	
 *--------------------------------------------------------------*/
void	q8tk_init(void)
{
    int	i;

    MAX_WIDGET = 0;
    widget_table = NULL;

    MAX_LIST = 0;
    list_table = NULL;

    for (i=0; i<MAX_WINDOW_LAYER; i++) {
	window_layer[i] = NULL;
	focus_widget[i] = NULL;
    }
    window_layer_level = -1;

    set_main_loop_flag(TRUE);
    set_construct_flag(FALSE);

    set_drag_widget(NULL);
    widget_focus_list_init();
    widget_scrollin_init();


    q8gr_init();


    mouse.x_old = mouse.x = mouse_x;
    mouse.y_old = mouse.y = mouse_y;

    now_shift_on = FALSE;
    now_mouse_on = FALSE;

    q8tk_disp_init_flag = TRUE;
}
/*--------------------------------------------------------------
 *	I
 *--------------------------------------------------------------*/
static	void	q8tk_term(void)
{
    int	i;
    for (i=0; i<MAX_WIDGET; i++) {
	if (widget_table[i]) {
	    if (widget_table[i]->name) {
		free(widget_table[i]->name);
	    }
	    free(widget_table[i]);
	}
    }
    if (widget_table) {
	free(widget_table);
    }
    widget_table = NULL;
    MAX_WIDGET = 0;

    for (i=0; i<MAX_LIST; i++) {
	if (list_table[i]) {
	    free(list_table[i]);
	}
    }
    if (list_table) {
	free(list_table);
    }
    list_table = NULL;
    MAX_LIST = 0;
}



/************************************************************************/
/* [_̐ݒ							*/
/************************************************************************/
/*--------------------------------------------------------------
 *	[_ݒ
 *--------------------------------------------------------------*/
void	q8tk_grab_add(Q8tkWidget *widget)
{
    int i;
    Q8tkAssert(widget->type == Q8TK_TYPE_WINDOW, "grab add not window");

    for (i=0; i<MAX_WINDOW_LAYER; i++) {
	if (window_layer[i] == NULL) {
	    window_layer[i] = widget;
	    window_layer_level = i;
	    set_construct_flag(TRUE);
	    return;
	}
    }
    Q8tkAssert(FALSE, "overflow window level");
}
/*--------------------------------------------------------------
 *	[_
 *--------------------------------------------------------------*/
void	q8tk_grab_remove(Q8tkWidget *widget)
{
    int i;

    for (i=0; i<MAX_WINDOW_LAYER; i++) {
	if (window_layer[i] == widget) {
	    break;
	}
    }
    Q8tkAssert(i < MAX_WINDOW_LAYER, "grab remove not widget");
    for (   ; i<MAX_WINDOW_LAYER-1; i++) {
	window_layer[i] = window_layer[i+1];
	focus_widget[i] = focus_widget[i+1];
    }
    window_layer[i] = NULL;
    focus_widget[i] = NULL;
    window_layer_level --;
    set_construct_flag(TRUE);
}



/********************************************************/
/* EBWbg̍쐬					*/
/********************************************************/

/*---------------------------------------------------------------------------
 * EChE (WINDOW)
 *---------------------------------------------------------------------------
 *  ESẴEBWbg̍łcɂȂReiEBWbgB
 *  EqĂB
 *  Eqɂ́Aq8tk_container_add() gpB
 *  ẼEBWbg\ɂ́Aq8tk_grab_add()ɂĖIɕ\wB
 *  EWINDOW ͍őAMAX_WINDOW_LAYER쐬ł邪AVOi󂯕t̂́A
 *    Ō q8tk_grab_add() 𔭍sEChE̎q݂̂łB
 *  EQ8TK_WINDOW_TOPLEVEL ̃EBhEKKvB
 *  EVOi
 *	Ȃ
 *  EVOi ([Ups)
 *	"inactivate"	|bvAbvEChEɂăEChEONbN
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_window_new(int window_type)
 *	EChE̐
 *	ɂAEChE̎ނ܂
 *		Q8TK_WINDOW_TOPLEVEL c Ԋb̃EChEŁAB̂
 *					\BEChEgȂ
 *		Q8TK_WINDOW_DIALOG   c oςEChEg
 *		Q8TK_WINDOW_POPUP    c PȃEChEg
 *  -------------------------------------------------------------------------
 *	yWINDOWz [xxxx]		܂܂ȃEBWbgqɎĂ
 *
 *---------------------------------------------------------------------------*/
/* |bvAbvEChE͈̔͊Oɂă}EXNbNAVOi */
static	void	window_event_button_on(Q8tkWidget *widget)
{
    widget_signal_do(widget, "inactivate");
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

Q8tkWidget	*q8tk_window_new(int window_type)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_WINDOW;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->stat.window.type = window_type;

    switch (window_type) {
    case Q8TK_WINDOW_TOPLEVEL:
	Q8tkAssert(window_layer[0] == NULL, "Redefine TOP window");
	q8tk_grab_add(w);
	w->stat.window.no_frame = TRUE;
	break;

    case Q8TK_WINDOW_DIALOG:
	w->stat.window.no_frame = FALSE;
	w->stat.window.shadow_type = Q8TK_SHADOW_OUT;
	break;

    case Q8TK_WINDOW_POPUP:
	w->stat.window.no_frame = FALSE;
	w->stat.window.shadow_type = Q8TK_SHADOW_ETCHED_OUT;
	w->event_button_on = window_event_button_on;
	break;
    }

    return w;
}




/*---------------------------------------------------------------------------
 * {^ (BUTTON)
 *---------------------------------------------------------------------------
 *  E}EXȂǂŃ{^ĂԂ͈ŁA}EX𗣂Ɩ߂B
 *  EqĂB (AAxȊO̎qꍇ͖̓ۏ)
 *  Eqɂ́Aq8tk_container_add() gpB
 *  EVOi
 *	"clicked"	{^ꂽɔ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_button_new(void)
 *	{^̐B
 *
 *  Q8tkWidget	*q8tk_button_new_with_label(const char *label)
 *	 label `ꂽ{^̐B
 *	Iɂ́A{^ƃxAeqɂB
 *  -------------------------------------------------------------------------
 *	yBUTTONz [LABEL]		xqɎ
 *
 *---------------------------------------------------------------------------*/
/* ^[EXy[XAVOi */
static	void	button_event_key_on(Q8tkWidget *widget, int key)
{
    if (key == Q8TK_KEY_RET || key == Q8TK_KEY_SPACE) {

#if 0		/* ̂܂܂ƁA񂾏Ԃ`悷ɂȂ */
	widget_signal_do(widget, "clicked");

#else		/* 񂾏Ԃ`悳̂ŁACxgx点 */
	widget->stat.button.active = Q8TK_BUTTON_ON;
	set_construct_flag(TRUE);
	set_delay_widget(widget, 3);		/* 3 t[x */
#endif
    }
}

/* {^}EXNbNA{^܂āAhbOJnƂ */
static	void	button_event_button_on(Q8tkWidget *widget)
{
    set_drag_widget(widget);

    widget->stat.button.active = Q8TK_BUTTON_ON;
    set_construct_flag(TRUE);
}

/* hbÓA}EẌʒuɉāA{^ʉ */
static	void	button_event_dragging(Q8tkWidget *widget)
{
    if (q8gr_get_focus_screen(mouse.x/8, mouse.y/16) == widget) {
	if (widget->stat.button.active == Q8TK_BUTTON_OFF) {
	    widget->stat.button.active = Q8TK_BUTTON_ON;
	    set_construct_flag(TRUE);
	}
    } else {
	if (widget->stat.button.active == Q8TK_BUTTON_ON) {
	    widget->stat.button.active = Q8TK_BUTTON_OFF;
	    set_construct_flag(TRUE);
	}
    }
}

/* hbOIŁA{^łAVOi */
static	void	button_event_drag_off(Q8tkWidget *widget)
{
    if (widget->stat.button.active == Q8TK_BUTTON_ON) {

#if 0	/* }EXAłł́Aʂ̘A\ƌꂵ */
	widget->stat.button.active = Q8TK_BUTTON_OFF;
	widget_signal_do(widget, "clicked");
	set_construct_flag(TRUE);

#else	/* Cxgx点邱ƂŁAA\Ȃ悤ɂ */
	widget->stat.button.active = Q8TK_BUTTON_OFF;
	set_delay_widget(widget, 3);		/* 3 t[x */
	set_construct_flag(TRUE);
#endif
    }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

Q8tkWidget	*q8tk_button_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_BUTTON;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->event_button_on = button_event_button_on;
    w->event_key_on    = button_event_key_on;
    w->event_dragging  = button_event_dragging;
    w->event_drag_off  = button_event_drag_off;

    return w;
}

Q8tkWidget	*q8tk_button_new_with_label(const char *label)
{
    Q8tkWidget *b = q8tk_button_new();
    Q8tkWidget *l = q8tk_label_new(label);

    q8tk_widget_show(l);
    q8tk_container_add(b, l);

    b->with_label = TRUE;

    return b;
}




/*---------------------------------------------------------------------------
 * gO{^ (TOGGLE BUTTON)
 *---------------------------------------------------------------------------
 *  E}EXȂǂŃ{^ƈށBx{^Ɩ߂B
 *  EqĂB (AAxȊO̎qꍇ͖̓ۏ)
 *  Eqɂ́Aq8tk_container_add() gpB
 *  EVOi
 *	"clicked"	{^Ĉ񂾎ɔ
 *	"toggled"	{^̏Ԃωɔ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_toggle_button_new(void)
 *	gO{^̐B
 *
 *  Q8tkWidget	*q8tk_toggle_button_new_with_label(const char *label)
 *	 label `ꂽO{^̐B
 *	Iɂ́AgO{^ƃxAeqɂB
 *
 *  void	q8tk_toggle_button_set_state(Q8tkWidget *widget, int status)
 *	{^̏ԂύXB
 *	status ^Ȃ{^Ԃɂ (VOi)B
 *	status UȂȂɂȂB
 *  -------------------------------------------------------------------------
 *	yTOGGLE BUTTONz [LABEL]		xqɎ
 *
 *---------------------------------------------------------------------------*/
/* {^}EXNbNAVOi */
static	void	toggle_button_event_button_on(Q8tkWidget *widget)
{
    if (widget->stat.button.active == Q8TK_BUTTON_ON) {
	widget->stat.button.active = Q8TK_BUTTON_OFF;
	widget_signal_do(widget, "toggled");
    } else {
	widget->stat.button.active = Q8TK_BUTTON_ON;
	widget_signal_do(widget, "clicked");
	widget_signal_do(widget, "toggled");
    }
    set_construct_flag(TRUE);
}

/* ^[EXy[XA}EXNbNƓ */
static	void	toggle_button_event_key_on(Q8tkWidget *widget, int key)
{
    if (key == Q8TK_KEY_RET || key == Q8TK_KEY_SPACE) {
	toggle_button_event_button_on(widget);
    }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

Q8tkWidget	*q8tk_toggle_button_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_TOGGLE_BUTTON;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->event_button_on = toggle_button_event_button_on;
    w->event_key_on    = toggle_button_event_key_on;

    return w;
}

Q8tkWidget	*q8tk_toggle_button_new_with_label(const char *label)
{
    Q8tkWidget *b = q8tk_toggle_button_new();
    Q8tkWidget *l = q8tk_label_new(label);

    q8tk_widget_show(l);
    q8tk_container_add(b, l);

    b->with_label = TRUE;

    return b;
}

void		q8tk_toggle_button_set_state(Q8tkWidget *widget, int status)
{
    if (status) {
	if (widget->event_key_on) {
	    (*widget->event_key_on)(widget, Q8TK_KEY_SPACE);
	}
    } else {
	widget->stat.button.active = Q8TK_BUTTON_OFF;
	set_construct_flag(TRUE);
    }
}




/*---------------------------------------------------------------------------
 * `FbN{^ (CHECK BUTTON)
 *---------------------------------------------------------------------------
 *  E{^ƁA`FbN{bNXhԂB
 *    x{^Ɩ߂B
 *  EqĂB (AAxȊO̎qꍇ͖̓ۏ)
 *  Eqɂ́Aq8tk_container_add() gpB
 *  EVOi
 *	"clicked"	{^ꂽɔ
 *	"toggled"	{^̏Ԃωɔ
 *		OFFԂ̏ꍇ́A "toggled" 
 *		 ONԂ̏ꍇ́A "clicked"  "toggled" ̏ɔ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_check_button_new(void)
 *	`FbN{^̐B
 *
 *  Q8tkWidget	*q8tk_check_button_new_with_label(const char *label)
 *	 label `ꂽ`FbN{^̐B
 *	Iɂ́A`FbN{^ƃxAeqɂB
 *  -------------------------------------------------------------------------
 *	ڂ͈ႤA@\Iɂ̓gO{^ƓłB
 *	gO{^ƓlAq8tk_toggle_button_set_state() ɂA
 *	{^Ԃɂ邱Ƃł (VOi)B
 *  -------------------------------------------------------------------------
 *	yCHECK BUTTONz [LABEL]		xqɎ
 *
 *---------------------------------------------------------------------------*/
static	void	check_button_event_do(Q8tkWidget *widget)
{
    if (widget->stat.button.active == Q8TK_BUTTON_ON) {
	widget->stat.button.active = Q8TK_BUTTON_OFF;
	widget_signal_do(widget, "toggled");
    } else {
	widget->stat.button.active = Q8TK_BUTTON_ON;
	widget_signal_do(widget, "clicked");
	widget_signal_do(widget, "toggled");
    }
    set_construct_flag(TRUE);
}

/* ^[EXy[XAVOi */
static	void	check_button_event_key_on(Q8tkWidget *widget, int key)
{
    if (key == Q8TK_KEY_RET || key == Q8TK_KEY_SPACE) {
	check_button_event_do(widget);
    }
}

/* {^}EXNbNAhbOJnƂ */
static	void	check_button_event_button_on(Q8tkWidget *widget)
{
    set_drag_widget(widget);
    set_construct_flag(TRUE);
}

/* hbOIŁAVOi (hbÓAȂɂȂ) */
static	void	check_button_event_drag_off(Q8tkWidget *widget)
{
    if (q8gr_get_focus_screen(mouse.x/8, mouse.y/16) == widget) {
	check_button_event_do(widget);
    }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

Q8tkWidget	*q8tk_check_button_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_CHECK_BUTTON;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->event_button_on = check_button_event_button_on;
    w->event_key_on    = check_button_event_key_on;
    w->event_drag_off  = check_button_event_drag_off;

    return w;
}

Q8tkWidget	*q8tk_check_button_new_with_label(const char *label)
{
    Q8tkWidget *b = q8tk_check_button_new();
    Q8tkWidget *l = q8tk_label_new(label);

    q8tk_widget_show(l);
    q8tk_container_add(b, l);

    b->with_label = TRUE;

    return b;
}




/*---------------------------------------------------------------------------
 * WI{^ (RADIO BUTTON)
 *---------------------------------------------------------------------------
 *  E̃WI{^mŃO[sOłB
 *  E{^ƃ`FbN邪AO[sOꂽ
 *    ̃WI{^́A`FbNOB
 *  EqĂB (AAxȊO̎qꍇ͖̓ۏ)
 *  Eqɂ́Aq8tk_container_add() gpB
 *  EVOi
 *	"clicked"	{^ꂽɔ
 *	"toggled"	{^̏Ԃωɔ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_radio_button_new(Q8tkWidget *group)
 *	WI{^̐B
 *	O[vƂ郉WI{^ŗ^B(ŏ̃{^Ȃ NULL)
 *	ŏ̃{^`FbNBȍ~̃{^̓`FbNOB
 *	ȉ́A3̃WI{^𐶐
 *		button[0] = q8tk_radio_button_new(NULL);
 *		button[1] = q8tk_radio_button_new(button[0]);
 *		button[2] = q8tk_radio_button_new(button[1]);
 *
 *  Q8tkWidget	*q8tk_radio_button_new_with_label(Q8List *list,
 *						  const char *label)
 *	 label `ꂽWI{^̐B
 *	Iɂ́AWI{^ƃxAeqɂB
 *  -------------------------------------------------------------------------
 *	O[sOĂ邪A@\Iɂ̓gO{^ƓłB
 *	gO{^ƓlAq8tk_toggle_button_set_state() ɂA
 *	{^Ԃɂ邱ƂłBȂA̎O[sOꂽ
 *	ׂẴWI{^ "toggled" VOiB
 *  -------------------------------------------------------------------------
 *	yRADIO BUTTONz [LABEL]			xqɎ
 *							LIST 擪ŕێ
 *			LIST
 *					b
 *	yRADIO BUTTONz [LABEL]	bb
 *					b
 *			LIST
 *
 *	eWI{^͓ƗEBWbgł邪AXgɂO[v
 *	ȂĂBeWI{^́ÃXg̐擪ŕێĂB
 *	{^ƃO[v𐶐ĂSEBWbgɃVOiB
 *
 *---------------------------------------------------------------------------*/
static	void	radio_button_event_do(Q8tkWidget *widget)
{
    Q8List *list;

					/* g clicked VOi𔭐 */
    widget_signal_do(widget, "clicked");
    if (widget->stat.button.active == Q8TK_BUTTON_ON) return;

					/* XgǂĎȊÕ{^  */
    list = widget->stat.button.list;	/* ItɂA toggled VOi */
    while (list) {
	if (list->data != widget) {
	    ((Q8tkWidget *)(list->data))->stat.button.active = Q8TK_BUTTON_OFF;
	    widget_signal_do((Q8tkWidget *)(list->data), "toggled");
	}
	list = list->next;
    }
						/* g{^ԕωȂ */
						/* toggled VOi     */
    widget->stat.button.active = Q8TK_BUTTON_ON;

    widget_signal_do(widget, "toggled");

    set_construct_flag(TRUE);
}

/* ^[EXy[XAVOi */
/* /L[AO/̃WI{^ɁAtH[JXړ */
static	void	radio_button_event_key_on(Q8tkWidget *widget, int key)
{
    if (key == Q8TK_KEY_RET || key == Q8TK_KEY_SPACE) {
	radio_button_event_do(widget);
    }

#ifdef	OLD_FOCUS_CHANGE
	/* DO NOTHING */
#else	/* VȃtH[JXړ */
    if (key == Q8TK_KEY_LEFT  ||
	key == Q8TK_KEY_UP    ||
	key == Q8TK_KEY_RIGHT ||
	key == Q8TK_KEY_DOWN) {

#if 0	/* OFFԂŃtH[JX̏ꍇAJ[\L[Ń{^Ƃ݂Ȃ */
	if (widget->stat.button.active == FALSE) {
	    radio_button_event_do(widget);
	}
	else
#endif
	{
	    Q8List *list = q8_list_find(widget->stat.button.list, widget);

	    if (list) {
		if (key == Q8TK_KEY_LEFT ||
		    key == Q8TK_KEY_UP) {
		    if (list->prev == NULL) list = q8_list_last(list);
		    else                    list = list->prev;
		} else {
		    if (list->next == NULL) list = q8_list_first(list);
		    else                    list = list->next;
		}
		if (list) {
		    q8tk_widget_set_focus((Q8tkWidget *)(list->data));
#if 0	/* /L[AO/̃WI{^Ƃ݂Ȃ */
		    radio_button_event_do((Q8tkWidget *)(list->data));
#endif
		}
	    }
	}
    }
#endif
}

/* {^}EXNbNAhbOJnƂ */
static	void	radio_button_event_button_on(Q8tkWidget *widget)
{
    set_drag_widget(widget);
    set_construct_flag(TRUE);
}

/* hbOIŁAVOi (hbÓAȂɂȂ) */
static	void	radio_button_event_drag_off(Q8tkWidget *widget)
{
    if (q8gr_get_focus_screen(mouse.x/8, mouse.y/16) == widget) {
	radio_button_event_do(widget);
    }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

Q8tkWidget	*q8tk_radio_button_new(Q8tkWidget *group)
{
    Q8tkWidget *w;
    Q8List *list;

    w = malloc_widget();
    w->type = Q8TK_TYPE_RADIO_BUTTON;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->key_up_used    = TRUE;
    w->key_down_used  = TRUE;
    w->key_left_used  = TRUE;
    w->key_right_used = TRUE;

    w->event_button_on = radio_button_event_button_on;
    w->event_key_on    = radio_button_event_key_on;
    w->event_drag_off  = radio_button_event_drag_off;

    if (group == NULL) {				/* ŏ1 */
	list = NULL;
	w->stat.button.active = TRUE;
    } else {						/* 2ڈȍ~   */
	list = group->stat.button.list;
	w->stat.button.active = FALSE;
    }
    w->stat.button.list = q8_list_append(list, w);

    return w;
}

Q8tkWidget	*q8tk_radio_button_new_with_label(Q8tkWidget *group,
						  const char *label)
{
    Q8tkWidget *b = q8tk_radio_button_new(group);
    Q8tkWidget *l = q8tk_label_new(label);

    q8tk_widget_show(l);
    q8tk_container_add(b, l);

    b->with_label = TRUE;

    return b;
}

Q8List	*q8tk_radio_button_get_list(Q8tkWidget *group)
{
    return group->stat.button.list;
}




/*---------------------------------------------------------------------------
 * R{{bNX (COMBO BOX)
 *---------------------------------------------------------------------------
 *  EGg̈B
 *  Eq͎ĂȂB
 *  Eq8tk_combo_append_popdown_strings() ɂA̕xɎ
 *    XgACeŐB͈ꗗĨ|bvAbvEChE
 *    ɂĕ\B
 *  EVOi
 *	"activate"	XgACeIꂽƂɂA
 *			Gg̈̕ɕύXɔ
 *			ȂAGgɂă^[L[͂ɔ
 *	"changed"	Ggɂĕ́A폜ɔ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_combo_new(void)
 *	R{{bNX̐B́A͕͂sɂȂĂB
 *
 *  void	q8tk_combo_append_popdown_strings(Q8tkWidget *combo, 
 *						  const char *entry_str,
 *						  const char *disp_str)
 *	ꗗĨ|bvAbvEChE\邽߂́AXgACe
 *	B̃XgACéA disp_str ̕xɎB
 *		ꗗĨ|bvAbvEChEɂẴXgACeI
 *		ꂽꍇA R{{bNX̃Gg̈ entry_str Zbg
 *		B("activate"VOi)
 *	disp_str == NULL ̏ꍇ́A disp_str  entry_str ƓɂȂB
 *
 *  const char	*q8tk_combo_get_text(Q8tkWidget *combo)
 *	Gg̈ɓ͂Ă镶Ԃ
 *
 *  void	q8tk_combo_set_text(Q8tkWidget *combo, const char *text)
 *	Gg̈ɐݒ肷 (VOi͔Ȃ)B
 *
 *  void	q8tk_combo_set_editable(Q8tkWidget *combo, int editable)
 *	Gg͉̈̓Esݒ肷B editable  ^Ȃ͉B
 *
 *  void	q8tk_misc_set_size(Q8tkWidget *widget, int width, int height)
 *	R{{bNX̕\TCY width w肷B height ͖B
 *  -------------------------------------------------------------------------
 *	yCOMBO BOXz
 *		b
 *		yENTRYz
 *
 *	q8tk_combo_append_popdown_strings ɂ LIST ITEM  LABEL 𐶐B
 *
 *	yCOMBO BOXz
 *	    b  b
 *	    b  yENTRYz
 *	    b
 *	      LIST  yLIST ITEMzyLABELz
 *			
 *			LIST  yLIST ITEMzyLABELz
 *			
 *			LIST  yLIST ITEMzyLABELz
 *			
 *
 *	R{{bNX}EXŃNbNƁAȉ̂悤ȃEChE
 *	(Q8TK_WINDOW_POPUP) IɐÃEChE q8tk_grab_add()
 *	B܂ÃEChEւ̑ȊÓAoȂȂB
 *
 *	yWINDOWzyLIST BOXzyLIST ITEMzyLABELz
 *	    b				  
 *	    b			    yLIST ITEMzyLABELz
 *	    b				  
 *	    b			    yLIST ITEMzyLABELz
 *	    b				  
 *	    b
 *	    yACCEL GROUPzyACCEL KEYz  yBUTTON(_~[)z
 *
 *	 LIST ITEM  LABEL  q8tk_combo_append_popdown_strings() ɂ
 *	ꂽXgACe (ƃx) łB
 *
 *	XgACêꂩIƁAŎ
 *	EBWbg(XgACe͏)͑Sč폜AƂ̕\ɖ߂B
 *	̎AIXgACe̎񂪁AGg̈
 *	ZbgAɃVOiB
 *
 *	ESCL[ꂽꍇA̕\̖߂B(̏ꍇ͓RVOiȂ)
 *	邽߂ɃANZ[^L[𗘗pĂ邪AANZ[^
 *	L[́AEBWbgɃVOi𑗂邱ƂoȂ̂ŁA_~[̃{^
 *	(\) 𐶐āÃ{^ɃVOi𑗂悤ɂĂB
 *	̃{^̓VOiƎ󂯂ƁASẴEBWbg폜B
 *
 *	XgȂꍇAXg{bNX̕\ʂɎ܂ȂƂ
 *	̂ŁȀꍇ WINDOW  LIST BOX ̊ԂɃXN[hEChE
 *	𐶐B(ʂɎ܂邩ǂ̔f͌\)
 *
 *---------------------------------------------------------------------------*/

/* |bvAbvEChEŁALIST ITEM I or ESCL[ or EChEO
   }EXNbÑR[obN֐B|bvAbvEChE폜 */
static	void	combo_fake_callback(UNUSED_WIDGET, Q8tkWidget *parent)
{
    Q8List *l;

    l = parent->stat.combo.list;		/* l->data  LIST ITEM */
    while (l) {
	q8tk_signal_handlers_destroy((Q8tkWidget *)(l->data));
	l = l->next;
    }

    q8tk_grab_remove(parent->stat.combo.popup_window);

    if (parent->stat.combo.popup_scrolled_window)
	q8tk_widget_destroy(parent->stat.combo.popup_scrolled_window);

    /* LIST BOX ͍폜邪A LIST ITEM ͍폜Ɏc */
    q8tk_widget_destroy(parent->stat.combo.popup_list);
    q8tk_widget_destroy(parent->stat.combo.popup_window);
    q8tk_widget_destroy(parent->stat.combo.popup_fake);
    q8tk_widget_destroy(parent->stat.combo.popup_accel_group);
}

/* |bvAbvEChE LIST ITEM }EXNbÑR[obN */
static	void	combo_event_list_callback(Q8tkWidget *list_item,
					  Q8tkWidget *parent)
{
    if (strcmp(parent->stat.combo.entry->name, list_item->child->name) == 0) {
	/* ݂̓͂ƁAIXg̕񂪓Ȃ̂ŁAVOi͖ */
    } else {
	/* ݂̓͂ƁAIXg̕񂪓Ȃ̂ŁAVOi͖ */
	q8tk_entry_set_text(parent->stat.combo.entry,
			    list_item->child->name);
	widget_signal_do(parent, "activate");
    }

    combo_fake_callback(NULL, parent);
}

/* R{̈ꗗ\{^}EXNbNA|bvAbvEChE */
static	void	combo_event_button_on(Q8tkWidget *widget)
{
    int selected = FALSE;
    Q8List *l;
    int scrolled = FALSE;
    int y_pos = widget->y + 1; /* |bvAbvEChE\ʒu */

    widget->stat.combo.popup_window = q8tk_window_new(Q8TK_WINDOW_POPUP);
    widget->stat.combo.popup_scrolled_window = NULL;
    widget->stat.combo.popup_list = q8tk_listbox_new();

    l = widget->stat.combo.list;		/* l->data  LIST ITEM */
    while (l) {
	q8tk_container_add(widget->stat.combo.popup_list,
			   (Q8tkWidget *)(l->data));

    /* Gg̈̕v郊XgACeAIԂƂB          */
    /* q8tk_listbox_select_child()̓VOîŃVOio^Oɏ */
	if (selected == FALSE) {		/* l->data->child  LABEL */
	    if (strcmp(widget->stat.combo.entry->name,
		       ((Q8tkWidget*)(l->data))->child->name) == 0) {
		q8tk_listbox_select_child(widget->stat.combo.popup_list,
					  (Q8tkWidget*)(l->data));
		selected = TRUE;
	    }
	}

	q8tk_signal_connect((Q8tkWidget *)(l->data), "select",
			    combo_event_list_callback, widget);
	l = l->next;
    }


    q8tk_widget_show(widget->stat.combo.popup_list);


#if 1
    if (widget->y + widget->stat.combo.nr_items + 2 <= (24+1)) {
	/* ɕ\ĂAʂ͂ݏoȂ (ʏ WINDOW )*/

	scrolled = FALSE;
	y_pos    = widget->y + 1;

    } else if (widget->y - widget->stat.combo.nr_items - 2 >= (0-1)) {
	/* 㕔ɕ\΁Aʂ͂ݏoȂ (ʏ WINDOW )*/

	scrolled = FALSE;
	y_pos    = widget->y - widget->stat.combo.nr_items - 2;

    } else {
	/* ǂɕ\ĂAʂ͂ݏo (SCROLLED WINDOW )*/

	if (widget->y <= 25/2) {	/* ̂قL̂ŁAɕ\ */
	    scrolled = TRUE;
	    y_pos    = widget->y + 1;
	} else {			/* 㕔̂قL̂ŁA㕔ɕ\ */
	    scrolled = TRUE;
	    y_pos    = 0-1;
	}
    }

    if (scrolled) {	/* SCROLLED WINDOW ̏ꍇ */
	int height;

	if (y_pos > widget->y) height = (24+1) - 2 - widget->y;	/*  */
	else                   height = widget->y - 2 +1;	/* 㕔 */
	if (height < 3) height = 3;		/* 肦ȂAÖ */

	widget->stat.combo.popup_scrolled_window = 
					q8tk_scrolled_window_new(NULL, NULL);
	q8tk_container_add(widget->stat.combo.popup_scrolled_window, 
			   widget->stat.combo.popup_list);

	/* ㉺ŁAANeBuITEM̕\ʒuςĂB} */
	q8tk_listbox_set_placement(widget->stat.combo.popup_list, +1, +1);

	q8tk_scrolled_window_set_policy(
				widget->stat.combo.popup_scrolled_window,
				Q8TK_POLICY_AUTOMATIC, Q8TK_POLICY_ALWAYS);

	if (widget->stat.combo.width) {
	    q8tk_misc_set_size(widget->stat.combo.popup_scrolled_window, 
			       widget->stat.combo.width +3, height);
	} else {
	    q8tk_misc_set_size(widget->stat.combo.popup_scrolled_window, 
			       widget->stat.combo.length +3, height);
	}

	q8tk_widget_show(widget->stat.combo.popup_scrolled_window);
	q8tk_container_add(widget->stat.combo.popup_window, 
			   widget->stat.combo.popup_scrolled_window);

    } else {		/* m[} WINDOW ̏ꍇ */

	q8tk_container_add(widget->stat.combo.popup_window, 
			   widget->stat.combo.popup_list);

    }

#else
		/* ʂ͂ݏoȎ́ASCROLLED WINDOW 𐶐 */
    if (widget->y + widget->stat.combo.nr_items + 2 > (24+1)) {

	int height = (24+1) - 2 - widget->y;
	if (height < 3) height = 3;

	widget->stat.combo.popup_scrolled_window = 
					q8tk_scrolled_window_new(NULL, NULL);
	q8tk_container_add(widget->stat.combo.popup_scrolled_window, 
			   widget->stat.combo.popup_list);

	q8tk_scrolled_window_set_policy(
				widget->stat.combo.popup_scrolled_window,
				Q8TK_POLICY_AUTOMATIC, Q8TK_POLICY_ALWAYS);

	if (widget->stat.combo.width) {
	    q8tk_misc_set_size(widget->stat.combo.popup_scrolled_window, 
			       widget->stat.combo.width +3, height);
	} else {
	    q8tk_misc_set_size(widget->stat.combo.popup_scrolled_window, 
			       widget->stat.combo.length +3, height);
	}

	q8tk_widget_show(widget->stat.combo.popup_scrolled_window);
	q8tk_container_add(widget->stat.combo.popup_window, 
			   widget->stat.combo.popup_scrolled_window);

    } else {	/* ʏ̓Vv WINDOW 𐶐 */

	q8tk_container_add(widget->stat.combo.popup_window, 
			   widget->stat.combo.popup_list);

    }
#endif

    q8tk_widget_show(widget->stat.combo.popup_window);
    q8tk_grab_add(widget->stat.combo.popup_window);
    q8tk_widget_set_focus(widget->stat.combo.popup_list);

    if (widget->stat.combo.width) {
	q8tk_misc_set_size(widget->stat.combo.popup_list,
			   widget->stat.combo.width, 0);
    }

    widget->stat.combo.popup_window->stat.window.set_position = TRUE;
    widget->stat.combo.popup_window->stat.window.x = 
		widget->x -1 -((widget->stat.combo.popup_scrolled_window)?1:0);
    widget->stat.combo.popup_window->stat.window.y = 
		y_pos;

    q8tk_signal_connect(widget->stat.combo.popup_window,
			"inactivate", combo_fake_callback,widget);


	/* ESC L[Xg邽߂́A_~[𐶐 */

    widget->stat.combo.popup_fake = q8tk_button_new();
    q8tk_signal_connect(widget->stat.combo.popup_fake, "clicked",
			combo_fake_callback, widget);

    widget->stat.combo.popup_accel_group = q8tk_accel_group_new();
    q8tk_accel_group_attach(widget->stat.combo.popup_accel_group,
			    widget->stat.combo.popup_window);
    q8tk_accel_group_add(widget->stat.combo.popup_accel_group, Q8TK_KEY_ESC,
			 widget->stat.combo.popup_fake, "clicked");
}

/* ^[EXy[XAꗗ\{^}EXNbNƓ*/
/* L[ꍇl */
static	void	combo_event_key_on(Q8tkWidget *widget, int key)
{
    if (key == Q8TK_KEY_RET || key == Q8TK_KEY_SPACE) {
	combo_event_button_on(widget);
    }

#ifdef	OLD_FOCUS_CHANGE
	/* DO NOTHING */
#else	/* VȃtH[JXړ */
    if (key == Q8TK_KEY_UP || key == Q8TK_KEY_DOWN) {
	combo_event_button_on(widget);
    }
#endif
}

/* Ggɓ͂ƂAVOi */
static	void	combo_event_entry_activate(UNUSED_WIDGET, Q8tkWidget *parent)
{
    widget_signal_do(parent, "activate");
}
static	void	combo_event_entry_changed(UNUSED_WIDGET, Q8tkWidget *parent)
{
    widget_signal_do(parent, "changed");
}


Q8tkWidget	*q8tk_combo_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_COMBO;
    w->sensitive = TRUE;

    w->key_up_used    = TRUE;
    w->key_down_used  = TRUE;

    w->stat.combo.entry  = q8tk_entry_new();
    w->stat.combo.list   = NULL;
    w->stat.combo.width  = 0;
    w->stat.combo.length = 0;

    w->stat.combo.entry->stat.entry.combo = w;

    q8tk_combo_set_editable(w, FALSE);
    q8tk_widget_show(w->stat.combo.entry);
    q8tk_signal_connect(w->stat.combo.entry, "activate",
			combo_event_entry_activate, w);
    q8tk_signal_connect(w->stat.combo.entry, "changed",
			combo_event_entry_changed, w);

    w->event_button_on = combo_event_button_on;
    w->event_key_on    = combo_event_key_on;

    return w;
}
void		q8tk_combo_append_popdown_strings(Q8tkWidget *combo, 
						  const char *entry_str,
						  const char *disp_str)
{
    int l0, l1, l2;
    Q8tkWidget *list_item;

    if (combo->stat.combo.list == NULL) {	/* Ôߏ */
	combo->stat.combo.length   = 0;
	combo->stat.combo.nr_items = 0;
    }

		/* 񒷂`FbN */

    if (entry_str == NULL) entry_str = "";
    if (disp_str  == NULL) disp_str  = entry_str;

    l0 = combo->stat.combo.length;
    l1 = (disp_str) ? q8gr_strlen(kanji_code, disp_str) : 0;
    l2 = q8gr_strlen(kanji_code, entry_str)
		+ ((combo->stat.combo.entry->stat.entry.editable) ? +1 : 0);

    combo->stat.combo.length = Q8TKMAX(Q8TKMAX(l0, l1), l2);


		/* xt LIST ITEM 𐶐Ã|C^Xgɕێ */

    list_item = q8tk_list_item_new_with_label(disp_str);
    q8tk_widget_show(list_item);
    q8tk_list_item_set_string(list_item, entry_str);

    combo->stat.combo.list = q8_list_append(combo->stat.combo.list, list_item);
    combo->stat.combo.nr_items ++;


		/* R{͕̓ɁA̕Zbg */

    q8tk_entry_set_text(combo->stat.combo.entry, entry_str);

    if (combo->stat.combo.width) {
	q8tk_misc_set_size(combo->stat.combo.entry,
			   combo->stat.combo.width, 0);
    } else {
	q8tk_misc_set_size(combo->stat.combo.entry,
			   combo->stat.combo.length, 0);
    }
}

#if 0
void		q8tk_combo_clear_popdown_strings(Q8tkWidget *combo, 
						 int start, int end)
{
    /* 쐬 */
}
#endif

const	char	*q8tk_combo_get_text(Q8tkWidget *combo)
{
    return combo->stat.combo.entry->name;
}

void		q8tk_combo_set_text(Q8tkWidget *combo, const char *text)
{
    q8tk_entry_set_text(combo->stat.combo.entry, text);
}

void		q8tk_combo_set_editable(Q8tkWidget *combo, int editable)
{
    q8tk_entry_set_editable(combo->stat.combo.entry, editable);
}




/*---------------------------------------------------------------------------
 * Xg{bNX (LIST BOX)
 *---------------------------------------------------------------------------
 *  E{bNX̂悤ȃEBWbgB
 *  E̎qĂB  AAXgACeȊO̎qĂ͂ȂB
 *  Eqɂ́Aq8tk_container_add() gpB
 *    q́Aq8tk_container_add() ĂяoԂɉ։ւƕłB
 *  EXgACêꂩIԂɂ邱ƂłB
 *    (IȂɂ邱Ƃł邪AIԂɂ邱Ƃ͂łȂ)
 *  EVOi
 *	"selection_change"	XgACe}EXNbNA
 *				ݑIԂƂȂĂ郊XgACe
 *				ω甭B
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_listbox_new(void)
 *	Xg{bNX̐B
 *
 *  void    q8tk_listbox_clear_items(Q8tkWidget *wlist, int start, int end)
 *	q̃XgACe폜B 
 *	XgACéAq8tk_container_add()Ăяo 0 ̔ԍ
 *	ÛŁA̔ԍŁA폜郊XgACew肷B
 *	end  start ꍇ́ASẴXgACe폜B
 *	폜XgACe͏ł̂Ōォėp邱Ƃ͂łȂB
 *	ŗpꍇ͂ЂƂ q8tk_container_remove() ɂč폜ׂB
 *
 *  void    q8tk_listbox_select_item(Q8tkWidget *wlist, int item)
 *	item ̔ԍ̃XgACeIԂɂ (VOi)B
 *
 *  void    q8tk_listbox_select_child(Q8tkWidget *wlist, Q8tkWidget *child)
 *	child ̃XgACeIԂɂ (VOi)B
 *
 *  void    q8tk_misc_set_size(Q8tkWidget *widget, int width, int height)
 *	Xg{bNX̕\TCY width w肷B height ͖B
 *
 *  void    q8tk_listbox_set_placement(Q8tkWidget *widget,
 *				       int top_pos, int left_pos)
 *	Xg{bNXXN[hEChE̎qłꍇAXg{bNX
 *	q̃XgACêAANeBuȂ̂XN[C悤
 *	\ʒu邪A̒ʒuw肷B
 *		top_pos ̏ꍇ́AANeBuȂ̂EChE㕔ɁA
 *		̏ꍇ́AANeBuȂ̂EChEɁA\
 *		悤ɒBl̐Βl傫ȂقǁAEChE
 *		ɕ\B
 *		left_pos ̏ꍇ́AXgACe̐擪Ȁꍇ́A
 *		XgACe̖\悤ɒBl̐Βl
 *		֌WȂB
 *		l 0 ̏ꍇ (ftHg) ́A -1 Ƃ݂ȂB(܂A
 *		EChEɃACe̖\悤ɒ)
 *  -------------------------------------------------------------------------
 *	yLIST BOXz [LIST ITEM]  [LABEL]	XgACe (ƁA
 *	   F		    			x) qɎ
 *	   F	       [LIST ITEM]  [LABEL]
 *	   F		    
 *	   Fc->      [LIST ITEM]  [LABEL]
 *	L[	    
 *	ɂ           [LIST ITEM]  [LABEL]
 *	ꂩ	    
 *	IԂ
 *	
 *	    ccc  Iꂽ LIST ITEM  }EXNbNꂽƂɂȂ
 *
 *
 *	Xg{bNXXN[hEChE̎qłꍇAXN[
 *	EChEɃtH[JXƒɃXg{bNXɃtH[JX
 *	ڂBɂAXg{bNX̓L[͂󂯂悤ɂȂB
 *
 *	L[͂ɂāA郊XgACeIꍇA
 *	̃XgACe}EXŃNbNꂽ̂ƓB
 *	
 *	q8tk_listbox_select_item() Aq8tk_listbox_select_child() 
 *	XgACeIꍇƂ͓삪ႤHHH
 *
 *---------------------------------------------------------------------------*/

static void list_scroll_adjust(Q8tkWidget *widget);

/* L[A̕擪ɂXgACeANeBuɂ  */
/* L[A㉺̃XgACeANeBuɂ                */
/* Xy[XE^[ÃXgACeI (VOi) */
static	void	list_event_key_on(Q8tkWidget *widget, int key)
{
    Q8tkWidget *w = widget->stat.listbox.active;

    if (w) {
	if (key <= 0xff &&
	    isgraph(key)) {	       /* Xy[XȊO͂̕ꂽꍇ */

	    Q8tkWidget *active = w;
	    for (;;) {		       /* ANeBuȃXgACe */
		w = w->next;	       /* ̃XgACéAq(x)   */
		if (w == NULL) {       /* 擪ƃL[͂̂v */
		    w = widget->child; /* TĂBXgACe */
		}		       /* ̎͐擪ɖ߂AׂĂT */

		if (w == active || w == NULL) break;   /* Ȃ΂߂ */

		if (w->child) {
		    if ((w->name        && w->name[0]        == key) ||
			(w->child->name && w->child->name[0] == key)) {
							/*       */
			widget->stat.listbox.active = w;/* ANeBu*/

			list_scroll_adjust(widget);	/* \ʒu𒲐 */
			break;
		    }
		}
	    }

	} else {		       /* Xy[X␧䕶͂ꂽꍇ */
	    switch (key) {

	    case Q8TK_KEY_RET:
	    case Q8TK_KEY_SPACE:
		(*w->event_button_on)(w);
		break;

	    case Q8TK_KEY_UP:
		if (w->prev) {
		    widget->stat.listbox.active = w->prev;
							/* 1OANeBu */
		    list_scroll_adjust(widget);		/* \ʒu𒲐 */
		}
		break;
	    case Q8TK_KEY_DOWN:
		if (w->next) {
		    widget->stat.listbox.active = w->next;
							/* 1ANeBu */
		    list_scroll_adjust(widget);		/* \ʒu𒲐 */
		}
		break;

	    case Q8TK_KEY_PAGE_UP:
		if (widget->parent &&
		    widget->parent->type == Q8TK_TYPE_SCROLLED_WINDOW &&
		    widget->parent->stat.scrolled.vscrollbar) {

		    int h = widget->parent->stat.scrolled.height -1;
		    if (widget->stat.scrolled.hscrollbar) h -= 3;
		    else                                  h -= 2;
		    for ( ; h>0; h--) {
			if (w->prev == NULL) break;
			w = w->prev;
		    }
		    widget->stat.listbox.active = w;
							/* 1őOANeBu */
		    list_scroll_adjust(widget);		/* \ʒu𒲐 */
		}
		break;
	    case Q8TK_KEY_PAGE_DOWN:
		if (widget->parent &&
		    widget->parent->type == Q8TK_TYPE_SCROLLED_WINDOW &&
		    widget->parent->stat.scrolled.vscrollbar) {

		    int h = widget->parent->stat.scrolled.height -1;
		    if (widget->stat.scrolled.hscrollbar) h -= 3;
		    else                                  h -= 2;
		    for ( ; h>0; h--) {
			if (w->next == NULL) break;
			w = w->next;
		    }
		    widget->stat.listbox.active = w;
							/* 1ŌANeBu */
		    list_scroll_adjust(widget);		/* \ʒu𒲐 */
		}
		break;
	    }
	}
    }
}



static void list_scroll_adjust(Q8tkWidget *widget)
{
    int i;
    Q8tkWidget *c;

    if (widget->parent &&
	widget->parent->type == Q8TK_TYPE_SCROLLED_WINDOW) {

	c = widget->child;
	for (i=0; c ;i++) {
	    if (c == widget->stat.listbox.active) break;
	    c = c->next;
	}

	if (i < widget->parent->stat.scrolled.child_y0) {
	    Q8TK_ADJUSTMENT(widget->parent->stat.scrolled.vadj)->value = i;
	}
	else if (i >=   widget->parent->stat.scrolled.child_y0
		      + widget->parent->stat.scrolled.child_sy) {
	    Q8TK_ADJUSTMENT(widget->parent->stat.scrolled.vadj)->value
				= i -widget->parent->stat.scrolled.child_sy +1;
	}
    }
    set_construct_flag(TRUE);
}





Q8tkWidget	*q8tk_listbox_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_LISTBOX;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->key_up_used    = TRUE;
    w->key_down_used  = TRUE;

    w->event_key_on = list_event_key_on;

    w->stat.listbox.selected = NULL;
    w->stat.listbox.active   = NULL;

    return w;
}

void		q8tk_listbox_clear_items(Q8tkWidget *wlist, int start, int end)
{
    int i, count;
    Q8tkWidget *wk, *c = wlist->child;

    if (c == NULL) return;
    if (start < 0) return;

    if (end < start) count = -1;
    else             count = end - start +1;

    for (i=0; i<start; i++) {			/* q LIST ITEM  start */
	if ((c = c->next) == NULL) return;	/* ڂ܂ŏɂǂ          */
    }
    while (count) {				/*  endڂ܂ł    */
	wk = c->next;				/* ؂藣                  */
	q8tk_container_remove(wlist, c);		/* LIST ITEM  LABEL*/
	q8tk_widget_destroy(c);				/* Cɍ폜  */
	if ((c = wk) == NULL) break;
	if (count > 0) count --;
    }

    set_construct_flag(TRUE);
}

static	/* LIST BOX Ɍq LIST ́A name  s Ɉv̂T */
Q8tkWidget	*q8tk_listbox_search_items(Q8tkWidget *wlist, const char *s)
{
    Q8tkWidget *c = wlist->child;

    for (;;) {
	if (c == NULL) return NULL;

	if (c->name &&
	    strcmp(c->name, s) == 0) return c;

	c = c->next;
    }
}

void		q8tk_listbox_select_item(Q8tkWidget *wlist, int item)
{
    int i;
    Q8tkWidget *c = wlist->child;

    if (c == NULL) return;

    if (item < 0) c = NULL;
    else {
	for (i=0; i<item; i++) {
	    if ((c = c->next) == NULL) break;
	}
    }

    q8tk_listbox_select_child(wlist, c);
}

void		q8tk_listbox_select_child(Q8tkWidget *wlist, Q8tkWidget *child)
{
    if (wlist->stat.listbox.selected != child) {
	wlist->stat.listbox.selected = child;
	wlist->stat.listbox.active   = child;
	widget_signal_do(wlist, "selection_changed");
	set_construct_flag(TRUE);
    }
    if (child) {
	widget_signal_do(child, "select");
	widget_scrollin_register(child);
    }
}

void		q8tk_listbox_set_placement(Q8tkWidget *widget,
					   int top_pos, int left_pos)
{
    widget->stat.listbox.scrollin_top  = top_pos;
    widget->stat.listbox.scrollin_left = left_pos;
}


/*
 * ͂ƓꏈB
 *	LIST BOX  SCROLLED WINDOW ̎q̏ꍇŁASCROLLED WINDOW ̃XN[
 *	o[(c) ꂽƂÅ֐Ă΂B
 *	ł́ASCROLLED WINDOW ̕\͈͂ɉāALIST BOX  active
 *	EBWbgύXĂB
 */
static	void	list_event_window_scrolled(Q8tkWidget *swin, int sy)
{
    Q8tkWidget *widget = swin->child;	/* == LISTBOX */

    Q8tkWidget *c = widget->child;
    int        nth = 0;

    if (c == NULL) return;

    while (c) {
	if (c == widget->stat.listbox.active) break;
	nth ++;
	c = c->next;
    }
    nth = nth - swin->stat.scrolled.vadj->stat.adj.value;

    if (0 <= nth && nth < sy) {
	/* Ok, No Adjust */
    } else {

	if (nth < 0) nth = swin->stat.scrolled.vadj->stat.adj.value;
	else         nth = swin->stat.scrolled.vadj->stat.adj.value + sy -1;

	c = widget->child;
	while (nth--) {
	    if ((c = c->next) == NULL) return;
	}
	widget->stat.listbox.active   = c;
	set_construct_flag(TRUE);

    }
}




/*---------------------------------------------------------------------------
 * XgACe (LIST ITEM)
 *---------------------------------------------------------------------------
 *  EXg{bNX̎qɂȂB
 *  EqĂB (AAxȊO̎qꍇ͖̓ۏ)
 *  Eqɂ́Aq8tk_container_add() gpB
 *  EɕێłB
 *  EVOi
 *	"select"	NbN (łɑIꂽԂł)
 *			ẽXg{bNXIԂƂĂ̂gŖ
 *			ꍇAɐe "selection_changed" Cxg𔭐
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_list_item_new(void)
 *	XgACe̐B
 *
 *  Q8tkWidget	*q8tk_list_item_new_with_label(const char *label)
 *	 label `ꂽXgACe̐B
 *	Iɂ́AXgACeƃxAeqɂB
 *
 *  void	q8tk_list_item_set_string(Q8tkWidget *w, const char *str)
 *	ɕ str ێB
 *  -------------------------------------------------------------------------
 *	[LIST BOX]  yLIST ITEMz [LABEL]	xqɎ
 *							éAXg{bNX
 *	   		    
 *	   F		    F
 *   "selection_change"     F
 *	   F		  "select"
 *	   Fcccccc   F
 *	ɐe	    F
 *	`d        {^őI
 *
 *---------------------------------------------------------------------------*/
/* XgACe}EXNbNAVOi */
static	void	list_item_event_button_on(Q8tkWidget *widget)
{
    if (widget->parent) {
	q8tk_widget_set_focus(widget->parent);

	if (widget->parent->stat.listbox.selected != widget) {
	    widget->parent->stat.listbox.selected = widget;
	    widget->parent->stat.listbox.active   = widget;

#if 0       /* ̂܂܂ƁAIԂ`悷ɂȂ */
	    widget_signal_do(widget->parent, "selection_changed");

#else	    /* IԂ`悳̂ŁACxgx点 */
	    set_delay_widget(widget, 6);	/* 6 t[x */
	    return;
#endif
	}
    }
    widget_signal_do(widget, "select");
    set_construct_flag(TRUE);
}

Q8tkWidget	*q8tk_list_item_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_LIST_ITEM;
    w->attr = Q8TK_ATTR_CONTAINER | Q8TK_ATTR_LABEL_CONTAINER;
    w->sensitive = TRUE;

    w->event_button_on = list_item_event_button_on;

    return w;
}

Q8tkWidget	*q8tk_list_item_new_with_label(const char *label)
{
    Q8tkWidget *i = q8tk_list_item_new();
    Q8tkWidget *l = q8tk_label_new(label);

    q8tk_widget_show(l);
    q8tk_container_add(i, l);

    i->with_label = TRUE;

    return i;
}

void		q8tk_list_item_set_string(Q8tkWidget *w, const char *str)
{
    if (w->name) free(w->name);
    w->name = (char *)malloc(strlen(str)+1);

    Q8tkAssert(w->name, "memory exhoused");

    strcpy(w->name, str);
    w->code = kanji_code;
}




/*---------------------------------------------------------------------------
 * x (LABEL)
 *---------------------------------------------------------------------------
 *  E(\p)ێł
 *  E܂܂ȃRei̎qɂȂB
 *  EVOi c 
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_label_new(const char *label)
 *	 label x̐B
 *
 *  void	q8tk_label_set(Q8tkWidget *w, const char *label)
 *	x̕ label ɕύXB
 *
 *  void	q8tk_label_set_reverse(Q8tkWidget *w, int reverse)
 *	x̔̕]\ݒ肷B reverse ^Ȃ甽]B
 *
 *  void	q8tk_label_set_color(Q8tkWidget *w, int foreground)
 *	x̐̕Fݒ肷BF foreground Őݒ肷Bl
 *	Q8GR_PALETTE_xxxx Ŏw肷B̒lȂAftHg̐Fɖ߂B
 *  -------------------------------------------------------------------------
 *	yLABELz			q͎ĂȂ
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_label_new(const char *label)
{
    Q8tkWidget *w;

    if (label == NULL) label = "";

    w = malloc_widget();
    w->type = Q8TK_TYPE_LABEL;
    w->name = (char *)malloc(strlen(label) + 1);
    w->sensitive = TRUE;

    Q8tkAssert(w->name, "memory exhoused");

    strcpy(w->name, label);
    w->code = kanji_code;

    w->stat.label.foreground = Q8GR_PALETTE_FOREGROUND;
    w->stat.label.background = Q8GR_PALETTE_BACKGROUND;
    w->stat.label.reverse    = FALSE;

    return w;
}
void		q8tk_label_set(Q8tkWidget *w, const char *label)
{
    if (label == NULL) label = "";

    if (w->name) free(w->name);
    w->name = (char *)malloc(strlen(label) + 1);

    Q8tkAssert(w->name, "memory exhoused");

    strcpy(w->name, label);
    w->code = kanji_code;

    set_construct_flag(TRUE);
}
void		q8tk_label_set_reverse(Q8tkWidget *w, int reverse)
{
    if (w->stat.label.reverse != reverse) {
	w->stat.label.reverse = reverse;
	set_construct_flag(TRUE);
    }
}
void		q8tk_label_set_color(Q8tkWidget *w, int foreground)
{
    if (foreground < 0) foreground = Q8GR_PALETTE_FOREGROUND;

    if (w->stat.label.foreground != foreground) {
	w->stat.label.foreground = foreground;
	set_construct_flag(TRUE);
    }
}


/*---------------------------------------------------------------------------
 * S (LOGO)
 *---------------------------------------------------------------------------
 *  E^CgS\ł(e,TCY͌Œ)
 *  E܂܂ȃRei̎qɂȂB
 *  EVOi c 
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_logo_new(void)
 *	S̐B
 *
 *  -------------------------------------------------------------------------
 *	yLOGOz			q͎ĂȂ
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_logo_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_LOGO;
    w->sensitive = TRUE;

    return w;
}


/*---------------------------------------------------------------------------
 * t[ (FRAME)
 *---------------------------------------------------------------------------
 *  EqЂƂĂB
 *  Eqɂ́Aq8tk_container_add() gpB
 *  E(o)ێłB
 *  EVOi c 
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_frame_new(const char *label)
 *	 label oɂt[̐B
 *  void       q8tk_frame_set_shadow_type(Q8tkWidget *frame, int shadow_type)
 *	t[̎ނݒłB
 *		Q8TK_SHADOW_NONE	ĝȂt[
 *		Q8TK_SHADOW_IN		Ŝւ񂾃t[
 *		Q8TK_SHADOW_OUT		Ŝオt[
 *		Q8TK_SHADOW_ETCHED_IN	gւ񂾃t[
 *		Q8TK_SHADOW_ETCHED_OUT	gオt[
 *  -------------------------------------------------------------------------
 *	yFRAMEz  [xxxx]		ȎqĂ
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_frame_new(const char *label)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_FRAME;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->stat.frame.shadow_type = Q8TK_SHADOW_OUT;

    w->name = (char *)malloc(strlen(label) + 1);

    Q8tkAssert(w->name, "memory exhoused");

    strcpy(w->name, label);
    w->code = kanji_code;

    return w;
}

void		q8tk_frame_set_shadow_type(Q8tkWidget *frame, int shadow_type)
{
    frame->stat.frame.shadow_type = shadow_type;
}




/*---------------------------------------------------------------------------
 * {bNX (HBOX)
 *---------------------------------------------------------------------------
 *  E̎qĂB
 *  Eqɂ́Aq8tk_box_pack_start() / _end ()gpB
 *  EVOi c 
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_hbox_new(void)
 *	{bNX̐B
 *  -------------------------------------------------------------------------
 *	yHBOXz [xxxx]		ȎqĂ
 *		      
 *		   [xxxx]
 *		      
 *		   [xxxx]
 *		      
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_hbox_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_HBOX;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    return w;
}




/*---------------------------------------------------------------------------
 * {bNX (VBOX)
 *---------------------------------------------------------------------------
 *  E̎qĂB
 *  Eqɂ́Aq8tk_box_pack_start() / _end ()gpB
 *  EVOi c 
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_vbox_new(void)
 *	{bNX̐B
 *  -------------------------------------------------------------------------
 *	yVBOXz [xxxx]		ȎqĂ
 *		      
 *		   [xxxx]
 *		      
 *		   [xxxx]
 *		      
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_vbox_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_VBOX;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    return w;
}




/*---------------------------------------------------------------------------
 * m[gubN (NOTE BOOK / NOTE PAGE)
 *---------------------------------------------------------------------------
 *  Ẽm[gy[WĂB
 *  Eem[gy[W̓ReiłAqĂB
 *  Eq8tk_notebook_append() ŎqA̓xɓŃm[gy[W𐶐
 *    ꂪqƂɂȂB
 *  ENOTE PAGE ́A(o)ێłB
 *  EVOi
 *	"switch_page"	ʂ̃y[Wɐ؂ւɔ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_notebook_new(void)
 *	m[g{bN̐
 *
 *  void	q8tk_notebook_append(Q8tkWidget *notebook,
 *				     Q8tkWidget *widget, const char *label)
 *	m[gubN noteboot  ɐVȃy[W쐬B
 *	̃y[W widget ǉBo̕ labelB
 *	Iɂ́Am[gy[WAeqɂłɁA
 *	m[gy[W wiget eqɂA
 *
 *  int	q8tk_notebook_current_page(Q8tkWidget *notebook)
 *	݂̃y[Wԍ擾B
 *	ȂAm[gubNɃy[WǉɁA0 ̔ԍUB
 *	Sy[WǉĂȂꍇ -1 B
 *
 *  void	q8tk_notebook_set_page(Q8tkWidget *notebook, int page_num)
 *	m[gubÑy[Ww肷(VOi)B
 *
 *  void	q8tk_notebook_next_page(Q8tkWidget *notebook)
 *	m[gubÑy[Włɂ(VOi)B
 *
 *  void	q8tk_notebook_prev_page(Q8tkWidget *notebook)
 *	m[gubÑy[WOłɂ(VOi)B
 *  -------------------------------------------------------------------------
 *	yNOTE BOOKzyNOTE PAGEz [xxxx]	m[gy[WqɎ
 *			      			Ƀm[gy[W
 *		       yNOTE PAGEz [xxxx]	ȎqĂ
 *			      
 *		       yNOTE PAGEz [xxxx]
 *			      
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_notebook_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_NOTEBOOK;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->stat.notebook.page = NULL;

    return w;
}

/* m[gy[W̃^O}EXNbNAVOi */
static	void	notepage_event_button_on(Q8tkWidget *widget)
{
    if ((widget->parent)->stat.notebook.page != widget) {
	(widget->parent)->stat.notebook.page = widget;
	widget_signal_do(widget->parent, "switch_page");

	/* m[gy[Wؑ֒́AtH[JX(A_[C)\Ȃ */
	/*    EEEȂƂȂA\JbRĈŁEEE */
	if ((widget->parent)->stat.notebook.lost_focus) {
	    q8tk_widget_set_focus(NULL);
	}

	set_construct_flag(TRUE);
    }
}

/* ^[EXy[XA}EXNbNƓ */
/* L[AÕy[Wł́A}EXNbNƓ */
static	void	notepage_event_key_on(Q8tkWidget *widget, int key)
{
    if (key == Q8TK_KEY_RET || key == Q8TK_KEY_SPACE) {
	notepage_event_button_on(widget);
    }

#ifdef	OLD_FOCUS_CHANGE
	/* DO NOTHING */
#else	/* VȃtH[JXړ */
    {
	Q8tkWidget *w = NULL;

	if (key == Q8TK_KEY_LEFT) {
	    if (widget->prev == NULL) {
		w = widget->next;
		if (w) {
		    while (w->next) {
			w = w->next;
		    }
		}
	    } else {
		w = widget->prev;
	    }
	}
	if (key == Q8TK_KEY_RIGHT) {
	    if (widget->next == NULL) {
		w = widget->prev;
		if (w) {
		    while (w->prev) {
			w = w->prev;
		    }
		}
	    } else {
		w = widget->next;
	    }
	}

	if (w) {
	    q8tk_widget_set_focus(w);
	    notepage_event_button_on(w);
	}
    }
#endif
}

void		q8tk_notebook_append(Q8tkWidget *notebook,
				     Q8tkWidget *widget, const char *label)
{
    Q8tkWidget *w;

    Q8tkAssert(notebook->type == Q8TK_TYPE_NOTEBOOK, NULL);

    w = malloc_widget();
    w->type = Q8TK_TYPE_NOTEPAGE;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->key_left_used  = TRUE;
    w->key_right_used = TRUE;

    w->name = (char *)malloc(strlen(label) + 1);

    Q8tkAssert(w->name, "memory exhoused");

    strcpy(w->name, label);
    w->code = kanji_code;

    if (notebook->child == NULL) {		/* ŏ NOTE PAGE ̏ꍇ*/
	notebook->stat.notebook.page = w;	/*  IԂɂ    */
    }
    q8tk_box_pack_start(notebook, w);		/* Rei BOXƓ */

    q8tk_container_add(w, widget);
    q8tk_widget_show(w);

    w->event_button_on = notepage_event_button_on;
    w->event_key_on    = notepage_event_key_on;
}

int		q8tk_notebook_current_page(Q8tkWidget *notebook)
{
    Q8tkWidget *child = notebook->child;
    int        i = 0;

    while (child) {
	if (child == notebook->stat.notebook.page) {
	    return i;
	}
	child = child->next;
	i++;
    }
    return -1;
}

void		q8tk_notebook_set_page(Q8tkWidget *notebook, int page_num)
{
    Q8tkWidget *child = notebook->child;
    int        i = 0;

    while (child) {
	if (i == page_num) {
	    if (notebook->stat.notebook.page != child) {
		q8tk_widget_set_focus(child);
		notepage_event_button_on(child);
	    }
	    break;
	} else {
	    child = child->next;
	    i++;
	}
    }
}

void		q8tk_notebook_next_page(Q8tkWidget *notebook)
{
    if (notebook->child) {
	Q8tkWidget *page = notebook->stat.notebook.page;
	if (page && page->next) {
	    q8tk_widget_set_focus(page->next);
	    notepage_event_button_on(page->next);
	}
    }
}

void		q8tk_notebook_prev_page(Q8tkWidget *notebook)
{
    if (notebook->child) {
	Q8tkWidget *page = notebook->stat.notebook.page;
	if (page && page->prev) {
	    q8tk_widget_set_focus(page->prev);
	    notepage_event_button_on(page->prev);
	}
    }
}

void		q8tk_notebook_hook_focus_lost(Q8tkWidget *notebook, 
					      int focus_lost)
{
    notebook->stat.notebook.lost_focus = focus_lost;
}



/*---------------------------------------------------------------------------
 * Zp[^ (VSEPARATOR)
 *---------------------------------------------------------------------------
 *  Eq͎ĂȂB
 *  EAeEBWbg̑傫ɂAIɕςB
 *  EVOi c Ȃ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_vseparator_new(void)
 *	Zp[^̐
 *  -------------------------------------------------------------------------
 *	yVSEPARATORz			q͎ĂȂ
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_vseparator_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_VSEPARATOR;
    w->sensitive = TRUE;

    return w;
}




/*---------------------------------------------------------------------------
 * Zp[^ (HSEPARATOR)
 *---------------------------------------------------------------------------
 *  Eq͎ĂȂB
 *  EAeEBWbg̑傫ɂAIɕςB
 *  EVOi c Ȃ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_hseparator_new(void)
 *	Zp[^̐
 *  -------------------------------------------------------------------------
 *	yVSEPARATORz			q͎ĂȂ
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_hseparator_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_HSEPARATOR;
    w->sensitive = TRUE;

    return w;
}




/*---------------------------------------------------------------------------
 * AWXgg (ADJUSTMENT)
 *---------------------------------------------------------------------------
 *  E\łȂ
 *  Eq͎ĂȂBqɂȂ邱ƂłȂB
 *  EXP[XN[hEChE𐶐ۂɁAKvƂȂB
 *    PƂł͎gp邱Ƃ͂ȂB
 *  EW(l͈̔)Ƒ(A傫2) A
 *    ɌB
 *  EXP[𐶐ꍇ́AOăAWXgg𐶐Ă̂
 *    ̂ʓIB
 *  EXN[hEChE𐶐ꍇ́A̎ɃAWXgg
 *    ̂ʓIB
 *  EVOi
 *	"value_changed"		lςɔ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_adjustment_new(int value, int lower, int upper,
 *				     int step_increment, int page_increment)
 *	AWXgg̐B
 *	l͈̔͂ lower ` upper Aݒl value A
 *	傫 step_increment A page_increment B
 *
 *  void  q8tk_adjustment_set_value(Q8tkWidget *adj, int value)
 *	AWXgǧݒlݒ肷BVOi͔ȂB
 *
 *  void  q8tk_adjustment_clamp_page(Q8tkWidget *adj, int lower, int upper)
 *	l͈̔͂ lower ` upper ɐݒ肵ȂB̎Aݒl͈͊Ȍꍇ
 *	őlȂŏlɐݒ肳BVOi͔ȂB
 *
 *  void  q8tk_adjustment_set_increment(Q8tkWidget *adj,
 *				        int step_increment, int page_increment)
 *	傫ƁAݒ肵ȂB
 *
 *  void	q8tk_adjustment_set_arrow(Q8tkWidget *adj, int arrow)
 *	arrow ^̏ꍇA\B
 *	ȂA󂪃NbNꂽꍇ } step_increment AB
 *	wiNbNꂽꍇ } page_increment AB
 *
 *  void	q8tk_adjustment_set_length(Q8tkWidget *adj, int length)
 *
 *   ------------------------------------------------------------------------
 *	yADJUSTMENTz			q͎ĂȂAqɂȂȂ
 *
 *---------------------------------------------------------------------------*/
/* AWXgg̒
   AWXgg}EXNbNAhbOۂɌĂяo */
enum {
    ADJ_STEP_DEC,
    ADJ_STEP_INC,
    ADJ_PAGE_DEC,
    ADJ_PAGE_INC,
    ADJ_SLIDER_DRAG
};
static	void	adjustment_do(Q8tkWidget *widget, int mode)
{
    Q8Adjust *adj = &widget->stat.adj;
    int value_old = adj->value;
    int repeat = TRUE;
    static int old = -1;	/* }EX{^ςȂɂɁA
				   XC_[s藈肷̂h */

    if (now_mouse_on == FALSE) old = -1;

    switch (mode) {
    case ADJ_STEP_DEC:
	adj->value -= adj->step_increment;
	if (adj->value < adj->lower) {
	    adj->value = adj->lower;
	    repeat = FALSE;
	}
	break;
    case ADJ_STEP_INC:
	adj->value += adj->step_increment;
	if (adj->value > adj->upper) {
	    adj->value = adj->upper;
	    repeat = FALSE;
	}
	break;
    case ADJ_PAGE_DEC:
	if (old == ADJ_PAGE_INC) {
	    mode = -1;
	    repeat = FALSE;
	    break;
	}
	adj->value -= adj->page_increment;
	if (adj->value < adj->lower) {
	    adj->value = adj->lower;
	    repeat = FALSE;
	}
	break;
    case ADJ_PAGE_INC:
	if (old == ADJ_PAGE_DEC) {
	    mode = -1;
	    repeat = FALSE;
	    break;
	}
	adj->value += adj->page_increment;
	if (adj->value > adj->upper) {
	    adj->value = adj->upper;
	    repeat = FALSE;
	}
	break;
    case ADJ_SLIDER_DRAG:
	set_drag_widget(widget);
	return;
    }

    if (value_old != adj->value) {
	widget_signal_do(widget, "value_changed");
	/* AWXgŁALISTBOX삳ꂽꍇ̗OtOON */
	adj->listbox_changed = TRUE;
    }
    set_construct_flag(TRUE);

    if (repeat) now_mouse_on = TRUE;
    else        now_mouse_on = FALSE;

    old = mode;
}

/* AWXgg̏ɂă}EXNbNAlVOi */
static	void	adjustment_event_button_on(Q8tkWidget *widget)
{
    Q8Adjust *adj = &widget->stat.adj;
    int slider_x, slider_y;
    int arrow_lower_x, arrow_lower_y;
    int arrow_upper_x, arrow_upper_y;
    int m_x = mouse.x / 8;
    int m_y = mouse.y / 16;

    if (adj->horizontal) {			/* HORIZONTAL ADJUSTMENT */

	slider_x = adj->x + adj->pos;
	slider_y = adj->y;

	if (m_y == slider_y) {

	    if (adj->arrow) {
		arrow_lower_x = adj->x;		slider_x ++;
		arrow_upper_x = adj->x + adj->length +1;

		if        (m_x == arrow_lower_x) {
		    adjustment_do(widget, ADJ_STEP_DEC);	return;
		} else if (m_x == arrow_upper_x) {
		    adjustment_do(widget, ADJ_STEP_INC);	return;
		}
	    }

	    if        (m_x == slider_x) {
		adjustment_do(widget, ADJ_SLIDER_DRAG);		return;
	    } else if (m_x < slider_x) {
		adjustment_do(widget, ADJ_PAGE_DEC);		return;
	    } else {
		adjustment_do(widget, ADJ_PAGE_INC);		return;
	    }

	} else {
	    return;
	}

    } else {					/* VIRTICAL ADJUSTMENT */

	slider_x = adj->x;
	slider_y = adj->y + adj->pos;

	if (m_x == slider_x) {

	    if (adj->arrow) {
		arrow_lower_y = adj->y;		slider_y ++;
		arrow_upper_y = adj->y + adj->length +1;
		if        (m_y == arrow_lower_y) {
		    adjustment_do(widget, ADJ_STEP_DEC);	return;
		} else if (m_y == arrow_upper_y) {
		    adjustment_do(widget, ADJ_STEP_INC);	return;
		}
	    }

	    if        (m_y == slider_y) {
		adjustment_do(widget, ADJ_SLIDER_DRAG);		return;
	    } else if (m_y < slider_y) {
		adjustment_do(widget, ADJ_PAGE_DEC);		return;
	    } else {
		adjustment_do(widget, ADJ_PAGE_INC);		return;
	    }

	} else {
	    return;
	}

    }
}

/* AWXgg̃XC_[hbOAlVOi */
static	void	adjustment_event_dragging(Q8tkWidget *widget)
{
    Q8Adjust *adj = &widget->stat.adj;
    int m_x = mouse.x / 8;
    int m_y = mouse.y / 16;
    int adj_x = adj->x;
    int adj_y = adj->y;
    int slider = -1;

    if (adj->upper <= adj->lower)  return;

    if (adj->horizontal) {
	if (adj->arrow) adj_x ++;
	if (adj_x <= m_x && m_x < adj_x+adj->length) {
	    slider = m_x - adj_x;
	}
    }else{
	if (adj->arrow) adj_y ++;
	if (adj_y <= m_y && m_y < adj_y+adj->length) {
	    slider = m_y - adj_y;
	}
    }

    if (slider >= 0) {
	float val0 = (slider -1) * adj->scale   + adj->lower;
	float val1 = (slider   ) * adj->scale   + adj->lower;
	int   val;

	if      (slider <= 0)             val = adj->lower;
	else if (slider >= adj->length-1) val = adj->upper;
	else {
	    float base = (float)(adj->upper-adj->lower) / (adj->length-1);
	    int   val2 = (int) ((int)(val1 / base) * base);
	    if (val0 < val2 && val2 <= val1) val =         val2;
	    else                             val = (int) ((val0 + val1) / 2);
	}

	if (adj->value != val) {
	    adj->value = val;
	    widget_signal_do(widget, "value_changed");
	    /* AWXgŁALISTBOX삳ꂽꍇ̗OtOON */
	    adj->listbox_changed = TRUE;
	}
	set_construct_flag(TRUE);
    }
}

/* J[\L[ȂǂA}EXNbNƓ */
static	void	adjustment_event_key_on(Q8tkWidget *widget, int key)
{
    Q8Adjust *adj = &widget->stat.adj;

    if (adj->horizontal) {			/* HORIZONTAL ADJUSTMENT */
	if      (key == Q8TK_KEY_LEFT)     adjustment_do(widget, ADJ_STEP_DEC);
	else if (key == Q8TK_KEY_RIGHT)    adjustment_do(widget, ADJ_STEP_INC);
    } else {					/* VIRTICAL ADJUSTMENT */
	if      (key == Q8TK_KEY_UP)       adjustment_do(widget, ADJ_STEP_DEC);
	else if (key == Q8TK_KEY_DOWN)     adjustment_do(widget, ADJ_STEP_INC);
	else if (key == Q8TK_KEY_PAGE_UP)  adjustment_do(widget, ADJ_PAGE_DEC);
	else if (key == Q8TK_KEY_PAGE_DOWN)adjustment_do(widget, ADJ_PAGE_INC);
    }

    /* J[\L[ςȂɂƁA
       }EX{^̉ςȂ̏ɑJڂĂ܂̂ŁAh */
    now_mouse_on = FALSE;
}

Q8tkWidget	*q8tk_adjustment_new(int value, int lower, int upper,
				     int step_increment, int page_increment)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_ADJUSTMENT;
    w->sensitive = TRUE;

    w->event_button_on = adjustment_event_button_on;
    w->event_dragging  = adjustment_event_dragging;
    w->event_key_on    = adjustment_event_key_on;

    w->stat.adj.value = value;
    w->stat.adj.lower = lower;
    w->stat.adj.upper = upper;
    w->stat.adj.step_increment = step_increment;
    w->stat.adj.page_increment = page_increment;

    return w;
}

void		q8tk_adjustment_set_value(Q8tkWidget *adj, int value)
{
    if (value < adj->stat.adj.lower) value = adj->stat.adj.lower;
    if (value > adj->stat.adj.upper) value = adj->stat.adj.upper;

    if (adj->stat.adj.value != value) {
	adj->stat.adj.value = value;
	/* ̃AWXgŁALISTBOX𑀍삷邱Ƃ͖nY
	  adj->stat.adj.listbox_changed = TRUE;
	*/

	/* VOi͔Ȃ */
	/*
	  widget_signal_do(adj, "value_changed");
	*/

	set_construct_flag(TRUE);
    }
}

void		q8tk_adjustment_clamp_page(Q8tkWidget *adj,
					   int lower, int upper)
{
    if (upper < lower) upper = lower;

    adj->stat.adj.lower = lower;
    adj->stat.adj.upper = upper;
    if (adj->stat.adj.value < adj->stat.adj.lower)
				adj->stat.adj.value = adj->stat.adj.lower;
    if (adj->stat.adj.value > adj->stat.adj.upper)
				adj->stat.adj.value = adj->stat.adj.upper;

    /* VOi͔Ȃ */

    set_construct_flag(TRUE);
}

void		q8tk_adjustment_set_arrow(Q8tkWidget *adj, int arrow)
{
    if (adj->stat.adj.arrow != arrow) {
	adj->stat.adj.arrow = arrow;
	set_construct_flag(TRUE);
    }
}

void		q8tk_adjustment_set_length(Q8tkWidget *adj, int length)
{
    if (adj->stat.adj.max_length != length) {
	adj->stat.adj.max_length = length;
	set_construct_flag(TRUE);
    }
}

void		q8tk_adjustment_set_increment(Q8tkWidget *adj,
					      int step_increment,
					      int page_increment)
{
    adj->stat.adj.step_increment = step_increment;
    adj->stat.adj.page_increment = page_increment;
}



/*---------------------------------------------------------------------------
 * XP[ (HSCALE)
 *---------------------------------------------------------------------------
 *  Enew()ɁAŃAWXggw肷B
 *    XP[̃W(͈)⑝́ÃAWXggɈˑB
 *  Enew()̈ NULL ̏ꍇ́AIɃAWXgg邪A
 *    ̎̃W 0`10 A 1  2 ɌŒłB(ύX\)
 *  Eq͎ĂȂ
 *  EVOi c ȂB
 *	AAWXgg̓VOi󂯂B
 *	AWXggꍇAǂăVOiZbgH
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_hscale_new(Q8tkWidget *adjustment)
 *	XP[𐶐B
 *	\ߍ쐬ς݂̃AWXgg adjustment w肷B 
 *	NULL ȂŎB
 *
 *  void	q8tk_scale_set_draw_value(Q8tkWidget *scale, int draw_value)
 *	draw_value ^ȂAݒlXC_[̉ɕ\B
 *
 *  void	q8tk_scale_set_value_pos(Q8tkWidget *scale, int pos)
 *	ݒl\ʒu߂B
 *		Q8TK_POS_LEFT	XC_[̍ɕ\
 *		Q8TK_POS_RIGHT	XC_[̉Eɕ\
 *		Q8TK_POS_TOP	XC_[̏ɕ\
 *		Q8TK_POS_BOTTOM	XC_[̉ɕ\
 *  -------------------------------------------------------------------------
 *	yHSCALEz				q͎ĂȂ
 *	     	yADJUSTMENTz
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_hscale_new(Q8tkWidget *adjustment)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_HSCALE;
    w->sensitive = TRUE;

    if (adjustment) {
	w->stat.scale.adj = adjustment;
    } else {
	w->stat.scale.adj = q8tk_adjustment_new(0, 0, 10, 1, 2);
    }

    w->stat.scale.adj->stat.adj.horizontal = TRUE;
    w->stat.scale.adj->parent = w;

    w->stat.scale.adj->key_up_used    = FALSE;
    w->stat.scale.adj->key_down_used  = FALSE;
    w->stat.scale.adj->key_left_used  = TRUE;
    w->stat.scale.adj->key_right_used = TRUE;

    return w;
}




/*---------------------------------------------------------------------------
 * XP[ (HSCALE)
 *---------------------------------------------------------------------------
 *  Enew()ɁAŃAWXggw肷B
 *    XP[̃W(͈)⑝́ÃAWXggɈˑB
 *  Enew()̈ NULL ̏ꍇ́AIɃAWXgg邪A
 *    ̎̃W 0`10 A 1  2 ɌŒłB(ύX\)
 *  Eq͎ĂȂ
 *  EVOi c ȂB
 *	AAWXgg̓VOi󂯂B
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_hscale_new(Q8tkWidget *adjustment)
 *	XP[𐶐B
 *	\ߍ쐬ς݂̃AWXgg adjustment w肷B 
 *	NULL ȂŎB
 *
 *  void	q8tk_scale_set_draw_value(Q8tkWidget *scale, int draw_value)
 *	XP[ƓB
 *
 *  void	q8tk_scale_set_value_pos(Q8tkWidget *scale, int pos)
 *	XP[ƓB
 *  -------------------------------------------------------------------------
 *	yVSCALEz				q͎ĂȂ
 *	     	yADJUSTMENTz
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_vscale_new(Q8tkWidget *adjustment)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_VSCALE;
    w->sensitive = TRUE;

    w->key_up_used    = TRUE;
    w->key_down_used  = TRUE;

    if (adjustment) {
	w->stat.scale.adj = adjustment;
    } else {
	w->stat.scale.adj = q8tk_adjustment_new(0, 0, 10, 1, 2);
    }

    w->stat.scale.adj->stat.adj.horizontal = FALSE;
    w->stat.scale.adj->parent = w;

    w->stat.scale.adj->key_up_used    = TRUE;
    w->stat.scale.adj->key_down_used  = TRUE;
    w->stat.scale.adj->key_left_used  = FALSE;
    w->stat.scale.adj->key_right_used = FALSE;

    return w;
}

void		q8tk_scale_set_value_pos(Q8tkWidget *scale, int pos)
{
    scale->stat.scale.value_pos = pos;
    set_construct_flag(TRUE);
}

void		q8tk_scale_set_draw_value(Q8tkWidget *scale, int draw_value)
{
    scale->stat.scale.draw_value = draw_value;
    set_construct_flag(TRUE);
}



/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * \̃TCYvZ (widget_size()Ă΂)
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static	void	adjustment_size(Q8Adjust *adj, int *sx, int *sy)
{
    int i, limit;
    int range = (adj->upper - adj->lower + 1);

    if (adj->horizontal) limit = (int) (Q8GR_SCREEN_X * 0.8);
    else                 limit = (int) (Q8GR_SCREEN_Y * 0.8);

    if (adj->max_length <= 2) {
	for (i=1; ; i++) if (range / i < limit) break;
	adj->length = range / i;
    } else {
	adj->length = adj->max_length;
    }
    adj->scale = (float)(range - 1) / (adj->length - 2);
    if      (adj->value == adj->lower) adj->pos = 0;
    else if (adj->value == adj->upper) adj->pos = adj->length-1;
    else {
	adj->pos = (int) ((adj->value - adj->lower) / adj->scale) + 1;
	if (adj->pos >= adj->length-1) adj->pos = adj->length-2;
    }

    if (adj->horizontal) {
	*sx = adj->length + ((adj->arrow) ? +2 : 0);
	*sy = 1;
    }else{
	*sx = 1;
	*sy = adj->length + ((adj->arrow) ? +2 : 0);
    }
}




/*---------------------------------------------------------------------------
 * XN[hEChE (SCROLLED WINDOW)
 *---------------------------------------------------------------------------
 *  Enew()ɁAŃAWXggw肷邪AXP[̃W(͈)
 *    ̃XN[hEChE̎q̑傫ɂāAIɕωB
 *     (͈p)
 *  Enew()̈ NULL ̏ꍇ́AIɃAWXggB
 *    ̎̑ 1  10 łB
 *    ɗRȂ΁ANULL ɂ鎩̕ȒPŕ֗łB
 *    ȂA̕Е NULL ɂƃoO肻ȗ\B
 *    Ȃ̂ŁA NULL ܂ ɃAWXggݒAƂ邱ƁB
 *  EqĂB
 *    (AAq⑷XN[EChE悤ȏꍇ͖̓ۏ)
 *  EVOi c Ȃ
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_scrolled_window_new(Q8tkWidget *hadjustment,
 *					  Q8tkWidget *vadjustment)
 *	XN[hEChE̐B
 *	\ߍ쐬ς݂̃AWXgg adjustment w肷B 
 *	NULL ȂŎB
 *
 *  void	q8tk_scrolled_window_set_policy(Q8tkWidget *scrolledw,
 *						int hscrollbar_policy,
 *						int vscrollbar_policy)
 *	XN[o[̕\@cEʂɐݒ肷B
 *		Q8TK_POLICY_ALWAYS	ɕ\
 *		Q8TK_POLICY_AUTOMATIC	\TCY傫ꍇ̂ݕ\
 *		Q8TK_POLICY_NEVER	\Ȃ
 *
 *  void	q8tk_misc_set_size(Q8tkWidget *widget, int width, int height)
 *	EChẼTCY width A height w肷B
 *  -------------------------------------------------------------------------
 *	ySCROLLED WINDOWz [xxxx]		ȎqĂ
 *		bb
 *		b	yADJUSTMENTz
 *			yADJUSTMENTz
 *
 *
 *
 *	ySCROLLED WINDOWz [LISTBOX]
 *
 *	XN[hEChE̎qXg{bNX̎A
 *	XN[hEChENbNƁAXg{bNX
 *	tH[JXݒ肳B܂AL[͂͑SăXg{bNXɓ`B
 *
 *---------------------------------------------------------------------------*/
/* EChE}EXNbN
   ̎qXg{bNX̏ꍇɌāAXg{bNXANeBuɂ */
static	void	scrolled_window_event_button_on(Q8tkWidget *widget)
{
    if (widget->child && widget->child->type == Q8TK_TYPE_LISTBOX) {
	q8tk_widget_set_focus(widget->child);
    }
}
Q8tkWidget	*q8tk_scrolled_window_new(Q8tkWidget *hadjustment,
					  Q8tkWidget *vadjustment)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_SCROLLED_WINDOW;
    w->attr = Q8TK_ATTR_CONTAINER;
    w->sensitive = TRUE;

    w->stat.scrolled.width  = 10;
    w->stat.scrolled.height = 10;
    w->stat.scrolled.hpolicy = Q8TK_POLICY_ALWAYS;
    w->stat.scrolled.vpolicy = Q8TK_POLICY_ALWAYS;
    w->stat.scrolled.hscrollbar = TRUE;
    w->stat.scrolled.vscrollbar = TRUE;

    if (hadjustment)
	w->stat.scrolled.hadj = hadjustment;
    else {
	w->stat.scrolled.hadj = q8tk_adjustment_new(0, 0, 7, 1, 10);
	w->with_label = TRUE; 
    }
    q8tk_adjustment_set_arrow(w->stat.scrolled.hadj, TRUE);
    q8tk_adjustment_set_length(w->stat.scrolled.hadj, 7);
    w->stat.scrolled.hadj->stat.adj.horizontal = TRUE;
    w->stat.scrolled.hadj->parent = w;
    w->stat.scrolled.hadj->key_up_used    = FALSE;
    w->stat.scrolled.hadj->key_down_used  = FALSE;
    w->stat.scrolled.hadj->key_left_used  = TRUE;
    w->stat.scrolled.hadj->key_right_used = TRUE;

    if (vadjustment)
	w->stat.scrolled.vadj = vadjustment;
    else {
	w->stat.scrolled.vadj = q8tk_adjustment_new(0, 0, 7, 1, 10);
	w->with_label = TRUE;
    }
    q8tk_adjustment_set_arrow(w->stat.scrolled.vadj, TRUE);
    q8tk_adjustment_set_length(w->stat.scrolled.vadj, 7);
    w->stat.scrolled.vadj->stat.adj.horizontal = FALSE;
    w->stat.scrolled.vadj->parent = w;
    w->stat.scrolled.vadj->key_up_used    = TRUE;
    w->stat.scrolled.vadj->key_down_used  = TRUE;
    w->stat.scrolled.vadj->key_left_used  = FALSE;
    w->stat.scrolled.vadj->key_right_used = FALSE;

    w->event_button_on = scrolled_window_event_button_on;

    return w;
}
void		q8tk_scrolled_window_set_policy(Q8tkWidget *scrolledw,
						int hscrollbar_policy,
						int vscrollbar_policy)
{
    scrolledw->stat.scrolled.hpolicy = hscrollbar_policy;
    scrolledw->stat.scrolled.vpolicy = vscrollbar_policy;

    if        (scrolledw->stat.scrolled.hpolicy == Q8TK_POLICY_ALWAYS) {
	scrolledw->stat.scrolled.hscrollbar = TRUE;
    } else if (scrolledw->stat.scrolled.hpolicy == Q8TK_POLICY_NEVER)  {
	scrolledw->stat.scrolled.hscrollbar = FALSE;
    }

    if        (scrolledw->stat.scrolled.vpolicy == Q8TK_POLICY_ALWAYS) {
	scrolledw->stat.scrolled.vscrollbar = TRUE;
    } else if (scrolledw->stat.scrolled.vpolicy == Q8TK_POLICY_NEVER)  {
	scrolledw->stat.scrolled.vscrollbar = FALSE;
    }

    set_construct_flag(TRUE);
}
#if 0
void		q8tk_scrolled_window_set_width_height(Q8tkWidget *w, 
						      int width, int height)
{
    w->stat.scrolled.width  = width;
    w->stat.scrolled.height = height;

    set_construct_flag(TRUE);
}
#endif






/*---------------------------------------------------------------------------
 * Gg[ (ENTRY)
 *---------------------------------------------------------------------------
 *  E̓͂\BAA ASCIÎ݁B\E폜͊
 *  Eq͎ĂȂB
 *  EVOi
 *	"activate"	^[L[͂ɔ
 *	"changed"	́A폜ɔ
 *  ------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_entry_new(void)
 *	Gg𐶐B͉\ȕ͖B
 *
 *  Q8tkWidget	*q8tk_entry_new_with_max_length(int max)
 *	Gg𐶐B ͉\ȕ́Amax ܂ŁB(max==0Ŗ)
 *
 *  void	q8tk_entry_set_text(Q8tkWidget *entry, const char *text)
 *	GgɁA text ݒ肷BVOi͔ȂB
 *	J[\͔\ƂȂA\ʒu͕擪ƂȂB
 *	AEBWbgANeBuҏW\ȏꍇAJ[\͕񖖒[
 *	ɈړAJ[\\悤ɕ\ʒuωB
 *
 *  void	q8tk_entry_set_position(Q8tkWidget *entry, int position)
 *	Gg̃̕J[\ʒu position ɐݒ肷B
 *	position == -1 ̏ꍇ́AJ[\͕\ȂB
 *	position 񖖔̏ꍇAJ[\͕񖖔ɕ\B
 *	J[\\ꍇAJ[\\悤ɕ\ʒuωB
 *
 *  void	q8tk_entry_set_max_length(Q8tkWidget *entry, int max)
 *	Ggɓ͉\ȕ max ɕύXB(max==0Ŗ)
 *
 *  void	q8tk_entry_set_editable(Q8tkWidget *entry, int editable)
 *	Gg͉̈̓Esݒ肷B editable  ^Ȃ͉B
 *
 *  void	q8tk_misc_set_size(Q8tkWidget *widget, int width, int height)
 *	Gg̕\TCY width w肷B height ͖B
 *	J[\\ꍇAJ[\\悤ɕ\ʒuωB
 *  -------------------------------------------------------------------------
 *	yENTRYz			q͎ĂȂ
 *
 *---------------------------------------------------------------------------*/
/*
 * strlen()̌ʂ strsize ł悤ȕZbg\ȃm
 */
static	void	q8tk_entry_malloc(Q8tkWidget *entry, int strsize)
{
#if 0
	/* strsize  1oCg]Ɋm ('\0' ̕]) */
    int malloc_size = strsize + 1;
#else
	/* 1oCgPʂłȂA512oCgPʂŊmۂ悤ɂĂ݂悤 */
    int malloc_size = (((strsize + 1)/512) +1) * 512;
#endif

    if (entry->name == NULL ||
	entry->stat.entry.malloc_length < malloc_size) {
	if (entry->name == NULL) {
	    entry->name = (char *)malloc(malloc_size);
	} else {
	    entry->name = (char *)realloc(entry->name, malloc_size);
	}

	Q8tkAssert(entry->name, "memory exhoused");

	entry->stat.entry.malloc_length = malloc_size;
    }
}

/* Gg}EXNbNAJ[\ړ (ҏW\̂) */
static	void	entry_event_button_on(Q8tkWidget *widget)
{
    int m_x = mouse.x / 8;

    if (widget->stat.entry.editable == FALSE) return;

    if (widget->stat.entry.cursor_pos < 0) {	/* J[\\Ȃ       */
						/* 񖖔ɃJ[\ړ */
	q8tk_entry_set_position(widget,
				q8gr_strlen(widget->code, widget->name));

    } else					/* J[\\Ȃ     */
    {						/* }EXʒuɃJ[\ړ */
	q8tk_entry_set_position(widget,		
				m_x - widget->x + widget->stat.entry.disp_pos);
    }
    set_construct_flag(TRUE);
}

/* L[AJ[\ړ           (ҏW\̂) */
/* L[AҏWAVOi (ҏW\̂) */
/* ^[AVOi               (ҏW\̂) */
static	void	entry_event_key_on(Q8tkWidget *widget, int key)
{
    if (widget->stat.entry.editable == FALSE) return;
    if (widget->stat.entry.cursor_pos < 0) return;

    switch (key) {
    case Q8TK_KEY_LEFT:
	if (widget->stat.entry.cursor_pos) {
	    q8tk_entry_set_position(widget, widget->stat.entry.cursor_pos - 1);
	}
	break;

    case Q8TK_KEY_RIGHT:
	{
	    int w = 1;
	    if (q8gr_strchk(widget->code, widget->name, 
			    widget->stat.entry.cursor_pos) == 1) { w = 2; }
	    q8tk_entry_set_position(widget, widget->stat.entry.cursor_pos + w);
	}
	break;

    case Q8TK_KEY_UP:
    case Q8TK_KEY_DOWN:
#ifdef	OLD_FOCUS_CHANGE
	/* DO NOTHING */
#else	/* VȃtH[JXړ */
	if (widget->stat.entry.combo) {
	    Q8List *l = widget->stat.entry.combo->stat.combo.list;
	    /* R{̔zɂꍇAŃR{̃XgJ */
	    while (l) {
		if (strcmp(widget->name,
			   ((Q8tkWidget*)(l->data))->child->name) == 0) {
		    if (key == Q8TK_KEY_UP) l = l->prev;
		    else                    l = l->next;
		    if (l) {
			q8tk_entry_set_text(widget,
					((Q8tkWidget*)(l->data))->child->name);
			widget_signal_do(widget, "activate");
			return;
		    } else {
			break;
		    }
		}
		l = l->next;
	    }
	    /* JΏۂȂ΁AXg̐擪()Zbg */
	    l = widget->stat.entry.combo->stat.combo.list;
	    if (l) {
		if (key == Q8TK_KEY_UP) l = q8_list_first(l);
		else                    l = q8_list_last(l);
		if (l) {
		    q8tk_entry_set_text(widget,
					((Q8tkWidget*)(l->data))->child->name);
		    widget_signal_do(widget, "activate");
		    return;
		}
	    }
	}
#endif
	if (key == Q8TK_KEY_UP)
	    q8tk_entry_set_position(widget, 0);
	else                   
	    q8tk_entry_set_position(widget,
				    q8gr_strlen(widget->code, widget->name));
	break;

    case Q8TK_KEY_PAGE_UP:
	q8tk_entry_set_position(widget, 0);
	break;

    case Q8TK_KEY_PAGE_DOWN:
	q8tk_entry_set_position(widget,
				q8gr_strlen(widget->code, widget->name));
	break;

    case Q8TK_KEY_RET:
	widget_signal_do(widget, "activate");
	break;

    case Q8TK_KEY_BS:
	if (widget->stat.entry.cursor_pos > 0) {
	    int w = q8gr_strdel(widget->code, widget->name,
				widget->stat.entry.cursor_pos - 1);
	    /* J[\1AɈړ */
	    q8tk_entry_set_position(widget, widget->stat.entry.cursor_pos - w);
	    widget_signal_do(widget, "changed");
	}
	break;

    case Q8TK_KEY_DEL:
	if (widget->stat.entry.cursor_pos < (int)q8gr_strlen(widget->code,
							     widget->name)) {
	    q8gr_strdel(widget->code, widget->name,
			widget->stat.entry.cursor_pos);
	    /* J[\̈ړ͕sv */
	    set_construct_flag(TRUE);
	    widget_signal_do(widget, "changed");
	}
	break;

    default:
	if (key <= 0xff && isprint(key)) {
	    int len = (int)strlen(widget->name) + 1;	/* 1oCgǉ */
	    if (widget->stat.entry.max_length &&	/* TCY */
		widget->stat.entry.max_length < len) {	/* 𒴂疳   */
		;
	    } else {
		q8tk_entry_malloc(widget, len);	/* ȂȂm */

		if (q8gr_stradd(widget->code, widget->name,
				widget->stat.entry.cursor_pos, key)) {
		    /* J[\1AEɈړ */
		    q8tk_entry_set_position(widget,
					    widget->stat.entry.cursor_pos + 1);
		    widget_signal_do(widget, "changed");
		}
	    }
	}
	break;
    }
}

Q8tkWidget	*q8tk_entry_new(void)
{
    return q8tk_entry_new_with_max_length(0);
}

Q8tkWidget	*q8tk_entry_new_with_max_length(int max)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_ENTRY;
    w->sensitive = TRUE;

    w->key_up_used    = TRUE;
    w->key_down_used  = TRUE;
    w->key_left_used  = TRUE;
    w->key_right_used = TRUE;

    q8tk_entry_malloc(w, max);

    w->name[0] = '\0';
    w->code = kanji_code;

    w->stat.entry.max_length    = max;
/*  w->stat.entry.malloc_length = q8tk_entry_malloc()ɂĐݒς */
    w->stat.entry.disp_pos      = 0;
    w->stat.entry.cursor_pos    = 0;
    w->stat.entry.width         = 8;
    w->stat.entry.editable      = TRUE;
    w->stat.entry.combo         = NULL;

    w->event_button_on = entry_event_button_on;
    w->event_key_on    = entry_event_key_on;

    return w;
}

const	char	*q8tk_entry_get_text(Q8tkWidget *entry)
{
    return entry->name;
}

void		q8tk_entry_set_text(Q8tkWidget *entry, const char *text)
{
    int len = strlen(text);

    if (entry->stat.entry.max_length == 0) {	/* Ȃ */

	q8tk_entry_malloc(entry, len);	/* ȂȂAm */
	strcpy(entry->name, text);

    } else {					/*  */

	q8gr_strncpy(entry->code,
		     entry->name, text, entry->stat.entry.max_length - 1);
	entry->name[ entry->stat.entry.max_length - 1 ] = '\0';

    }

    entry->stat.entry.disp_pos = 0;		/* 擪\ */
    q8tk_entry_set_position(entry, -1);		/* J[\\     */
}

void		q8tk_entry_set_position(Q8tkWidget *entry, int position)
{
    int disp_pos;
    int tail = q8gr_strlen(entry->code, entry->name);

    if (position < 0) {
	entry->stat.entry.cursor_pos = -1;
	set_construct_flag(TRUE);
	return;
    }

    if (tail < position) position = tail;
    if (q8gr_strchk(entry->code, entry->name, position) == 2) {
	position -= 1;
    }

	/* \͈͂OɃJ[\Zbg */
    if (position < entry->stat.entry.disp_pos) {

	entry->stat.entry.disp_pos   = position;
	entry->stat.entry.cursor_pos = position;

    }	/* \͈͂ɃJ[\Zbg */
    else if (entry->stat.entry.disp_pos + entry->stat.entry.width <= position){

	disp_pos = position - entry->stat.entry.width + 1;
	if (q8gr_strchk(entry->code, entry->name, disp_pos) == 2) {
	    disp_pos += 1;
	}
	entry->stat.entry.disp_pos   = disp_pos;
	entry->stat.entry.cursor_pos = position;

    }	/* \͈̖͂ (Sp2oCg)ɃJ[\Zbg */
    else if ((entry->stat.entry.disp_pos + entry->stat.entry.width - 1
								== position) &&
	     q8gr_strchk(entry->code, entry->name, position) == 1) {

	disp_pos = entry->stat.entry.disp_pos +1;
	if (q8gr_strchk(entry->code, entry->name, disp_pos) == 2) {
	    disp_pos += 1;
	}
	entry->stat.entry.disp_pos   = disp_pos;
	entry->stat.entry.cursor_pos = position;
    
    }	/* ȊO (\͈͓ɃJ[\Zbg) */
    else {

	entry->stat.entry.cursor_pos = position;

    }
    q8gr_set_cursor_blink();
    set_construct_flag(TRUE);
}

void		q8tk_entry_set_max_length(Q8tkWidget *entry, int max)
{
    q8tk_entry_malloc(entry, max);	/* ȂȂAm */

    entry->stat.entry.max_length = max;
}

void		q8tk_entry_set_editable(Q8tkWidget *entry, int editable)
{
    if (entry->stat.entry.editable != editable) {
	entry->stat.entry.editable = editable;
	set_construct_flag(TRUE);
    }
}





/*---------------------------------------------------------------------------
 * ANZ[^O[v (ACCEL GROUP)
 * ANZ[^[L[   (ACCEL KEY)
 *---------------------------------------------------------------------------
 *  Eq͎ĂȂA\łȂB
 *  EIɂ́AANZ[^O[veAANZ[^L[q
 *    `ԂƂ
 *  EANZ[^O[vEChEɊ֘AÂ邱ƂŁAANZ[^
 *    L[̃EChEɂėLɂ邱ƂłB
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_accel_group_new(void)
 *	ANZ[^O[v̐B
 *
 *  void	q8tk_accel_group_attach(Q8tkWidget *accel_group, 
 *					Q8tkWidget *window)
 *	ANZ[^O[vAEChE window Ɋ֘AÂB
 *
 *  void	q8tk_accel_group_detach(Q8tkWidget *accel_group, 
 *					Q8tkWidget *window)
 *	EChE window Ɋ֘AÂANZ[^O[v؂藣B
 *
 *  void	q8tk_accel_group_add(Q8tkWidget *accel_group, int accel_key,
 *				     Q8tkWidget *widget, const char *signal)
 *	ANZ[^L[ݒ肷B
 *	ANZ[^O[v accel_group ɁAL[ accel_key ݒ肷B
 *	̃L[ꂽA EBWbg widget  VOi signal 𑗂B
 *  -------------------------------------------------------------------------
 *	[WINDOW]
 *	   b
 *	   yACCEL GROUPzyACCEL KEYz
 *					
 *				  yACCEL KEYz
 *					
 *				  yACCEL KEYz
 *					
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_accel_group_new(void)
{
    Q8tkWidget *w;

    w = malloc_widget();
    w->type = Q8TK_TYPE_ACCEL_GROUP;
    w->sensitive = TRUE;

    return w;
}

void		q8tk_accel_group_attach(Q8tkWidget *accel_group,
					Q8tkWidget *window)
{
    Q8tkAssert(window->type == Q8TK_TYPE_WINDOW, NULL);
    window->stat.window.accel = accel_group;
}

void		q8tk_accel_group_detach(Q8tkWidget *accel_group,
					Q8tkWidget *window)
{
    Q8tkAssert(window->type == Q8TK_TYPE_WINDOW, NULL);

    if (window->stat.window.accel == accel_group) {
	window->stat.window.accel = NULL;
    }
}

void		q8tk_accel_group_add(Q8tkWidget *accel_group, int accel_key,
				     Q8tkWidget *widget, const char *signal)
{
    Q8tkWidget *w;
    w = malloc_widget();

    if (accel_group->child) {
	Q8tkWidget *c = accel_group->child;
	while (c->next) {
	    c = c->next;
	}
	c->next = w;
	w->prev = c;
	w->next = NULL;
    } else {
	accel_group->child = w;
	w->prev = NULL;
	w->next = NULL;
    }
    w->parent = accel_group;

    w->type = Q8TK_TYPE_ACCEL_KEY;
    w->sensitive = TRUE;
    w->name = (char *)malloc(strlen(signal) + 1);

    Q8tkAssert(w->name, "memory exhoused");

    strcpy(w->name, signal);
    w->code = Q8TK_KANJI_ANK;

    w->stat.accel.key    = accel_key;
    w->stat.accel.widget = widget;
}




/*---------------------------------------------------------------------------
 * _CAO (DIALOG)
 *---------------------------------------------------------------------------
 *  E_CAOEChEJB
 *		+-------------------+
 *		| WARING !          |
 *		| Quit, really?     |́̕Avbox ({bNX)
 *		| press button.     |
 *		| +------+ +------+ |
 *		| |  OK  | |CANCEL| |
 *		| +------+ +------+ |
 *		+-------------------+
 *		   ̕  
 *		     action_area ({bNX)
 *  E_CAO𐶐́A vbox  action_area ɔCӂ̃EBWbg
 *    ݒłBq8tk_box_pack_start() / end() ɂĐݒ肷B
 *  ẼEChE̓[_XȂ̂ŒӁB
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_dialog_new(void)
 *	_CAO̐B
 *
 *	Ő_CAO vbox ɃEBWbgǉꍇ̗B
 *		d = q8tk_dialog_new();
 *		q8tk_box_pack_start(Q8TK_DIALOGE(d)->vbox, label);
 *
 *	Ő_CAO action_area ɃEBWbgǉꍇ̗B
 *		d = q8tk_dialog_new();
 *		q8tk_box_pack_start(Q8TK_DIALOGE(d)->action_area, button);
 *  -------------------------------------------------------------------------
 *	    FccyDIALOGz
 *	    
 *	yWINDOWzyFRAMEzyVBOXzyVBOX(vbox)z
 *			 	                    
 *				             yHBOX(action_area)z
 *
 *	q8tk_dialog_new()̕Ԃl yWINDOWz ̃EBWbgłB
 *	[_ɂꍇ́ÃEBWbg q8tk_grab_add() B
 *
 *	vboxAaction_area ̓[UCӂɃEBWbgǉłB
 *
 *	q8tk_widget_destroy() ̍ۂ́ȂSẴEBWbg폜邪A
 *	[U vboxAaction_area ɒǉEBWbg͍폜ȂB
 *
 *---------------------------------------------------------------------------*/
Q8tkWidget	*q8tk_dialog_new(void)
{
    Q8tkWidget *dialog, *window, *vbox, *frame;

    dialog = malloc_widget();
    dialog->type = Q8TK_TYPE_DIALOG;
    dialog->sensitive = TRUE;

    window = q8tk_window_new(Q8TK_WINDOW_DIALOG);
    window->stat.window.work = dialog;

    frame = q8tk_frame_new("");
    q8tk_container_add(window, frame);
    q8tk_widget_show(frame);
    q8tk_frame_set_shadow_type(frame, Q8TK_SHADOW_NONE);

    vbox = q8tk_vbox_new();
    q8tk_container_add(frame, vbox);
    q8tk_widget_show(vbox);

    dialog->stat.dialog.vbox = q8tk_vbox_new();
    q8tk_box_pack_start(vbox, dialog->stat.dialog.vbox);
    q8tk_widget_show(dialog->stat.dialog.vbox);

    dialog->stat.dialog.action_area = q8tk_hbox_new();
    q8tk_box_pack_start(vbox, dialog->stat.dialog.action_area);
    q8tk_widget_show(dialog->stat.dialog.action_area);

    return window;
}




/*---------------------------------------------------------------------------
 * FILE SELECTION
 *---------------------------------------------------------------------------
 *  EEBWbggݍ킹āAt@CZNVoB
 *  Et@C̒́ApX܂߂čő
 *    Q8TK_MAX_FILENAME ܂łłB(I[\0܂)
 *  Et@C̈ꗗ́AVXeˑ֐ɂďB
 *  -------------------------------------------------------------------------
 *  Q8tkWidget	*q8tk_file_selection_new(const char *title, int select_ro)
 *	t@CZNV̐B
 *	o\p̕ title w肷B
 *	select_ro  1 ȂAuRead Onlyv`FbN{^\A`FbN
 *	B0 ȂAuRead Onlyv`FbN{^\邪A`FbN
 *	ȂB-1 ȂAuRead Onlyv`FbN{^͕\ȂB
 *	 (`FbNꂽǂ́A q8tk_file_selection_get_readonly ɂ
 *	  擾ł̂ŁAĂяoŃ[hI[ŊJǂ肷)
 *
 *  const char	*q8tk_file_selection_get_filename(Q8tkWidget *fselect)
 *	I()Ăt@C擾B
 *
 *  void	q8tk_file_selection_set_filename(Q8tkWidget *fselect,
 *						 const char *filename)
 *	t@C (fBNgł) w肷B
 *
 *  int		q8tk_file_selection_get_readonly(Q8tkWidget *fselect)
 *	^ ȂAu[hI[ŊJv`FbNĂB
 *  -------------------------------------------------------------------------
 *	    FccyFILE SELECTIONz
 *	    
 *	yWINDOWz
 *	
 *	yVBOXzyLABELz	q8tk_file_selection_new()̈
 *			  
 *		      yHSEPARATORz
 *			  
 *		      yLABELz	fBNg
 *			  
 *		      yHBOXzyLABELz ()
 *			  b	      
 *			  bb    ySCROLLED WINDOWzyLIST BOXz(A)
 *			  bb	      b    bb
 *			  bb	      bb    b  yADJUSTMENTz
 *			  bb	      bb      yADJUSTMENTz
 *			  bb	      b
 *			  bb    yLABELz ()
 *			  bb	      
 *			  bb    yVBOXzyLABELz ()
 *			  bb			  
 *			  bb		      yLABELz t@C
 *			  bb			  
 *			  bb		      yLABELz (܁~4)
 *			  bb			  
 *			  bb		      yBUTTONzyLABELz
 *			  bb			  b		(view_button)
 *			  bb			  b
 *			  bb		      yLABELz (܁~2)
 *			  bb			  
 *			  bb		      yCHECK BUTTONzyLABELz
 *			  bb			  b		      Read only
 *			  bb			  b
 *			  bb		      yBUTTONzyLABELz
 *			  bb			  b		(ok_button)
 *			  bb			  b
 *			  bb		      yBUTTONzyLABELz
 *			  bb					(cancel_button)
 *			  b
 *		      yLABELz	(s)
 *			  
 *		      yHBOXzyLABELz	Filename(o)
 *				      
 *				  yENTRYz	t@C
 *
 *	q8tk_file_selection_new() ̕Ԃl yWINDOWz ̃EBWbgłB
 *	[_ɂꍇ́ÃEBWbg q8tk_grab_add() B
 *
 *	cancel_buttonAok_button ̓[UCӂɃVOiݒłB
 *
 *		fsel = q8tk_file_selection_new();
 *		q8tk_widget_show(fsel);
 *		q8tk_grab_add(fsel);
 *		q8tk_signal_connect(Q8TK_FILE_SELECTION(fsel)->ok_button,
 *		 		    "clicked", [U֐A[U);
 *		q8tk_signal_connect(Q8TK_FILE_SELECTION(fsel)->cancel_button,
 *		 		    "clicked", [U֐A[U);
 *
 *	---------------------------------------------------------------------
 *		(A)  yLIST ITEMzyLABELz
 *		     	   
 *		       yLIST ITEMzyLABELz
 *		     	   
 *		       yLIST ITEMzyLABELz
 *		     	   
 *
 *	q8tk_file_selection_set_filename() ɂăfBNgZbgƁA
 *	̃fBNg̃t@Cꗗ擾A(̏̓VXeˑ)A
 *	SẴt@CXgACeɂāAXg{bNXɏ悹B
 *	t@CZbgꍇAfBNg؂o
 *	(̏VXeˑ)AlɃfBNg̃t@Cꗗ𐶐
 *	B̏ꍇAGgɂt@CZbgB
 *
 *	---------------------------------------------------------------------
 *	ȉ̏ꍇAok_button  "clicked" VOiB
 *		EOK ̃{^NbNꍇ
 *		Et@Cꗗ̃XgACéAANeBuȂ̂NbN
 *		  ꂪfBNgłȂꍇB
 *		EGgɂē͂ă^[L[A
 *		  ꂪfBNgłȂꍇB
 *
 *	܂Aok_button  "clicked" VOiݒ肵Ă΁A
 *	ʓIȑɂt@CI()młB
 *
 *	---------------------------------------------------------------------
 *	q8tk_widget_destroy() ̍ۂ́AׂẴEBWbgj󂷂B
 *	(s萔 LIST ITEM ECWbg܂)
 *
 *---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------
 *	ȉ̊֐̈ fselect  q8tk_file_selection_new() ̖߂ĺA
 *	EChEEBWbgłBt@CZNVEBWbg̕ϐ
 *	(fselect->stat.fselect.ϐ) ɃANZXɂ́Aȉ̂悤ɂB
 *	Q8TK_FILE_SELECTION((Q8tkWidget*)fselect)->ϐ
 *---------------------------------------------------------------------------*/

/* t@CZNṼXg{bNX̃XgACeNbNꂽꍇ

   EOɑIĂXg{bNXƈႤ̂NbNꂽꍇ
	fsel_list_selection_changed() ("selection_changed"Cxgɂ)
	fsel_item_selected()          ("select"           Cxgɂ)
     ̏ɌĂяoB

   EOɑIĂXg{bNXƓ̂NbNꂽꍇ
	fsel_item_selected()          ("select"           Cxgɂ)
     ĂяoB ("selection_changed" Cxg͔Ȃ̂)     */


static void fsel_update(Q8tkWidget *fselect, const char *filename, int type);
static int fsel_opendir(Q8tkWidget *fselect, const char *filename, int type);


/* t@Cꗗ LIST BOX ɂāAI𒆂̃t@Cς̃R[obN */
static void fsel_selection_changed_callback(UNUSED_WIDGET, void *fselect)
{
    Q8TK_FILE_SELECTION((Q8tkWidget*)fselect)->selection_changed = TRUE;
}


/* t@C LIST ITEM ɂāA NbÑR[obN */
static void fsel_selected_callback(Q8tkWidget *item, void *fselect)
{
    const char *name;
    if      (item->name)                       name = item->name;
    else if (item->child && item->child->name) name = item->child->name;
    else                                       name = "";


    if (Q8TK_FILE_SELECTION((Q8tkWidget*)fselect)->selection_changed) {

	/* O fsel_selection_changed_callback() ĂяoĂꍇA
	   ܂wOƂ͈ႤxXgACeNbNꂽꍇ́A
	   ̃XgACe̕ێt@CAGgɃZbg */

	Q8TK_FILE_SELECTION((Q8tkWidget*)fselect)->selection_changed = FALSE;

	q8tk_entry_set_text(Q8TK_FILE_SELECTION((Q8tkWidget*)fselect)
						      ->selection_entry, name);

    } else {

	/*  fsel_selected_callback() ĂяoꂽꍇA
	   ܂wOƓxXgACeNbNꂽꍇ́A
	   ̃XgACe̕ێt@CŁAt@CꗗXV */

	fsel_update((Q8tkWidget*)fselect, name, item->stat.any.data[0]);
    }
}


/* t@C͂ ENTRY ɂāA^[L[̃R[obN */
static void fsel_activate_callback(Q8tkWidget *entry, void *fselect)
{
    const char *input_filename = q8tk_entry_get_text(entry);
    int   type = -1;	/* fBNgǂ͕s */

    /* ͂t@CAXg name Ɉv΁A
       t@C^Cvm肷邱ƂłB
       (Ċm肳Kv͂Ȃ̂ŁAKɈv`FbN) */

    Q8tkWidget *match_list;
    match_list = q8tk_listbox_search_items(
			 Q8TK_FILE_SELECTION((Q8tkWidget*)fselect)->file_list,
			 input_filename);

    if (match_list) type = match_list->stat.any.data[0];


    /* ͂t@CŁAt@CꗗXV */
    fsel_update((Q8tkWidget*)fselect, input_filename, type);
}


/* t@Cꗗ LIST BOX XVB fBNgȂ\XVA
   t@Cm肵ꍇ́AOK {^Ƃɂ */
static void fsel_update(Q8tkWidget *fselect, const char *filename, int type)
{
    char wk[ Q8TK_MAX_FILENAME ];

    if (osd_path_join(Q8TK_FILE_SELECTION(fselect)->pathname, filename,
		      wk, Q8TK_MAX_FILENAME) == FALSE) {
	strcpy(wk, "");
    }

    if (fsel_opendir(fselect, wk, type) != FILE_STAT_DIR) {
	widget_signal_do(Q8TK_FILE_SELECTION(fselect)->ok_button, "clicked");
    }
}


/* w肳ꂽpXAfBNgƃt@CɕA fBNgJ
   XgɃt@CꗗZbgA t@CGgɃZbg */
static int fsel_opendir_sub(Q8tkWidget *fselect, const char *dirname);
static int fsel_opendir(Q8tkWidget *fselect, const char *filename, int type)
{
    int save_code = q8tk_set_kanjicode(osd_kanji_code());

    char path[ Q8TK_MAX_FILENAME ];
    char dir [ Q8TK_MAX_FILENAME ];
    char file[ Q8TK_MAX_FILENAME ];


    if (filename == NULL || filename[0] == '\0') { /* filenameȏꍇ */
	filename = osd_dir_cwd();		   /* JgfBNg */
	type = FILE_STAT_DIR;			   /* ɎgƂɂ */
    }

    if (osd_path_normalize(filename, path, Q8TK_MAX_FILENAME)	/* K */
							== FALSE) {
	strcpy(path, "");
	type = FILE_STAT_DIR;
    }


		/* filename fBNgƃt@Cɕ */

    if (type < 0) {				/* fBNgǂs */
	type = osd_file_stat(path);		/* ȂA܂͑擾   */
    }

    if (type == FILE_STAT_DIR) {		/* filename ̓fBNg */
	strcpy(dir,  path);
	strcpy(file, "");				/* t@C͋ */

    } else {					/* filename ̓t@C炵 */
						/* fBNgƕ  */
	if (osd_path_split(path, dir, file, Q8TK_MAX_FILENAME) == FALSE) {
	    strcpy(dir,  "");				/* s     */
	    strcpy(file, path);				/* Kɂ܂ */
	}
    }

		/* fBNgŃfBNgJ */

    if (fsel_opendir_sub(fselect, dir) >= 0) {		/* Ĵɐ */

	Q8TK_FILE_SELECTION(fselect)->pathname[0] = '\0';
	strncat(Q8TK_FILE_SELECTION(fselect)->pathname, dir,
		Q8TK_MAX_FILENAME-1);

	q8tk_entry_set_text(Q8TK_FILE_SELECTION(fselect)->selection_entry,
			    file);
    } else {						/* JȂcc */

	q8tk_entry_set_text(Q8TK_FILE_SELECTION(fselect)->selection_entry,
			    path);
    }


    q8tk_set_kanjicode(save_code);

		/* w肳ꂽpXfBNgǂԂ */
    return type;
}


static	int	fsel_opendir_sub(Q8tkWidget *fselect, const char *dirname)
{
    T_DIR_INFO	*dirp;
    T_DIR_ENTRY	*dirent;
    char	wk[ Q8TK_MAX_FILENAME ];
    int		nr, i, width;
    char	old_path[ Q8TK_MAX_FILENAME ];
    char	*old_dirname = NULL;

		/*  LIST ITEM 폜 */

    if (Q8TK_FILE_SELECTION(fselect)->file_list->child) {
	q8tk_listbox_clear_items(Q8TK_FILE_SELECTION(fselect)->file_list,0,-1);
    }
    q8tk_adjustment_set_value(Q8TK_FILE_SELECTION(fselect)->scrolled_window
						      ->stat.scrolled.hadj, 0);
    q8tk_adjustment_set_value(Q8TK_FILE_SELECTION(fselect)->scrolled_window
						      ->stat.scrolled.vadj, 0);


		/* fBNg𒲂ׁAt@C LIST ITEM Ƃēo^ */
		/* ANZX\ȃt@C LIST ITEM ɕێĂ */
		/* łȂ̂ŁAt@C̃^Cv LIST ITEM ɕێĂ */

    if (dirname[0] != '\0' &&
	(dirp = osd_opendir(dirname))) {

	/* pXʃpXƃfBNgɕB
	   ̏ʃpXƁÃpXv΁A
	   ̕fBNgoĂ */
	if (Q8TK_FILE_SELECTION(fselect)->pathname[0] != '\0' &&
	    osd_path_split(Q8TK_FILE_SELECTION(fselect)->pathname,
			   wk,
			   old_path,
			   Q8TK_MAX_FILENAME)) {
	    if (strcmp(wk, dirname) == 0) {
		old_dirname = old_path;
	    }
	}

	nr = 0;
	while ((dirent = osd_readdir(dirp))) {
	    Q8tkWidget *item;

	    wk[0] = '\0';
	    strncat(wk, dirent->str, Q8TK_MAX_FILENAME-1);

	    item = q8tk_list_item_new_with_label(wk);
	    q8tk_list_item_set_string(item, dirent->name);
	    item->stat.any.data[0] = dirent->type;
	    q8tk_container_add(Q8TK_FILE_SELECTION(fselect)->file_list, item);
	    q8tk_widget_show(item);

	    /* ofBNgɈvACe΁AANeBu */
	    if (old_dirname && (strcmp(old_dirname, dirent->name) == 0)) {
		q8tk_listbox_select_child(
				Q8TK_FILE_SELECTION(fselect)->file_list, item);
		old_dirname = NULL;
	    }

	    q8tk_signal_connect(item, "select",
				fsel_selected_callback, fselect);
	    nr ++;
	}
	osd_closedir(dirp);


	i = strlen(dirname);
	width = Q8TK_FILE_SELECTION(fselect)->width;
	if (i + 6 > width) {			/* 6 == sizeof("DIR = ") */
	    i = i - (width - 6 -3);		/* 3 == sizeof("...")    */
	    if (q8gr_strchk(Q8TK_FILE_SELECTION(fselect)->dir_name->code, 
			    dirname, i) == 2) { i ++; }	/* ̓r͔*/
	} else {
	    i = 0;
	}
	wk[0] = '\0';
	strncat(wk, "DIR = ", Q8TK_MAX_FILENAME-1);
	if (i) {
	    strncat(wk, "...", Q8TK_MAX_FILENAME-1 -strlen(wk));
	}
	strncat(wk, &dirname[i], Q8TK_MAX_FILENAME-1 -strlen(wk));


    } else {

	nr = -1;

	wk[0] = '\0';
	strncat(wk, "DIR = non existant", Q8TK_MAX_FILENAME-1);

    }

    q8tk_label_set(Q8TK_FILE_SELECTION(fselect)->dir_name, wk);

    sprintf(wk, "%4d file(s)", (nr < 0) ? 0 : nr);
    q8tk_label_set(Q8TK_FILE_SELECTION(fselect)->nr_files, wk);


    return nr;
}




static void fsel_selection_view_callback(UNUSED_WIDGET, void *fselect)
{
    q8tk_utility_view(q8tk_file_selection_get_filename(fselect));
}



#if 0	/* ver 0.5.x ܂ł̕\` */

Q8tkWidget	*q8tk_file_selection_new(const char *title, int select_ro)
{
    Q8tkWidget *fselect, *window, *vbox, *wk;
    int save_code;

    fselect = malloc_widget();
    fselect->type = Q8TK_TYPE_FILE_SELECTION;
    fselect->sensitive = TRUE;

    fselect->stat.fselect.pathname = (char *)calloc(Q8TK_MAX_FILENAME, 1);
    fselect->stat.fselect.filename = (char *)calloc(Q8TK_MAX_FILENAME, 1);
    Q8tkAssert(fselect->stat.fselect.pathname, "memory exhoused");
    Q8tkAssert(fselect->stat.fselect.filename, "memory exhoused");

    window = q8tk_window_new(Q8TK_WINDOW_DIALOG);	/* EChE */
    window->stat.window.work = fselect;

    vbox = q8tk_vbox_new();				/* ȉ ɋl߂ */
    q8tk_container_add(window, vbox);
    q8tk_widget_show(vbox);

    wk = q8tk_label_new(title);				/* o() */
    q8tk_box_pack_start(vbox, wk);
    q8tk_widget_show(wk);
    q8tk_misc_set_placement(wk, Q8TK_PLACEMENT_X_CENTER, Q8TK_PLACEMENT_Y_TOP);
    fselect->stat.fselect.width = MAX(q8gr_strlen(wk->code, wk->name),
				      Q8GR_SCREEN_X * 0.5);
  
    wk = q8tk_hseparator_new();				/* ---------------- */
    q8tk_box_pack_start(vbox, wk);
    q8tk_widget_show(wk);
							/* DIR = /...       */
    fselect->stat.fselect.dir_name = q8tk_label_new("DIR =");
    q8tk_box_pack_start(vbox, fselect->stat.fselect.dir_name);
    q8tk_widget_show(fselect->stat.fselect.dir_name);
    q8tk_misc_set_placement(fselect->stat.fselect.dir_name,
			    Q8TK_PLACEMENT_X_LEFT, Q8TK_PLACEMENT_Y_TOP);

							/*     99 file(s)   */
    fselect->stat.fselect.nr_files = q8tk_label_new("0 file(s)");
    q8tk_box_pack_start(vbox, fselect->stat.fselect.nr_files);
    q8tk_widget_show(fselect->stat.fselect.nr_files);
    q8tk_misc_set_placement(fselect->stat.fselect.nr_files,
			    Q8TK_PLACEMENT_X_CENTER, Q8TK_PLACEMENT_Y_TOP);

							/* [Xg{bNX] */
    fselect->stat.fselect.scrolled_window=q8tk_scrolled_window_new(NULL, NULL);
    q8tk_box_pack_start(vbox, fselect->stat.fselect.scrolled_window);
    q8tk_widget_show(fselect->stat.fselect.scrolled_window);

    fselect->stat.fselect.file_list = q8tk_listbox_new();
    q8tk_container_add(fselect->stat.fselect.scrolled_window,
		       fselect->stat.fselect.file_list);
    q8tk_widget_show(fselect->stat.fselect.file_list);
    q8tk_signal_connect(fselect->stat.fselect.file_list, "selection_changed",
			fsel_selection_changed_callback, window);

    q8tk_misc_set_placement(fselect->stat.fselect.scrolled_window,
			    Q8TK_PLACEMENT_X_CENTER, Q8TK_PLACEMENT_Y_CENTER);
    q8tk_scrolled_window_set_policy(fselect->stat.fselect.scrolled_window,
				    Q8TK_POLICY_AUTOMATIC, Q8TK_POLICY_ALWAYS);
    q8tk_misc_set_size(fselect->stat.fselect.scrolled_window, 40, 14);
    q8tk_misc_set_size(fselect->stat.fselect.file_list, 40-3, 0);
    q8tk_listbox_set_placement(fselect->stat.fselect.file_list, -2, +1);

							/* File name:       */
    wk = q8tk_label_new("File name:");
    q8tk_box_pack_start(vbox, wk);
    q8tk_widget_show(wk);
    q8tk_misc_set_placement(wk, Q8TK_PLACEMENT_X_LEFT, Q8TK_PLACEMENT_Y_TOP);

							/* [Gg]     */
    save_code = q8tk_set_kanjicode(osd_kanji_code());
    fselect->stat.fselect.selection_entry = q8tk_entry_new();
    q8tk_box_pack_start(vbox, fselect->stat.fselect.selection_entry);
    q8tk_widget_show(fselect->stat.fselect.selection_entry);
    q8tk_misc_set_size(fselect->stat.fselect.selection_entry,
		       fselect->stat.fselect.width, 0);
    q8tk_signal_connect(fselect->stat.fselect.selection_entry, "activate",
			fsel_activate_callback, window);
    q8tk_set_kanjicode(save_code);

    wk = q8tk_hbox_new();				/*     [OK][CANCEL] */
    q8tk_box_pack_start(vbox, wk);
    q8tk_widget_show(wk);
    q8tk_misc_set_placement(wk, Q8TK_PLACEMENT_X_RIGHT, Q8TK_PLACEMENT_Y_TOP);

    fselect->stat.fselect.ro_button =
				q8tk_check_button_new_with_label("Read only");
    q8tk_box_pack_start(wk, fselect->stat.fselect.ro_button);
    if (select_ro >= 0) {
	if (select_ro > 0) {
	    q8tk_toggle_button_set_state(fselect->stat.fselect.ro_button,TRUE);
	}
	q8tk_widget_show(fselect->stat.fselect.ro_button);
    }
    q8tk_misc_set_placement(fselect->stat.fselect.ro_button,
			    Q8TK_PLACEMENT_X_CENTER, Q8TK_PLACEMENT_Y_CENTER);

    fselect->stat.fselect.ok_button = q8tk_button_new_with_label("  OK  ");
    q8tk_box_pack_start(wk, fselect->stat.fselect.ok_button);
    q8tk_widget_show(fselect->stat.fselect.ok_button);

    fselect->stat.fselect.cancel_button = q8tk_button_new_with_label("CANCEL");
    q8tk_box_pack_start(wk, fselect->stat.fselect.cancel_button);
    q8tk_widget_show(fselect->stat.fselect.cancel_button);

/*  q8tk_file_selection_set_filename(window, Q8TK_FILE_SELECTION(fselect)->pathname);*/

    return window;
}

#else	/* ver 0.6.0 ȍ~̕\` */

Q8tkWidget	*q8tk_file_selection_new(const char *title, int select_ro)
{
    Q8tkWidget *fselect, *window, *vbox, *hbox, *vv, *wk;
    int i, save_code;

    fselect = malloc_widget();
    fselect->type = Q8TK_TYPE_FILE_SELECTION;
    fselect->sensitive = TRUE;

    fselect->stat.fselect.pathname = (char *)calloc(Q8TK_MAX_FILENAME, 1);
    fselect->stat.fselect.filename = (char *)calloc(Q8TK_MAX_FILENAME, 1);
    Q8tkAssert(fselect->stat.fselect.pathname, "memory exhoused");
    Q8tkAssert(fselect->stat.fselect.filename, "memory exhoused");

    window = q8tk_window_new(Q8TK_WINDOW_DIALOG);	/* EChE */
    window->stat.window.work = fselect;

    vbox = q8tk_vbox_new();				/* ȉ ɋl߂ */
    q8tk_container_add(window, vbox);
    q8tk_widget_show(vbox);

    wk = q8tk_label_new(title);				/* o() */
    q8tk_box_pack_start(vbox, wk);
    q8tk_widget_show(wk);
    q8tk_misc_set_placement(wk, Q8TK_PLACEMENT_X_CENTER, Q8TK_PLACEMENT_Y_TOP);
    fselect->stat.fselect.width = MAX(q8gr_strlen(wk->code, wk->name), 60);
  
    wk = q8tk_hseparator_new();				/* ---------------- */
    q8tk_box_pack_start(vbox, wk);
    q8tk_widget_show(wk);
							/* DIR = /...       */
    fselect->stat.fselect.dir_name = q8tk_label_new("DIR =");
    q8tk_box_pack_start(vbox, fselect->stat.fselect.dir_name);
    q8tk_widget_show(fselect->stat.fselect.dir_name);
    q8tk_misc_set_placement(fselect->stat.fselect.dir_name,
			    Q8TK_PLACEMENT_X_LEFT, Q8TK_PLACEMENT_Y_TOP);

    hbox = q8tk_hbox_new();
    q8tk_box_pack_start(vbox, hbox);
    q8tk_widget_show(hbox);
    {
	wk = q8tk_label_new("    ");				/*  */
	q8tk_box_pack_start(hbox, wk);
	q8tk_widget_show(wk);

								/* [Xg] */
	fselect->stat.fselect.scrolled_window
					= q8tk_scrolled_window_new(NULL, NULL);
	q8tk_box_pack_start(hbox, fselect->stat.fselect.scrolled_window);
	q8tk_widget_show(fselect->stat.fselect.scrolled_window);

	fselect->stat.fselect.file_list = q8tk_listbox_new();
	q8tk_container_add(fselect->stat.fselect.scrolled_window,
			   fselect->stat.fselect.file_list);
	q8tk_widget_show(fselect->stat.fselect.file_list);
	q8tk_signal_connect(fselect->stat.fselect.file_list,
			    "selection_changed",
			    fsel_selection_changed_callback, window);

	q8tk_misc_set_placement(fselect->stat.fselect.scrolled_window,
				Q8TK_PLACEMENT_X_CENTER,
				Q8TK_PLACEMENT_Y_CENTER);
	q8tk_scrolled_window_set_policy(fselect->stat.fselect.scrolled_window,
					Q8TK_POLICY_AUTOMATIC,
					Q8TK_POLICY_ALWAYS);
	q8tk_misc_set_size(fselect->stat.fselect.scrolled_window, 40, 18);
	q8tk_misc_set_size(fselect->stat.fselect.file_list, 40-3, 0);
	q8tk_listbox_set_placement(fselect->stat.fselect.file_list, -2, +1);


	wk = q8tk_label_new("  ");				/*  */
	q8tk_box_pack_start(hbox, wk);
	q8tk_widget_show(wk);


	vv = q8tk_vbox_new();
	q8tk_box_pack_start(hbox, vv);
	q8tk_widget_show(vv);
	{

	    wk = q8tk_label_new("");				/* s */
	    q8tk_box_pack_start(vv, wk);
	    q8tk_widget_show(wk);

								/* n file(s) */
	    fselect->stat.fselect.nr_files = q8tk_label_new("0000 file(s)");
	    q8tk_box_pack_start(vv, fselect->stat.fselect.nr_files);
	    q8tk_widget_show(fselect->stat.fselect.nr_files);
	    q8tk_misc_set_placement(fselect->stat.fselect.nr_files,
				    Q8TK_PLACEMENT_X_CENTER,
				    Q8TK_PLACEMENT_Y_CENTER);
#if 0
	    for (i=0; i<9; i++) {				/* s */
		wk = q8tk_label_new("");
		q8tk_box_pack_start(vv, wk);
		q8tk_widget_show(wk);
	    }
#else
	    for (i=0; i<4; i++) {				/* s */
		wk = q8tk_label_new("");
		q8tk_box_pack_start(vv, wk);
		q8tk_widget_show(wk);
	    }
								/* [VIEW] */
	    fselect->stat.fselect.view_button =
					q8tk_button_new_with_label(" VIEW ");
	    q8tk_box_pack_start(vv, fselect->stat.fselect.view_button);
	    q8tk_widget_show(fselect->stat.fselect.view_button);
	    q8tk_misc_set_placement(fselect->stat.fselect.view_button,
				    Q8TK_PLACEMENT_X_CENTER,
				    Q8TK_PLACEMENT_Y_CENTER);
	    q8tk_signal_connect(fselect->stat.fselect.view_button,  "clicked",
				fsel_selection_view_callback, window);

	    for (i=0; i<2; i++) {				/* s */
		wk = q8tk_label_new("");
		q8tk_box_pack_start(vv, wk);
		q8tk_widget_show(wk);
	    }
#endif

								/* Read only */
	    fselect->stat.fselect.ro_button =
				q8tk_check_button_new_with_label("Read only");
	    q8tk_box_pack_start(vv, fselect->stat.fselect.ro_button);
	    q8tk_misc_set_placement(fselect->stat.fselect.ro_button,
				    Q8TK_PLACEMENT_X_CENTER,
				    Q8TK_PLACEMENT_Y_CENTER);
	    if (select_ro >= 0) {
		if (select_ro > 0) {
		    q8tk_toggle_button_set_state(
					fselect->stat.fselect.ro_button, TRUE);
		}
		q8tk_widget_show(fselect->stat.fselect.ro_button);
	    }

								/* [OK] */
	    fselect->stat.fselect.ok_button = 
					q8tk_button_new_with_label("  OK  ");
	    q8tk_box_pack_start(vv, fselect->stat.fselect.ok_button);
	    q8tk_widget_show(fselect->stat.fselect.ok_button);
	    q8tk_misc_set_placement(fselect->stat.fselect.ok_button,
				    Q8TK_PLACEMENT_X_CENTER,
				    Q8TK_PLACEMENT_Y_CENTER);

								/* [CANCEL] */
	    fselect->stat.fselect.cancel_button =
					q8tk_button_new_with_label("CANCEL");
	    q8tk_box_pack_start(vv, fselect->stat.fselect.cancel_button);
	    q8tk_widget_show(fselect->stat.fselect.cancel_button);
	    q8tk_misc_set_placement(fselect->stat.fselect.cancel_button,
				    Q8TK_PLACEMENT_X_CENTER,
				    Q8TK_PLACEMENT_Y_CENTER);
	}

#if 0
	wk = q8tk_label_new(" ");				/*  */
	q8tk_box_pack_start(hbox, wk);
	q8tk_widget_show(wk);
#endif
    }


    wk = q8tk_label_new("");				/* s */
    q8tk_box_pack_start(vbox, wk);
    q8tk_widget_show(wk);

    hbox = q8tk_hbox_new();
    q8tk_box_pack_start(vbox, hbox);
    q8tk_widget_show(hbox);
    {
							/* File name:       */
	wk = q8tk_label_new("Filename ");
	q8tk_box_pack_start(hbox, wk);
	q8tk_widget_show(wk);

							/* [Gg]     */
	save_code = q8tk_set_kanjicode(osd_kanji_code());
	fselect->stat.fselect.selection_entry = q8tk_entry_new();
	q8tk_box_pack_start(hbox, fselect->stat.fselect.selection_entry);
	q8tk_widget_show(fselect->stat.fselect.selection_entry);
	q8tk_misc_set_size(fselect->stat.fselect.selection_entry, 50, 0);
	q8tk_signal_connect(fselect->stat.fselect.selection_entry, "activate",
			    fsel_activate_callback, window);
	q8tk_set_kanjicode(save_code);
    }

/*  q8tk_file_selection_set_filename(window, Q8TK_FILE_SELECTION(fselect)->pathname);*/

    return window;
}

#endif

const	char	*q8tk_file_selection_get_filename(Q8tkWidget *fselect)
{
    if (osd_path_join(Q8TK_FILE_SELECTION(fselect)->pathname,
		      q8tk_entry_get_text(Q8TK_FILE_SELECTION(fselect)
							->selection_entry),
		      Q8TK_FILE_SELECTION(fselect)->filename,
		      Q8TK_MAX_FILENAME)
	== FALSE) {
	return "";
    }

    return Q8TK_FILE_SELECTION(fselect)->filename;
}

void		q8tk_file_selection_set_filename(Q8tkWidget *fselect,
						 const char *filename)
{
    fsel_opendir(fselect, filename, -1);
}

int		q8tk_file_selection_get_readonly(Q8tkWidget *fselect)
{
    return Q8TK_TOGGLE_BUTTON(Q8TK_FILE_SELECTION(fselect)->ro_button)->active;
}




/*---------------------------------------------------------------------------
 * FILE VIEWER
 *---------------------------------------------------------------------------
 *  EōAt@CƂ݂郆[eBeB
 *  EeLXgt@C̔f́Agq̂
 *    SJIS  EUC  UTF8 Bɔf
 *  ÊɂƂ̂Ƃ悤ccc
 *    ƂAo悭ȂCzȂΏccc
 *  EȂ݂ɃEBWbgł͂ȂAȂt@C\B
 *---------------------------------------------------------------------------*/
#define	VIEW_MAX_LINE	(1000)				/* 1000s\ */
#define	VIEW_MAX_COLUMN	(80)				/* 80ȍ~͔\ */
static	Q8tkWidget	*view_widget_win;
static	Q8tkWidget	*view_widget_vbox;
static	Q8tkWidget	*view_widget_swin;
static	Q8tkWidget	*view_widget_board;
static	Q8tkWidget	*view_widget_quit;
static	Q8tkWidget	*view_widget_accel;
static	Q8tkWidget	*view_string[ VIEW_MAX_LINE ];
static	int		view_string_cnt;

static	void	q8tk_utility_view_end(UNUSED_WIDGET, UNUSED_PARM);
int		q8tk_utility_view(const char *filename)
{
    int save_code, file_code, file_text;
    OSD_FILE *fp;
    Q8tkWidget *w, *swin, *x, *b, *z;

    if (filename == NULL || *filename == '\0' ||
	osd_file_stat(filename) != FILE_STAT_FILE) {
	return 0;
    }

    fp = osd_fopen(FTYPE_READ, filename, "rb");

    if (fp == NULL) {
	return 0;
    }

    {
	int l = strlen(filename);
	if (l >= 4 && ((filename[l-4] == '.') &&
		       (filename[l-3] == 'T' || filename[l-3] == 't') &&
		       (filename[l-2] == 'X' || filename[l-2] == 'x') &&
		       (filename[l-1] == 'T' || filename[l-1] == 't'))) {
	    file_text = TRUE;
	} else {
	    file_text = FALSE;
	}
    }

    if (file_text == FALSE) {		/* oCit@C */

	file_code = Q8TK_KANJI_ANK;

    } else {				/* eLXgt@C */
					/* t@C擪 1KB KɌ  */
	int  sz;			/* R[h𔻒BقƂɓK */
	char buf[1024];

	sz = (int)osd_fread(buf, sizeof(char), sizeof(buf), fp);
	if (osd_fseek(fp, 0, SEEK_SET) == -1) {
	    osd_fclose(fp);
	    return 0;
	}
	file_code = q8gr_strcode(buf, sz);
    }



    {						/* CƂȂEChE */
	w = q8tk_window_new(Q8TK_WINDOW_DIALOG);
	view_widget_accel = q8tk_accel_group_new();
	q8tk_accel_group_attach(view_widget_accel, w);
    }
    {						/* Ƀ{bNX悹 */
	x = q8tk_vbox_new();
	q8tk_container_add(w, x);
	q8tk_widget_show(x);
							/* {bNXɂ     */
	{						/* SCRLEChE */
	    swin  = q8tk_scrolled_window_new(NULL, NULL);
	    q8tk_widget_show(swin);
	    q8tk_scrolled_window_set_policy(swin, Q8TK_POLICY_AUTOMATIC,
						  Q8TK_POLICY_AUTOMATIC);
	    q8tk_misc_set_size(swin, 78, 20);
	    q8tk_box_pack_start(x, swin);
	}
	{						/* I{^zu */
	    b = q8tk_button_new_with_label(" O K ");
	    q8tk_box_pack_start(x, b);
	    q8tk_widget_show(b);

	    q8tk_misc_set_placement(b, Q8TK_PLACEMENT_X_CENTER,
				       Q8TK_PLACEMENT_Y_CENTER);
	    q8tk_signal_connect(b, "clicked", q8tk_utility_view_end, NULL);

	    q8tk_accel_group_add(view_widget_accel, Q8TK_KEY_ESC,
				 b, "clicked");
	}
    }

    {							/* SCRLEChE */
	z = q8tk_vbox_new();				/* VBOX     */
	q8tk_container_add(swin, z);
	q8tk_widget_show(z);

	save_code = q8tk_set_kanjicode(file_code);	/* t@Ce   */
    							/* xƂĔzu */
	{
	    int c1, c2;
	    int column, line;
	    int end_of_line, end_of_file;
	    char src[ VIEW_MAX_COLUMN + 1 ];

	    c2 = osd_fgetc(fp);

	    line = 0;
	    end_of_file = FALSE;
	    memset(src, 0, sizeof(src));

	    while (end_of_file == FALSE) {

		if (file_text) {		/* eLXgt@C */
		    column = 0;
		    end_of_line = FALSE;
		    memset(src, 0, sizeof(src));

		    while (end_of_line == FALSE) {

			c1 = c2;
			c2 = osd_fgetc(fp);
			if (c1 == '\r' &&  c2 == '\n') c2 = osd_fgetc(fp);

			if (c1 == EOF) {
			    c1 = '\0';
			    end_of_line = TRUE;
			    end_of_file = TRUE;
			}
			else if ((c1 == '\r') || (c1 == '\n')) {
			    c1 = '\0';
			    end_of_line = TRUE;
			}

			
			if (c1 == '\t') {			/* ^uu */
			    int len = q8gr_strlen(file_code, src);
			    int pad = ((len + 8) / 8) * 8 - len;
			    int i;
			    for (i=0; i<pad; i++) {
				if (column < (int)sizeof(src)-1) {
				    src[ column ] = ' ';
				    column ++;
				}
			    }
			}
			else if (column < (int)sizeof(src)-1) {	/* ^uȊO */
			    src[ column ] = c1;
			    column ++;
			}
		    }

		} else {			/* oCit@C */
		    int c[16];
		    char fmt[128];

		    if (c2 == EOF) {
			strcpy(src, "[EOF]");
			end_of_file = TRUE;
		    } else {
			for (column = 0; column < 16 && c2 != EOF; column ++) {
			    c[column] = c2;
			    c2 = osd_fgetc(fp);
			}

			strcpy(fmt, "%04X : ");
			while (column--) { strcat(fmt, "%02X "); }

			sprintf(src, fmt, line * 0x10,
				c[ 0], c[ 1], c[ 2], c[ 3],
				c[ 4], c[ 5], c[ 6], c[ 7],
				c[ 8], c[ 9], c[10], c[11],
				c[12], c[13], c[14], c[15]);
		    }
		}


		if (line == COUNTOF(view_string)-1)
		    strcpy(src, "........To be continued.");

		view_string[ line ] = q8tk_label_new(src);
		q8tk_widget_show(view_string[ line ]);
		q8tk_box_pack_start(z, view_string[ line ]);

		line ++;
		if (line >= COUNTOF(view_string)) break;
	    }

	    view_string_cnt = line;
	}
	q8tk_set_kanjicode(save_code);
    }

    osd_fclose(fp);


    q8tk_widget_show(w);
    q8tk_grab_add(w);

    q8tk_widget_set_focus(b);


    view_widget_win   = w;	/* _CAOƂɔ */
    view_widget_vbox  = x;	/* EBWbgoĂ܂     */
    view_widget_swin  = swin;
    view_widget_board = z;
    view_widget_quit  = b;

    return 1;
}

static	void	q8tk_utility_view_end(UNUSED_WIDGET, UNUSED_PARM)
{
    int i;
    for (i=0; i<view_string_cnt; i++)
	q8tk_widget_destroy(view_string[ i ]);

    q8tk_widget_destroy(view_widget_quit);
    q8tk_widget_destroy(view_widget_board);
    q8tk_widget_destroy(view_widget_swin);
    q8tk_widget_destroy(view_widget_vbox);

    q8tk_grab_remove(view_widget_win);
    q8tk_widget_destroy(view_widget_win);
    q8tk_widget_destroy(view_widget_accel);
}




/************************************************************************/
/* Gȏ								*/
/************************************************************************/

/*---------------------------------------------------------------------------
 * \ʒu̕ύX
 *---------------------------------------------------------------------------
 *  EHBOXAVBOX̎q̃EBWbĝݗLB͖ ()
 *  -------------------------------------------------------------------------
 *  void	q8tk_misc_set_placement(Q8tkWidget *widget,
 *					int placement_x, int placement_y)
 *---------------------------------------------------------------------------*/
void	q8tk_misc_set_placement(Q8tkWidget *widget,
				int placement_x, int placement_y)
{
    widget->placement_x = placement_x;
    widget->placement_y = placement_y;
}

/*---------------------------------------------------------------------------
 * \TCY̕ύX
 *---------------------------------------------------------------------------
 *  Eȉ̃EBWbĝݗLB͖ ()
 *	COMBO		c 񕔕̕\
 *	LIST		c ̕\
 *	SCROLLED WINDOW	c EChE̕A
 *	ENTRY		c ̕\
 *  -------------------------------------------------------------------------
 *  void	q8tk_misc_set_size(Q8tkWidget *widget, int width, int height)
 *---------------------------------------------------------------------------*/
void	q8tk_misc_set_size(Q8tkWidget *widget, int width, int height)
{
    switch (widget->type) {

    case Q8TK_TYPE_COMBO:
	if (width > 0) {
	    widget->stat.combo.width = width;
	    q8tk_misc_set_size(widget->stat.combo.entry,
			       widget->stat.combo.width, 0);
	} else {
	    widget->stat.combo.width = 0;
	    q8tk_misc_set_size(widget->stat.combo.entry,
			       widget->stat.combo.length, 0);
	}
	break;

    case Q8TK_TYPE_LISTBOX:
	if (width > 0) widget->stat.listbox.width = width;
	else           widget->stat.listbox.width = 0;
	break;

    case Q8TK_TYPE_SCROLLED_WINDOW:
	widget->stat.scrolled.width  = width;
	widget->stat.scrolled.height = height;

	if (widget->with_label) {
	    q8tk_adjustment_set_increment(widget->stat.scrolled.hadj,
					  1, MAX(10, width - 3));
	    q8tk_adjustment_set_increment(widget->stat.scrolled.vadj,
					  1, MAX(10, height - 3));
	}
	break;

    case Q8TK_TYPE_ENTRY:
	widget->stat.entry.width = width;
	q8tk_entry_set_position(widget, widget->stat.entry.cursor_pos);
	break;

    default:
	fprintf(stderr, "Cant resize widget=%s\n", debug_type(widget->type));
	Q8tkAssert(FALSE, NULL);
	return;
    }
    set_construct_flag(TRUE);
}




/************************************************************************/
/* Rei֌W								*/
/************************************************************************/
/*---------------------------------------------------------------------------
 * Rei
 *---------------------------------------------------------------------------
 *  EReiEBWbgƃEBWbgeqɂ
 *  -------------------------------------------------------------------------
 *  void    q8tk_container_add(Q8tkWidget *container, Q8tkWidget *widget)
 *	ReiEBWbg container  EBWbg widget eqɂB
 *
 *  void    q8tk_box_pack_start(Q8tkWidget *box, Q8tkWidget *widget)
 *	E{bNX box ̌ɁAEBWbg widget l߂B
 *
 *  void    q8tk_box_pack_end(Q8tkWidget *box, Q8tkWidget *widget)
 *	E{bNX box ̑OɁAEBWbg widget l߂B
 *
 *  void    q8tk_container_remove(Q8tkWidget *container, Q8tkWidget *widget)
 *	ReiEBWbg container  EBWbg widget ؂藣B
 *---------------------------------------------------------------------------*/
void	q8tk_container_add(Q8tkWidget *container, Q8tkWidget *widget)
{
    Q8tkAssert(container->attr & Q8TK_ATTR_CONTAINER, NULL);
    if (container->attr & Q8TK_ATTR_LABEL_CONTAINER) {
	Q8tkAssert(widget->type == Q8TK_TYPE_LABEL, NULL);
    }

    switch (container->type) {
    case Q8TK_TYPE_LISTBOX:			/* LIST BOX O */
	if (container->child == NULL) {			/* ŏ LIST ITEM */
	    container->stat.listbox.selected = widget;	/* ̏ꍇ́A */
	    container->stat.listbox.active   = widget;	/* IԂɂ   */
	}
	q8tk_box_pack_start(container, widget);		/* VBOXƓ */
	return;

    default:					/* ʏ̏ */
	container->child = widget;
	widget->parent = container;
	widget->prev   = NULL;
	widget->next   = NULL;
	break;
    }

    if (widget->visible) {
	widget_map(widget);
    }
}

void	q8tk_box_pack_start(Q8tkWidget *box, Q8tkWidget *widget)
{
    Q8tkAssert(box->attr & Q8TK_ATTR_CONTAINER, NULL);

    if (box->child == NULL) {
	box->child   = widget;
	widget->prev = NULL;
	widget->next = NULL;
    } else {
	Q8tkWidget *c = box->child;
	while (c->next) {
	    c = c->next;
	}
	c->next      = widget;
	widget->prev = c;
	widget->next = NULL;
    }
    widget->parent = box;

    if (widget->visible) {
	widget_map(widget);
    }
}

void	q8tk_box_pack_end(Q8tkWidget *box, Q8tkWidget *widget)
{
    Q8tkAssert(box->attr & Q8TK_ATTR_CONTAINER, NULL);

    if (box->child == NULL) {
	widget->prev = NULL;
	widget->next = NULL;
    } else {
	Q8tkWidget *c = box->child;
	Q8tkAssert(c->prev == NULL, NULL);
	c->prev      = widget;
	widget->next = c;
	widget->prev = NULL;
    }
    box->child     = widget;
    widget->parent = box;

    if (widget->visible) {
	widget_map(widget);
    }
}

void	q8tk_container_remove(Q8tkWidget *container, Q8tkWidget *widget)
{
    Q8tkAssert(container->attr & Q8TK_ATTR_CONTAINER, NULL);
    Q8tkAssert(widget->parent == container, NULL);

    if (widget->prev == NULL) {			/* e̒̎ */
	Q8tkWidget *n = widget->next;
	if (n) n->prev = NULL;
	container->child = n;

    } else {					/* Ȃ */
	Q8tkWidget *p = widget->prev;
	Q8tkWidget *n = widget->next;
	if (n) n->prev = p;
	p->next = n;
    }

    widget->parent = NULL;
    widget->prev = NULL;
    widget->next = NULL;

    switch (container->type) {

    case Q8TK_TYPE_LISTBOX:			/* LIST BOX O */
	if (container->stat.listbox.selected == widget) {
	    container->stat.listbox.selected = NULL;
	    container->stat.listbox.active   = NULL;
	}
	break;

    }


    if (container->visible) {
	widget_map(container);
    }
}


/************************************************************************/
/* \֌W								*/
/************************************************************************/
/*---------------------------------------------------------------------------
 * As
 *---------------------------------------------------------------------------
 *  EEBWbg̕\E\
 *  -------------------------------------------------------------------------
 *  void	q8tk_widget_show(Q8tkWidget *widget)
 *	EBWbg\B
 *
 *  void	q8tk_widget_hide(Q8tkWidget *widget)
 *	EBWbg\ɂBqSĔ\ɂȂB
 *---------------------------------------------------------------------------*/
void	q8tk_widget_show(Q8tkWidget *widget)
{
    widget->visible = TRUE;
    widget_map(widget);
}
void	q8tk_widget_hide(Q8tkWidget *widget)
{
    widget->visible = FALSE;
    widget_map(widget);
}


/*---------------------------------------------------------------------------
 * 
 *---------------------------------------------------------------------------
 *  EEBWbg̑
 *  -------------------------------------------------------------------------
 *  void	q8tk_widget_set_sensitive(Q8tkWidget *widget, int sensitive)
 *	EBWbg𑀍\^s\ɂB
 *	---------------------------------------------------------------------
 *	ۂ́Aqɓ`B
 *	s\ȃEBWbǵAʏƂ͈ႤF(n̐F)̕\ƂȂB
 *	ƂƑłȂEBWbg(xȂ)ɑ΂ĂAwłB
 *	---------------------------------------------------------------------
 *	LOGO / VSEPARATOR / HSEPARATOR ́As\ɂĂF͕ωȂB
 *	(ωق?)
 *
 *	NOTEPAGE ́AŃRei(NOTEPAGE)dg݂Ȃ̂ŁA
 *	ۂݒłȂB (肳΁A
 *	q8tk_widget_set_sensitive(widget->parent, FALSE) łł邪c)
 *
 *	ADJUSTMENT ͑ۂݒł邪AXP[Ȃǂ̂قŐݒ肷
 *	낤Aڎw肷邱Ƃ͂Ȃ낤B
 *---------------------------------------------------------------------------*/
void	q8tk_widget_set_sensitive(Q8tkWidget *widget, int sensitive)
{
    widget->sensitive = sensitive;
    widget_map(widget);
}


/************************************************************************/
/* EBWbg̏							*/
/************************************************************************/
/*---------------------------------------------------------------------------
 * EBWbg
 *---------------------------------------------------------------------------
 *  EEBWbg
 *	_CAO	     cq8tk_dialog_new ɂĐEBWbgSďB
 *				vbox  action_area ɍڂEBWbg͏
 *				Ȃ̂āAĂяoŏB
 *
 *	t@CZNV c ŐSẴEBWbgB
 *				t@CIrɐEBWbgSď
 *
 *	̑		     c ŎEBWbg킹ďB
 *				q8tk_xxx_new_with_label ŐxA
 *				q8tk_scrolled_window_new Ŏ
 *				AWXggȂ
 *  -------------------------------------------------------------------------
 *  void	q8tk_widget_destroy(Q8tkWidget *widget)
 *	EBWbg̏Bȍ~A widget ͎gp֎~
 *
 *---------------------------------------------------------------------------*/
static	void	widget_destroy_all(Q8tkWidget *widget);

void	q8tk_widget_destroy(Q8tkWidget *widget)
{
    Q8tkWidget *work;

    if (widget->type == Q8TK_TYPE_WINDOW &&	/* DIALOG  FILE SELECTION */
	(work = widget->stat.window.work)) {	/* ̗O		    */

	switch (work->type) {
	case Q8TK_TYPE_DIALOG:
	    Q8tkAssert(widget->child->type == Q8TK_TYPE_FRAME, NULL);
	    Q8tkAssert(widget->child->child->type == Q8TK_TYPE_VBOX, NULL);
	    q8tk_widget_destroy(Q8TK_DIALOG(widget)->action_area);
	    q8tk_widget_destroy(Q8TK_DIALOG(widget)->vbox);
	    q8tk_widget_destroy(widget->child->child);
	    q8tk_widget_destroy(widget->child);
	    q8tk_widget_destroy(work);
	    break;

	case Q8TK_TYPE_FILE_SELECTION:
	    {
		q8tk_widget_destroy(
			(Q8TK_FILE_SELECTION(widget)->scrolled_window)
							->stat.scrolled.hadj);
		q8tk_widget_destroy(
			(Q8TK_FILE_SELECTION(widget)->scrolled_window)
							->stat.scrolled.vadj);

		free(Q8TK_FILE_SELECTION(widget)->pathname);
		free(Q8TK_FILE_SELECTION(widget)->filename);

		/* ֌W͂肵Ă̂ŁAⓚpőSĂ */
		widget_destroy_all(widget->child);
	    }
	    q8tk_widget_destroy(work);
	    break;
	}
    }

    if (widget->type == Q8TK_TYPE_COMBO) {	/* COMBO ̗O */
	Q8List *l = widget->stat.combo.list;
	while (l) {
	    q8tk_widget_destroy((Q8tkWidget *)(widget->stat.combo.list->data));
	    l = l->next;
	}
	q8_list_free(widget->stat.combo.list);
	q8tk_widget_destroy(widget->stat.combo.entry);
    }

    if (widget->type == Q8TK_TYPE_ACCEL_GROUP &&    /* ACCEL ̎q͑Sď */
	widget->child) {
	/* ֌W͂肵Ă̂ŁAⓚpőSĂ */
	widget_destroy_all(widget->child);
    }


    if (widget->with_label &&			/* XXX_new_with_label() */
	widget->child      &&			/* ꂽ LABEL̏ */
	widget->child->type == Q8TK_TYPE_LABEL) {
	q8tk_widget_destroy(widget->child);
    }
    if (widget->with_label &&			    /*  NULL Őꂽ*/
	widget->type == Q8TK_TYPE_SCROLLED_WINDOW) {/* SCROLLED WINDOW ̏*/
	q8tk_widget_destroy(widget->stat.scrolled.hadj);
	q8tk_widget_destroy(widget->stat.scrolled.vadj);
    }

    if (widget->name) {
	free(widget->name);
	widget->name = NULL;
    }
    free_widget(widget);
}


/* gƁAqƁAԂSč폜B
   gȉ̃EBWbg̍폜ɂėOƂ킩Ăꍇ̂݉ */

static	void	widget_destroy_all(Q8tkWidget *widget)
{
    if (widget->next)  widget_destroy_all(widget->next);
    if (widget->child) widget_destroy_all(widget->child);

    if (widget->name) {
	free(widget->name);
	widget->name = NULL;
    }
    free_widget(widget);
}




/************************************************************************/
/* ̃EBWbgɃtH[JX𓖂ĂB				*/
/*	ʏ tH[JX́AOɃ{^L[͂ȂꂽEBWbg	*/
/*	ɂȂATAB ɂؑւ\Å֐œ̃EBWbg	*/
/*	ɃtH[JXݒ肷邱ƂłB				*/
/*	ÃEBWbg̈Ԑc WINDOW Aq8tk_grab_add()	*/
/*	ȂꂽƂłȂΖłB			*/
/************************************************************************/
void	q8tk_widget_set_focus(Q8tkWidget *widget)
{
    focus_widget[ window_layer_level ] = widget;
    set_construct_flag(TRUE);
}


/************************************************************************/
/* VOi֌W								*/
/************************************************************************/
/*
 *	Cӂ̃EBWbgɁACӂ̃VOi𑗂
 */
static	void	widget_signal_do(Q8tkWidget *widget, const char *name)
{
    switch (widget->type) {
    case Q8TK_TYPE_WINDOW:			/* EChE		*/
	if (strcmp(name, "inactivate") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	}
	break;
    case Q8TK_TYPE_BUTTON:			/* {^		*/
	if (strcmp(name, "clicked") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	}
	break;
    case Q8TK_TYPE_TOGGLE_BUTTON:		/* gO{^		*/
    case Q8TK_TYPE_CHECK_BUTTON:		/* `FbN{^	*/
    case Q8TK_TYPE_RADIO_BUTTON:		/* WI{^		*/
	if        (strcmp(name, "clicked") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	} else if (strcmp(name, "toggled") == 0) {
	    if (widget->user_event_1) {
		(*widget->user_event_1)(widget, widget->user_event_1_parm);
	    }
	    return;
	}
	break;

    case Q8TK_TYPE_NOTEBOOK:			/* m[gubN		*/
	if (strcmp(name, "switch_page") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	}
	break;

    case Q8TK_TYPE_COMBO:			/* R{{bNX	*/
	if        (strcmp(name, "activate") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	} else if (strcmp(name, "changed") == 0) {
	    if (widget->user_event_1) {
		(*widget->user_event_1)(widget, widget->user_event_1_parm);
	    }
	    return;
	}
	break;

    case Q8TK_TYPE_LISTBOX:			/* Xg{bNX	*/
	if (strcmp(name, "selection_changed") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	}
	break;

    case Q8TK_TYPE_LIST_ITEM:			/* XgACe	*/
	if (strcmp(name, "select") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	}
	break;

    case Q8TK_TYPE_ADJUSTMENT:			/* AWXgg */
	if (strcmp(name, "value_changed") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	}
	break;

    case Q8TK_TYPE_ENTRY:			/* Gg[		*/
	if        (strcmp(name, "activate") == 0) {
	    if (widget->user_event_0) {
		(*widget->user_event_0)(widget, widget->user_event_0_parm);
	    }
	    return;
	} else if (strcmp(name, "changed") == 0) {
	    if (widget->user_event_1) {
		(*widget->user_event_1)(widget, widget->user_event_1_parm);
	    }
	    return;
	}
	break;

    }

    fprintf(stderr, "BAD signal %s '%s'\n", debug_type(widget->type), name);
    Q8tkAssert(FALSE, NULL);
    return;
}


/*---------------------------------------------------------------------------
 * VOi̐ݒE폜
 *---------------------------------------------------------------------------
 *  EEBWbg̃VOiɁAR[obN֐ݒ肷B
 *    eEBWbgƂɔVOi܂Ă̂ŁÃVOi
 *    ɌĂяo֐ݒ肷B
 *  EŐݒ肷֐Ŏg̃EBWbg폜悤ȂƂ
 *    Ă͂ȂBŌ듮삷\B
 *     (A{^EBWbgɌA\ƂBȂ̂ŁA_CAO
 *	t@CZNṼ{^ɂāAg폜̂͑vȂ͂)
 *
 *  -------------------------------------------------------------------------
 * int	q8tk_signal_connect(Q8tkWidget *widget, const char *name,
 *			    Q8tkSignalFunc func, void *func_data)
 *	widget  name ŎVOiɑ΂R[obN֐ func 
 *	ݒ肷BVOiɂ́A֐ func   widget, func_data 
 *	ČĂяoB
 *	ȂA߂l͏ 0 ɂȂB
 *
 * void	q8tk_signal_handlers_destroy(Q8tkWidget *widget)
 *	widget ɐݒ肳ꂽSẴVOĩR[obN֐𖳌ɂB
 *
 *---------------------------------------------------------------------------*/
void	q8tk_signal_handlers_destroy(Q8tkWidget *widget)
{
    widget->user_event_0 = NULL;
    widget->user_event_1 = NULL;
}

int	q8tk_signal_connect(Q8tkWidget *widget, const char *name,
			    Q8tkSignalFunc func, void *func_data)
{
    switch (widget->type) {
    case Q8TK_TYPE_WINDOW:			/* EChE		*/
	if (strcmp(name, "inactivate") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	}
	break;
    case Q8TK_TYPE_BUTTON:			/* {^		*/
	if (strcmp(name, "clicked") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	}
	break;
    case Q8TK_TYPE_TOGGLE_BUTTON:		/* gO{^		*/
    case Q8TK_TYPE_CHECK_BUTTON:		/* `FbN{^	*/
    case Q8TK_TYPE_RADIO_BUTTON:		/* WI{^		*/
	if        (strcmp(name, "clicked") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	} else if (strcmp(name, "toggled") == 0) {
	    widget->user_event_1      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_1_parm = func_data;
	    return 0;
	}
	break;

    case Q8TK_TYPE_NOTEBOOK:			/* m[gubN		*/
	if (strcmp(name, "switch_page") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	}
	break;

    case Q8TK_TYPE_COMBO:			/* R{{bNX	*/
	if        (strcmp(name, "activate") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	} else if (strcmp(name, "changed") == 0) {
	    widget->user_event_1      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_1_parm = func_data;
	    return 0;
	}
	break;

    case Q8TK_TYPE_LISTBOX:			/* Xg{bNX	*/
	if (strcmp(name, "selection_changed") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	}
	break;

    case Q8TK_TYPE_LIST_ITEM:			/* XgACe	*/
	if (strcmp(name, "select") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	}
	break;

    case Q8TK_TYPE_ADJUSTMENT:			/* AWXgg	*/
	if (strcmp(name, "value_changed") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	}
	break;

    case Q8TK_TYPE_ENTRY:			/* Gg		*/
	if        (strcmp(name, "activate") == 0) {
	    widget->user_event_0      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_0_parm = func_data;
	    return 0;
	} else if (strcmp(name, "changed") == 0) {
	    widget->user_event_1      = (void (*)(Q8tkWidget*,void*))func;
	    widget->user_event_1_parm = func_data;
	    return 0;
	}
	break;

    }

    fprintf(stderr,
	    "Undefined signal %s '%s'\n", debug_type(widget->type),name);
    Q8tkAssert(FALSE, NULL);
    return 0;
}



/************************************************************************/
/* Cxg̃`FbN							*/
/************************************************************************/
/*
 *	DRAGGING
 */
static	void	widget_dragging(Q8tkWidget *focus)
{
    if (focus && focus->event_dragging) {
	(*focus->event_dragging)(focus);
    }
}
/*
 *	DRAG OFF
 */
static	void	widget_drag_off(Q8tkWidget *focus)
{
    if (focus && focus->event_drag_off) {
	(*focus->event_drag_off)(focus);
    }
}

/*
 *	MOUSE BUTTON ON
 */
static	void	widget_button_on(Q8tkWidget *focus)
{
    if (focus == NULL) {
	/* EBWbgȊONbNA̐eEChEɃCxgʒm */
	focus = window_layer[ window_layer_level ];
    }
    if (focus && focus->event_button_on) {
	(*focus->event_button_on)(focus);
    }
}
/*
 *	KEY ON
 */
static	void	widget_key_on(Q8tkWidget *focus, int key)
{
    if (focus && focus->event_key_on) {
	(*focus->event_key_on)(focus, key);
    }
}



/************************************************************************/
/* C								*/
/************************************************************************/
/*--------------------------------------------------------------
 *
 *--------------------------------------------------------------*/
void	q8tk_event_key_on(int code)
{
    Q8tkWidget *w;
    int change = FALSE;
    int back   = FALSE;

    now_mouse_on = FALSE;

    if (code == Q8TK_KEY_SHIFT) now_shift_on = TRUE;

    if (! get_drag_widget()) {			/* hbOȂ	*/

	w = get_focus_widget();

	switch (code) {
	case Q8TK_KEY_TAB:
	    change = TRUE;
	    if (now_shift_on) back = TRUE;
	    else              back = FALSE;
	    break;

#ifdef	OLD_FOCUS_CHANGE
	/* DO NOTHING */
#else	/* VȃtH[JXړ */
	case Q8TK_KEY_UP:
	    if (w->key_up_used == FALSE) {
		change = TRUE;
		back   = TRUE;
	    }
	    break;
	case Q8TK_KEY_DOWN:
	    if (w->key_down_used == FALSE) {
		change = TRUE;
		back   = FALSE;
	    }
	    break;
	case Q8TK_KEY_LEFT:
	    if (w->key_left_used == FALSE) {
		change = TRUE;
		back   = TRUE;
	    }
	    break;
	case Q8TK_KEY_RIGHT:
	    if (w->key_right_used == FALSE) {
		change = TRUE;
		back   = FALSE;
	    }
	    break;
#endif
	}
	    
	/* [TAB][][][][] ŁAÕEBWbgɃtH[JXڂ */
	if (change) {

	    w = widget_focus_list_get_next(w, back);
	    q8tk_widget_set_focus(w);

	    /* tH[JXړEBWbgA
	       XN[hEChEłAXN[AEg̈ȂA
	       IɃXN[ĈŁAŕ␳\ */
	    if (w && w->type != Q8TK_TYPE_ADJUSTMENT
		  && w->type != Q8TK_TYPE_LISTBOX
		  && w->type != Q8TK_TYPE_DIALOG
		  && w->type != Q8TK_TYPE_FILE_SELECTION) {
		widget_scrollin_register(w);
	    }
	} else {				/*	̃L[ */

	    /* ANZ[^[L[Aݒ肳ĂΏ */
	    if (window_layer_level >= 0) {
		w = window_layer[ window_layer_level ];
		Q8tkAssert(w->type == Q8TK_TYPE_WINDOW, NULL);

		if (w->stat.window.accel) {
		    w = (w->stat.window.accel)->child;
		    while (w) {
			if (w->stat.accel.key == code) {
			    widget_signal_do(w->stat.accel.widget, w->name);
			    break;
			}
			w = w->next;
		    }
		}
	    }

	    /* ANZ[^[L[LȂAW̏͂Ȃق? */
	    widget_key_on(get_focus_widget(), code);
	}
    }
}

void	q8tk_event_key_off(int code)
{
    now_mouse_on = FALSE;

    if (code == Q8TK_KEY_SHIFT) now_shift_on = FALSE;
}

void	q8tk_event_mouse_on(int code)
{
    if (get_construct_flag()) return;	/* EChEj̃NbN */

    if (code == Q8TK_BUTTON_L) {		/* {^ ON		*/
	if (! get_drag_widget()) {		/* hbOȂ	*/
	    void *focus = q8gr_get_focus_screen(mouse.x/8, mouse.y/16);
	    if        (focus == Q8GR_WIDGET_NONE) {
		widget_button_on(NULL);
	    } else if (focus == Q8GR_WIDGET_WINDOW) {
		/* DO NOTHING */ ;
	    } else {
		q8tk_widget_set_focus((Q8tkWidget *)focus);
		widget_button_on((Q8tkWidget *)focus);
	    }
	}
    } else if (code == Q8TK_BUTTON_U) {		/* zC[ UP		*/

	widget_key_on(get_focus_widget(), Q8TK_KEY_PAGE_UP);

    } else if (code == Q8TK_BUTTON_D) {		/* zC[ DOWN	*/

	widget_key_on(get_focus_widget(), Q8TK_KEY_PAGE_DOWN);
    }
}

void	q8tk_event_mouse_off(int code)
{
    now_mouse_on = FALSE;

    if (code == Q8TK_BUTTON_L) {		/* {^ OFF		*/
	if (get_drag_widget()) {		/*  hbO	*/
	    widget_drag_off(get_drag_widget());
	    set_drag_widget(NULL);
	}
    }
}

void	q8tk_event_mouse_moved(int x, int y)
{
    int block_moved;

    mouse.x_old = mouse.x;
    mouse.y_old = mouse.y;
    mouse.x     = x;
    mouse.y     = y;

    if (mouse.x/8  != mouse.x_old/8  ||		/* }EX 8dotȏ ړ	*/
	mouse.y/16 != mouse.y_old/16) {
	block_moved = TRUE;
	now_mouse_on = FALSE;

	if (disp_cursor) {
	    set_construct_flag(TRUE);
	}
    } else {
	block_moved = FALSE;
    }

    if (get_drag_widget()) {			/*  hbO 	*/
	if (block_moved) {			/* }EX 8dotȏ ړ	*/
	    widget_dragging(get_drag_widget());
	}
    }
}

void	q8tk_event_quit(void)
{
    q8tk_main_quit();
}

/*--------------------------------------------------------------
 *
 *--------------------------------------------------------------*/
static	int	cursor_exist = 0;
static	int	cursor_timer = 0;

#define	Q8GR_CURSOR_BLINK		(30)
#define	Q8GR_CURSOR_CYCLE		(60)

#define	Q8GR_MOUSE_AUTO_REPEAT		(6)


void	q8gr_set_cursor_exist(int exist_flag)
{
    cursor_exist = exist_flag;
}
int	q8gr_get_cursor_exist(void)
{
    return cursor_exist;
}
int	q8gr_get_cursor_blink(void)
{
    return (cursor_timer < Q8GR_CURSOR_BLINK) ? TRUE : FALSE;
}
void	q8gr_set_cursor_blink(void)
{
    cursor_timer = 0;
}

/*--------------------------------------------------------------
 * q8tk_main_loop
 *	߂lA^ȂAEFCgɉxłĂяo
 *		  UȂAI
 *--------------------------------------------------------------*/

int	q8tk_main_loop(void)
{
    static int mouse_frame = 0;

    if (get_main_loop_flag()) {

	if (get_delay_widget() == NULL) {

	    if (cursor_exist) {		/* J[\\Ȃ_Ń^C}XV */
		cursor_timer ++;
		if (cursor_timer > Q8GR_CURSOR_CYCLE) {
		    cursor_timer = 0;
		}
	    } else {
		cursor_timer = 0;
	    }

	    event_update();		/* Cxg		  */
					/* (KvɉāAŉʍ\z) */
					/* (ĨtOŃZbg) */

	    if (now_mouse_on) {		/* }EX{^I[gs[g */
		++ mouse_frame;
		if (mouse_frame >= Q8GR_MOUSE_AUTO_REPEAT) {
		    q8tk_event_mouse_on(Q8TK_BUTTON_L);
		    mouse_frame = 0;
		}
	    } else {
		mouse_frame = 0;
	    }

	    if (cursor_exist) {		  /* J[\_Ő؂ւ	*/
		if (cursor_timer == 0 ||  /* ^C~O`FbN	*/
		    cursor_timer == Q8GR_CURSOR_BLINK) {
		    set_construct_flag(TRUE);
		}
	    }

	} else {
      
	    /* Cxgx邽߂́A^C}[ (Ȃ苭) */
	    /* (̂ƂA{^ƃXgACê)              */
	    if (-- delay_timer < 0) {
		Q8tkWidget *widget = get_delay_widget();

		if (widget->type == Q8TK_TYPE_BUTTON) {
		    widget->stat.button.active = Q8TK_BUTTON_OFF;
		    widget_signal_do(widget, "clicked");
		}
		else if (widget->type == Q8TK_TYPE_LIST_ITEM) {
		    widget_signal_do(widget->parent, "selection_changed");
		    widget_signal_do(widget, "select");
		}
		set_construct_flag(TRUE);

		set_delay_widget(NULL, 0);
	    }
	}



	if (get_construct_flag()) {	/* ʍ\ύX́A` */

	    widget_construct();
	    set_construct_flag(FALSE);

	    if (q8tk_disp_init_flag) {
		screen_set_dirty_palette();
		q8tk_disp_init_flag = FALSE;
	    }
	    screen_set_dirty_flag(0);

#ifdef	RESET_EVENT			/* s͂LZ */
	    event_switch();
#endif
	}

    }

    /* ʂ菈IāAQ8TK IĂȂ΁A^Ԃ	*/
    /*		ʑ́A`EEFCgɂ̊֐ēxĂяo	*/
    /*									*/
    /* ʂ菈IāAQ8TK IĂ΁AUԂ		*/
    /*		ʑ́ȀɑJڂ邱			*/
    /*		`EEFCgɑJڂĂ\Ȃ			*/
    /*		ԈčēxĂяoꍇAȂɂɋUԂ	*/

    if (get_main_loop_flag()) {

	return TRUE;

    } else {

	q8tk_term();
	return FALSE;
    }
}

/*--------------------------------------------------------------
 *
 *--------------------------------------------------------------*/
void	q8tk_main_quit(void)
{
    set_main_loop_flag(FALSE);
}







/************************************************************************/
/*									*/
/*									*/
/*									*/
/*									*/
/*									*/
/*									*/
/************************************************************************/

/*------------------------------------------------------*/
/* EBWbg̕\ݒ
	eEBWbg`FbNA
	ESĂ̐eEBWbg
	EcEBWbg WINDOW
	̏ꍇA WINDOW ȉČvZĕ\
	悤ɁAtOĂB
	ۂ̍ČvZA\́Aq8tk_main() ōsȂB	*/
/*------------------------------------------------------*/
static	void	widget_map(Q8tkWidget *widget)
{
    Q8tkWidget *ancestor, *parent;
    int        size_calc = TRUE;

    if (widget->visible) {
	ancestor = widget;
	parent   = widget->parent;
	while (parent) {
	    if (parent->visible) {
		ancestor = parent;
		parent   = parent->parent;
	    } else {
		size_calc = FALSE;
		break;
	    }
	}
	if (size_calc && ancestor->type == Q8TK_TYPE_WINDOW) {
	    set_construct_flag(TRUE);
	}
    }
}


/*------------------------------------------------------*/
/* qEBWbg̃TCYɁAg̃TCYvZB
   ċAIɁASĂ̎qEBWFbgɌvZB

   *widget c ԐẽEBWbg
   *max_sx c SĂ̎qEBWbĝȂōőTCY x
   *max_sy c SĂ̎qEBWbĝȂōőTCY y
   *sum_sx c q̒ԃEBWbg̃TCYa x
   *sum_sy c q̒ԃEBWbg̃TCYa y          */
/*------------------------------------------------------*/
static	void	widget_resize(Q8tkWidget *widget, int max_sx, int max_sy);
static	void	widget_size(Q8tkWidget *widget, int *max_sx, int *max_sy,
						int *sum_sx, int *sum_sy)
{
    int n_msx, n_msy, n_ssx, n_ssy;

/*  printf("%d \n", widget->type); fflush(stdout);*/


		/* g̒ (next) ݂΁AċAIɌvZ */
  
    if (widget->next) {
	widget_size(widget->next, &n_msx, &n_msy, &n_ssx, &n_ssy);
    } else {
	n_msx = n_msy = n_ssx = n_ssy = 0;
    }


    if (widget->visible) {

	int c_msx, c_msy, c_ssx, c_ssy;

		/* qEBWbg̃TCYvZ(ċA) */

	if (widget->child) {
	    widget_size(widget->child, &c_msx, &c_msy, &c_ssx, &c_ssy);
	} else {
	    c_msx = c_msy = c_ssx = c_ssy = 0;
	}

		/* qEBWbgɁAg̃TCYvZ */

	switch (widget->type) {

	case Q8TK_TYPE_WINDOW:			/* EChE		*/
	    if (widget->stat.window.no_frame) {
		widget->sx = c_msx;
		widget->sy = c_msy;
	    } else {
		widget->sx = c_msx +2;
		widget->sy = c_msy +2;
	    }
	    break;

	case Q8TK_TYPE_BUTTON:			/* {^		*/
	case Q8TK_TYPE_TOGGLE_BUTTON:		/* gO{^		*/
	    widget->sx = c_msx +2;
	    widget->sy = c_msy +2;
	    break;

	case Q8TK_TYPE_CHECK_BUTTON:		/* `FbN{^	*/
	case Q8TK_TYPE_RADIO_BUTTON:		/* WI{^		*/
	    widget->sx = c_msx +3;
	    widget->sy = Q8TKMAX(c_msy, 1);
	    break;

	case Q8TK_TYPE_FRAME:			/* t[		*/
	    if (widget->name) {
		widget->sx = Q8TKMAX(c_msx,
				     q8gr_strlen(widget->code, widget->name))
									   + 2;
	    } else {
		widget->sx = c_msx + 2;
	    }
	    widget->sy = c_msy +2;
	    break;

	case Q8TK_TYPE_LABEL:			/* x		*/
	    if (widget->name) {
		widget->sx = q8gr_strlen(widget->code, widget->name);
	    } else {
		widget->sx = 0;
	    }
	    widget->sy = 1;
	    break;

	case Q8TK_TYPE_LOGO:			/* S			*/
	    widget->sx = Q8GR_LOGO_W;
	    widget->sy = Q8GR_LOGO_H;
	    break;

	case Q8TK_TYPE_NOTEBOOK:		/* m[gubN		*/
	    {
		int	len = 0;
		Q8tkWidget *n = widget->child;
		while (n) {
		    if (n ->name) {
			len += q8gr_strlen(n->code, n->name);
		    }
		    len += 1;
		    n = n->next;
		}
		len += 1;
		widget->sx = Q8TKMAX(c_msx +2, len);
	    }
	    widget->sy = c_msy + 4;
	    break;

	case Q8TK_TYPE_NOTEPAGE:		/* m[gubÑy[W	*/
	    widget->sx = c_msx;
	    widget->sy = c_msy;
	    break;

	case Q8TK_TYPE_VBOX:			/* {bNX		*/
	    widget->sx = c_msx;
	    widget->sy = c_ssy;
	    break;
	case Q8TK_TYPE_HBOX:			/* {bNX		*/
	    widget->sx = c_ssx;
	    widget->sy = c_msy;
	    break;

	case Q8TK_TYPE_VSEPARATOR:		/* ؂		*/
	    widget->sx = 1;
	    widget->sy = 1;
	    break;
	case Q8TK_TYPE_HSEPARATOR:		/* ؂		*/
	    widget->sx = 1;
	    widget->sy = 1;
	    break;

	case Q8TK_TYPE_COMBO:			/* R{{bNX	*/
	    if (widget->stat.combo.width) {
		widget->sx = widget->stat.combo.width;
	    } else {
		if (widget->stat.combo.length) {
		    widget->sx = widget->stat.combo.length;
		} else {
		    widget->sx = 8;
		}
	    }
	    widget->sx += 3;
	    widget->sy = 1;
	    break;

	case Q8TK_TYPE_LISTBOX:			/* Xg{bNX	*/
	    widget->sx = Q8TKMAX(c_msx, widget->stat.listbox.width);
	    widget->sy = c_ssy;
	    break;

	case Q8TK_TYPE_LIST_ITEM:		/* XgACe	*/
	    widget->sx = c_msx;
	    widget->sy = c_msy;
	    break;

	case Q8TK_TYPE_ADJUSTMENT:		/* AWXgg	*/
	    Q8tkAssert(FALSE, NULL);
	    break;

	case Q8TK_TYPE_HSCALE:			/* XP[		*/
	case Q8TK_TYPE_VSCALE:			/* XP[		*/
	    if (widget->stat.scale.adj) {
		int sx, sy;
		adjustment_size(&widget->stat.scale.adj->stat.adj, &sx, &sy);

		if (widget->stat.scale.draw_value) {
		    if (widget->stat.scale.value_pos == Q8TK_POS_LEFT ||
			widget->stat.scale.value_pos == Q8TK_POS_RIGHT) {
			widget->sx = sx + 4;
			widget->sy = Q8TKMAX(sy, 1);
		    } else {		/* Q8TK_POS_UP||Q8TK_POS_BOTTOM*/
			widget->sx = Q8TKMAX(sx, 3);
			widget->sy = sy + 1;
		    }
		} else {
		    widget->sx = sx;
		    widget->sy = sy;
		}
	    } else {
		widget->sx = 0;
		widget->sy = 0;
	    }
	    break;

	case Q8TK_TYPE_SCROLLED_WINDOW:		/* XN[hEChE */
	    if (widget->child) {

		/* cXN[o[\邩ǂ́A
		   child ̃TCYAscrolled ̃TCYAscrolled  policyA
		   ̑gݍ킹ɂAȉ 9 p^[ɕB

				   0)              1)              2)
				c_msx < w-2	c_msx = w-2	c_msx > w-2
				(NEVER)				(ALLWAYS)
		0)
		  c_msy < h-2				  
		  (NEVER)					  ---
		1)
		  c_msy = h-2					    |
						  --+
		2)
		  c_msy > h-2	    |		    |		    |
		  (ALLWAYS)			  --+		  --+

		*/

		int w, h, tmp;

		switch (widget->stat.scrolled.hpolicy) {
		case Q8TK_POLICY_NEVER:		w = 0;		break;
		case Q8TK_POLICY_ALWAYS:	w = 2;		break;
		default: /* AUTOMATIC */
		    if      (c_msx <  widget->stat.scrolled.width - 2) w = 0;
		    else if (c_msx == widget->stat.scrolled.width - 2) w = 1;
		    else                                               w = 2;
		}

		switch (widget->stat.scrolled.vpolicy) {
		case Q8TK_POLICY_NEVER:		h = 0;		break;
		case Q8TK_POLICY_ALWAYS:	h = 2;		break;
		default: /* AUTOMATIC */
		    if      (c_msy <  widget->stat.scrolled.height - 2) h = 0;
		    else if (c_msy == widget->stat.scrolled.height - 2) h = 1;
		    else                                                h = 2;
		}

		if        ((w == 0 || w == 1) && (h == 0 || h == 1)) {
		    widget->stat.scrolled.hscrollbar = FALSE;
		    widget->stat.scrolled.vscrollbar = FALSE;
		} else if ((w == 2) && (h == 0)) {
		    widget->stat.scrolled.hscrollbar = TRUE;
		    widget->stat.scrolled.vscrollbar = FALSE;
		} else if ((w == 0) && (h == 2)) {
		    widget->stat.scrolled.hscrollbar = FALSE;
		    widget->stat.scrolled.vscrollbar = TRUE;
		} else {
		    widget->stat.scrolled.hscrollbar = TRUE;
		    widget->stat.scrolled.vscrollbar = TRUE;
		}

		w = (widget->stat.scrolled.vscrollbar)
					? widget->stat.scrolled.width - 3
					: widget->stat.scrolled.width - 2;
		h = (widget->stat.scrolled.hscrollbar)
					? widget->stat.scrolled.height - 3
					: widget->stat.scrolled.height - 2;

		q8tk_adjustment_set_length(widget->stat.scrolled.hadj, w);
		q8tk_adjustment_clamp_page(widget->stat.scrolled.hadj,
					   0, c_msx - w);
		adjustment_size(&widget->stat.scrolled.hadj->stat.adj,
				&tmp, &tmp);

		q8tk_adjustment_set_length(widget->stat.scrolled.vadj, h);
		q8tk_adjustment_clamp_page(widget->stat.scrolled.vadj,
					   0, c_msy - h);
		adjustment_size(&widget->stat.scrolled.vadj->stat.adj,
				&tmp, &tmp);

		if (widget->child->type == Q8TK_TYPE_LISTBOX &&
		    (widget->stat.scrolled.vadj->stat.adj.listbox_changed) &&
		    (widget->stat.scrolled.vadj_value
			!= widget->stat.scrolled.vadj->stat.adj.value)) {
		    list_event_window_scrolled(widget, h);
		}
	    }
	    widget->stat.scrolled.vadj_value
			=  widget->stat.scrolled.vadj->stat.adj.value;
	    widget->stat.scrolled.vadj->stat.adj.listbox_changed = FALSE;
	    widget->sx = widget->stat.scrolled.width;
	    widget->sy = widget->stat.scrolled.height;
	    break;

	case Q8TK_TYPE_ENTRY:			/* Gg		*/
	    widget->sx = widget->stat.entry.width;
	    widget->sy = 1;
	    break;


	case Q8TK_TYPE_DIALOG:			/* _CAO		*/
	    Q8tkAssert(FALSE, NULL);
	    break;
	case Q8TK_TYPE_FILE_SELECTION:		/* t@CZNV	*/
	    Q8tkAssert(FALSE, NULL);
	    break;

	default:
	    Q8tkAssert(FALSE, "Undefined type");
	}

    } else {
	widget->sx = 0;
	widget->sy = 0;
    }


		/* TCYXV */

    *max_sx = Q8TKMAX(widget->sx, n_msx);
    *max_sy = Q8TKMAX(widget->sy, n_msy);
    *sum_sx = widget->sx + n_ssx;
    *sum_sy = widget->sy + n_ssy;


		/* qEBWbgɃZp[^܂܂ꍇ́ATCY */

    widget_resize(widget, widget->sx, widget->sy);


		/* Xg{bNXȂǂ̏ꍇAqEBWbg̃TCY𒲐 */


    if (widget->type == Q8TK_TYPE_LISTBOX) {
	Q8tkWidget *child = widget->child;
	while (child) {
	    Q8tkAssert(child->type == Q8TK_TYPE_LIST_ITEM, NULL);
	    child->sx = widget->sx;
	    if (child->next) child = child->next;
	    else             break;
	}
    }


/*printf("%s (%02d,%02d) max{ %02d,%02d } sum{ %02d,%02d }\n",debug_type(widget->type),widget->sx,widget->sy,*max_sx,*max_sy,*sum_sx,*sum_sy);fflush(stdout);*/
}


/*
 * Zp[^ȂǁAȇ傫ɈˑEBWbg̃TCYČvZ
 */
static	void	widget_resize(Q8tkWidget *widget, int max_sx, int max_sy)
{
    if (widget->type == Q8TK_TYPE_WINDOW   ||
	widget->type == Q8TK_TYPE_NOTEPAGE ||
	widget->type == Q8TK_TYPE_VBOX     ||
	widget->type == Q8TK_TYPE_HBOX) {

	Q8tkWidget *child = widget->child;
    
	if (widget->type == Q8TK_TYPE_WINDOW &&
	    ! widget->stat.window.no_frame) {
	    max_sx -= 2;
	    max_sy -= 2;
	}
	if (child) widget_resize(child, max_sx, max_sy);

	while (child) {
	    switch (child->type) {

	    case Q8TK_TYPE_HSEPARATOR:
		if (widget->type != Q8TK_TYPE_HBOX) {
		    if (child->sx < max_sx) child->sx = max_sx;
		}
		break;

	    case Q8TK_TYPE_VSEPARATOR:
		if (widget->type != Q8TK_TYPE_VBOX) {
		    if (child->sy < max_sy) child->sy = max_sy;
		}
		break;

	    case Q8TK_TYPE_VBOX:
		if (widget->type == Q8TK_TYPE_VBOX) {
		    if (child->sx < max_sx) child->sx = max_sx;
		}
		break;

	    case Q8TK_TYPE_HBOX:
		if (widget->type == Q8TK_TYPE_HBOX) {
		    if (child->sy < max_sy) child->sy = max_sy;
		}
		break;
	    }

	    if (child->next) child = child->next;
	    else             break;
	}
    }
}



/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/*------------------------------------------------------
   EBWbgAXN[hEChEɊ܂܂ꍇA
   XN[ʒuɂẮA\ȂƂB

   \߁ÃEBWbgȉ̊֐œo^Ă΁A

	widget_scrollin_register(this_widget);

   ʕ\̍ۂɁÃEBWbg\悤ɁAXN[
   ʒu𒲐悤ɂB

   XN[hEChEɂEBWbg\ꂽǂ́A
   ۂɕ\܂ł킩Ȃ̂ŁAۂɕ\Ȃ烏[N
   ݒ肵A[N̓eŁAĕ\ƂƂɂȂB

   ܂Aȉ̂悤ȊɂȂB

	widget_scrollin_adjust_reset();   c ̏
	widget_draw();                    c `

	if (widget_scrollin_adjust()) {   c ^
	    widget_draw();                c ̂ŁAĕ`
	}

  ȂAsȂ̂́AŏɌ e SCROLLED WINDOW ̂
  ɑ΂ĂȂ̂ŁASCROLLED WINDOW ̓q̏ꍇ͂ǂȂ邩
  킩ȂB
  ------------------------------------------------------*/

/* \ȃEBWbg̐BꂾΑv낤 */
#define	MAX_WIDGET_SCROLLIN	(8)
static	struct {
    int		drawn;
    Q8tkWidget	*widget;
} widget_scrollin[ MAX_WIDGET_SCROLLIN ];

/* S[N̏ (xs) */
static	void	widget_scrollin_init(void)
{
    int i;
    for (i=0; i<MAX_WIDGET_SCROLLIN; i++) {
	widget_scrollin[i].drawn  = FALSE;
	widget_scrollin[i].widget = NULL;
    }
}
/* EBWbg̓o^ */
static	void	widget_scrollin_register(Q8tkWidget *w)
{
    int i;
    for (i=0; i<MAX_WIDGET_SCROLLIN; i++) {
	if (widget_scrollin[i].widget == w) return;
    }
    for (i=0; i<MAX_WIDGET_SCROLLIN; i++) {
	if (widget_scrollin[i].widget == NULL) {
	    widget_scrollin[i].drawn  = FALSE;
	    widget_scrollin[i].widget = w;
	    return;
	}
    }
}
/* FEBWbg̕`OɌĂяo */
static	void	widget_scrollin_adjust_reset(void)
{
    int	i;
    for (i=0; i<MAX_WIDGET_SCROLLIN; i++) {
	widget_scrollin[i].drawn = FALSE;
    }
}
/* ݒFeEBWbg̕`斈ɌĂяo */
static	void	widget_scrollin_drawn(Q8tkWidget *w)
{
    int i;
    for (i=0; i<MAX_WIDGET_SCROLLIN; i++) {
	if (widget_scrollin[i].widget == w) {
	    widget_scrollin[i].drawn = TRUE;
	    return;
	}
    }
}
/* FSEBWbg̕`ɌĂяo */
static	int	widget_scrollin_adjust(void)
{
    int i, result = 0;

    for (i=0; i<MAX_WIDGET_SCROLLIN; i++) {

/*printf("%d %d %s\n",i,widget_scrollin[i].drawn,(widget_scrollin[i].widget)?debug_type(widget_scrollin[i].widget->type):"NULL");*/

	if (widget_scrollin[i].widget) {

	    if (widget_scrollin[i].drawn) {

		Q8tkWidget *widget = widget_scrollin[i].widget;
		Q8tkWidget *p = widget->parent;
		/*int	x1 = widget->x;*/
		int	x1 = widget->x + widget->sx -1;
		int	y1 = widget->y + widget->sy -1;

		/*
		 SCROLLED WINDOW ɏ悹EBWbgŜA_ƂA
		 Έʒu real_y

		 y1 = widget->y + widget->sy -1;
		 p->y + 1 - p->stat.scrolled.child_y0 + [ real_y ] = y1;
		*/

		while (p) {
		    if (p->type == Q8TK_TYPE_SCROLLED_WINDOW) {

			int d, topleft;

			/* d > 0 ȂA[\ */
			/* d < 0 ȂAE[\ */
			if (widget->type == Q8TK_TYPE_LIST_ITEM &&
			    widget->parent->type == Q8TK_TYPE_LISTBOX) {
			    d = widget->parent->stat.listbox.scrollin_left;
			} else {
			    d = 0;
			}
			/* d == 0 ́AftHg (-1 Ƃ) */
			if (d == 0) { d = -1; }

			if (d > 0) { topleft = TRUE;    d -= 1; }
			else       { topleft = FALSE;   d += 1; }

			if (topleft) {	   /* [\悤Ɉʒu␳ */
						        /* d = 0, 1, 2, 3... */
			    /* ␳Ȃ΍[\̂ŁÂ܂ */

			} else {	   /* E[\悤Ɉʒu␳ */
						     /* d = 0, -1, -2, -3... */
			    if (p->x +1 <= x1 &&
				x1 < p->x +1 + p->stat.scrolled.child_sx) {
				/* Ok, Expose */
			    } else {
				Q8TK_ADJUSTMENT(p->stat.scrolled.hadj)->value
				    = x1 - (p->x+1 - p->stat.scrolled.child_x0)
					 - p->stat.scrolled.child_sx + 1;
				result = 1;
			    }
			}
			/*  d ̒lɂĕ␳ʂςA܂x */


			/* d > 0 ȂA[\B+1̓sxA1\ */
			/* d < 0 ȂA[\B-1̓sxA1\ */
			if (widget->type == Q8TK_TYPE_LIST_ITEM &&
			    widget->parent->type == Q8TK_TYPE_LISTBOX) {
			    d = widget->parent->stat.listbox.scrollin_top;
			} else {
			    d = 0;
			}
			/* d == 0 ́AftHg (-1 Ƃ) */
			if (d == 0) { d = -1; }

			if (d > 0) { topleft = TRUE;    d -= 1; }
			else       { topleft = FALSE;   d += 1; }

			if (topleft) {	   /* [\悤Ɉʒu␳ */
						        /* d = 0, 1, 2, 3... */
			    if (p->y +1 == (y1-d)) {
				/* Ok */
			    } else {
				Q8TK_ADJUSTMENT(p->stat.scrolled.vadj)->value =
				 (y1-d) - (p->y+1 - p->stat.scrolled.child_y0);
				result = 1;
			    }

			} else {	   /* [\悤Ɉʒu␳ */
						     /* d = 0, -1, -2, -3... */
			    if (p->y +1 <= (y1-d) &&
				(y1-d) < p->y +1 + p->stat.scrolled.child_sy) {
				/* Ok, Expose */
			    } else {
				Q8TK_ADJUSTMENT(p->stat.scrolled.vadj)->value =
				 (y1-d) - (p->y+1 - p->stat.scrolled.child_y0)
					 - p->stat.scrolled.child_sy + 1;
				result = 1;
			    }
			}

	    /*
	    printf("  %s %d %d %d %d  %d %d %d %d\n",debug_type(p->type),
		   p->x, p->y, p->sx, p->sy,
		   p->stat.scrolled.child_x0, p->stat.scrolled.child_y0,
		   p->stat.scrolled.child_sx, p->stat.scrolled.child_sy);
	    printf("  %s %d %d %d %d\n",debug_type(widget->type),
		   widget->x, widget->y, widget->sx, widget->sy);
	    printf("  %d\n",y1);
	    if (result) printf("ADJ %d,%d\n",
			       Q8TK_ADJUSTMENT(p->stat.scrolled.vadj)->value,
			       Q8TK_ADJUSTMENT(p->stat.scrolled.hadj)->value);
	    */


			break;
		    }
		    p = p->parent;
		}
		widget_scrollin[i].drawn  = FALSE;
		widget_scrollin[i].widget = NULL;
	    }
	}
    }

    return result;
}


/*------------------------------------------------------
   EBWbg̃tH[JXړ̃Xg쐬
   
	TABL[AJ[\L[ɂAtH[JẌړ邽߂ɁA
	ΏۂƂȂEBWbg̃Xg𐶐B

		widget_focus_list_reset()  c Xg̏
		widget_draw()              c `BŃXg𐶐

	widget_draw() ̓ł́AtH[JXړ̑ΏۂƂEBWbg
	`̍ۂɁAwwidget_focus_list_append()x ֐ĂԁB

    TABL[ȂǂꂽƂɁAɃtH[JẌڂEBWbg擾ɂ
    wwidget_focus_list_get_next()x֐ĂԁB
  ------------------------------------------------------*/
/* BACKTAB Ή  thanks! floi */

static	Q8List		*widget_focus_list;

/* S[N̏ (xs) */
static	void	widget_focus_list_init(void)
{
    widget_focus_list = NULL;
}
/* FEBWbg̕`OɌĂяo */
static	void	widget_focus_list_reset(void)
{
    q8_list_free(widget_focus_list);
    widget_focus_list = NULL;
}
/* ݒFtH[JXXgɓo^EBWbgȂAĂяo */
static	void	widget_focus_list_append(Q8tkWidget *widget)
{
    if (widget) {
	widget_focus_list = q8_list_append(widget_focus_list, widget);
    }
}
/* 擾FtH[JXXg̐擪EBWbg擾 */
static	Q8tkWidget *widget_focus_list_get_top(void)
{
    if (widget_focus_list) {
	return (Q8tkWidget *)(widget_focus_list->data);
    } else {
	return NULL;
    }
}
/* 擾FtH[JXXg̎(O)̃EBWbg擾 */
static	Q8tkWidget *widget_focus_list_get_next(Q8tkWidget *widget, int back)
{
    Q8List *list;

    if (widget == NULL) {
	return widget_focus_list_get_top();
    }

#if	defined(OLD_FOCUS_CHANGE)
    list = q8_list_find(widget_focus_list, widget);

#else	/* VȃtH[JXړ */
    switch (widget->type) {
    case Q8TK_TYPE_RADIO_BUTTON:
	{
	    /* I RADIO BUTTON TāȂO */
	    Q8List *l = widget->stat.button.list;
	    while (l) {
		widget = (Q8tkWidget *)(l->data);
		if (widget->stat.button.active == Q8TK_BUTTON_ON) break;
		l = l->next;
	    }
	}
	list = q8_list_find(widget_focus_list, widget);
	break;

    case Q8TK_TYPE_NOTEPAGE:
	/* ̂ƂAtH[JX̂NOTEPAGE͏ɑIԂ
	   Ȃ̂ŁATABtB܂Aɂ͂ȂB */
	widget = (widget->parent)->stat.notebook.page;
	list = q8_list_find(widget_focus_list, widget);
	break;

    case Q8TK_TYPE_COMBO:
	if (widget->stat.combo.entry->stat.entry.editable == FALSE) {
	    /* ENTRY ҏWs̏ꍇ́ACOMBO g̑O */
	    list = q8_list_find(widget_focus_list, widget);
	} else {
	    /* ENTRY ҏW̏ꍇ */
	    if (back == FALSE) {
		/* COMBO ̎́AENTRY ̎ɓ */
		list = q8_list_find(widget_focus_list,
				    widget->stat.combo.entry);
	    } else {
		/* COMBO ̑ÓAENTRY ̂̂ɂĂ܂ */
		return widget->stat.combo.entry;
	    }
	}
	break;

    default:
	list = q8_list_find(widget_focus_list, widget);
	break;
    }
#endif

    if (list) {
	if (back == FALSE) {
	    if (list->next)  return (Q8tkWidget*)((list->next)->data);
	    else             return (Q8tkWidget*)((q8_list_first(list))->data);
	} else {
	    if (list->prev)  return (Q8tkWidget*)((list->prev)->data);
	    else             return (Q8tkWidget*)((q8_list_last(list))->data);
	}
    }
    return NULL;
}




/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/*------------------------------------------------------*/
/* g̕\ʒuƂɁA`悵A
   ċAIɁASĂ̎qEBWFbg`悷B		*/
/*------------------------------------------------------*/

static	void	widget_draw(Q8tkWidget *widget,
			    int parent_focus, int parent_sensitive)
{
    int		x = widget->x;
    int		y = widget->y;
    Q8tkWidget	*child = widget->child;
    int		focus, sensitive;
    int		next_focus;
    Q8tkWidget	*sense_widget;

    /* etH[JX肩AgtH[JXŁAtH[JXԂƂ*/
    focus = (parent_focus || (widget == get_focus_widget())) ? TRUE : FALSE;

    /* e\ŁAg\ȂA\Ƃ */
    sensitive = (parent_sensitive && widget->sensitive) ? TRUE : FALSE;
    sense_widget = (sensitive) ? widget : NULL;

    /* ԂɃtH[JX`ꍇA^Bʏ͓`Ȃ */
    next_focus = FALSE;



    widget_scrollin_drawn(widget);


		/* HBOXAVBOX ̎q̏ꍇɌA*/
		/* zu኱ύXłB	*/
		/* FRAME łɃVƂ悤 */

    if (widget->parent) {
	switch ((widget->parent)->type) {
	case Q8TK_TYPE_FRAME:
	    if        (widget->placement_x == Q8TK_PLACEMENT_X_CENTER) {
		x += ((widget->parent)->sx -2 - widget->sx) / 2;
	    } else if (widget->placement_x == Q8TK_PLACEMENT_X_RIGHT) {
		x += ((widget->parent)->sx -2 - widget->sx);
	    }
	    widget->x = x;
	    break;
	case Q8TK_TYPE_VBOX:
	    if        (widget->placement_x == Q8TK_PLACEMENT_X_CENTER) {
		x += ((widget->parent)->sx - widget->sx) / 2;
	    } else if (widget->placement_x == Q8TK_PLACEMENT_X_RIGHT) {
		x += ((widget->parent)->sx - widget->sx);
	    }
	    widget->x = x;
	    break;
	case Q8TK_TYPE_HBOX:
	    if        (widget->placement_y == Q8TK_PLACEMENT_Y_CENTER) {
		y += ((widget->parent)->sy - widget->sy) / 2;
	    } else if (widget->placement_y == Q8TK_PLACEMENT_Y_BOTTOM) {
		y += ((widget->parent)->sy - widget->sy);
	    }
	    widget->y = y;
	    break;
	}
    }


		/* g typeƂɘgȂǂB*/
		/* q΁Ax,y B		*/
		/* q̒(next)́Ax,y ߂B	*/
		/* ̎qɑ΂Ă̂ݍċAIɏB	*/

/*printf("%s (%d,%d) %d %d\n",debug_type(widget->type),widget->sx,widget->sy,widget->x,widget->y);fflush(stdout);*/

    if (widget->visible) {

	switch (widget->type) {

	case Q8TK_TYPE_WINDOW:			/* EChE		*/
	    if (widget->stat.window.no_frame) {
		/* no frame */
	    } else {
		q8gr_draw_window(x, y, widget->sx, widget->sy,
				 widget->stat.window.shadow_type,
				 (widget->stat.window.type
					== Q8TK_WINDOW_POPUP)
						? Q8GR_WIDGET_WINDOW : NULL);
	    }
	    if (child) {
		child->x = x  + (widget->stat.window.no_frame ? 0 : 1);
		child->y = y  + (widget->stat.window.no_frame ? 0 : 1);
		widget_draw(child, FALSE, sensitive);
	    }
	    break;

	case Q8TK_TYPE_BUTTON:			/* {^		*/
	case Q8TK_TYPE_TOGGLE_BUTTON:		/* gO{^		*/
	    widget_focus_list_append(sense_widget);
	    q8gr_draw_button(x, y, widget->sx, widget->sy,
			     widget->stat.button.active, sense_widget);
	    if (child) {
		child->x = x + 1;
		child->y = y + 1;
		widget_draw(child, focus, sensitive);
	    }
	    break;

	case Q8TK_TYPE_CHECK_BUTTON:		/* `FbN{^	*/
	    widget_focus_list_append(sense_widget);
	    q8gr_draw_check_button(x, y, widget->stat.button.active,
				   sense_widget);
	    if (child) {
		child->x = x + 3;
		child->y = y;
		widget_draw(child, focus, sensitive);
	    }
	    break;

	case Q8TK_TYPE_RADIO_BUTTON:		/* WI{^		*/
#if	defined(OLD_FOCUS_CHANGE)
	    widget_focus_list_append(sense_widget);
#else	/* VȃtH[JXړ */
	    if (widget->stat.button.active == Q8TK_BUTTON_ON) {
		widget_focus_list_append(sense_widget);
	    }
#endif
	    q8gr_draw_radio_button(x, y, widget->stat.button.active,
				   sense_widget);
	    if (child) {
		child->x = x + 3;
		child->y = y;
		widget_draw(child, focus, sensitive);
	    }
	    break;

	case Q8TK_TYPE_FRAME:			/* t[		*/
	    q8gr_draw_frame(x, y, widget->sx, widget->sy,
			    widget->stat.frame.shadow_type,
			    widget->code, widget->name,
			    sense_widget);
	    if (child) {
		child->x = x + 1;
		child->y = y + 1;
		widget_draw(child, FALSE, sensitive);
	    }
	    break;

	case Q8TK_TYPE_LABEL:			/* x		*/
	    q8gr_draw_label(x, y,
			    widget->stat.label.foreground,
			    widget->stat.label.background,
			    widget->stat.label.reverse,
			    focus,
			    (widget->name) ? (widget->code) : Q8TK_KANJI_ANK,
			    (widget->name) ? (widget->name) : "",
			    sense_widget);
	    break;

	case Q8TK_TYPE_LOGO:			/* S			*/
	    q8gr_draw_logo(x, y);
	    break;

	case Q8TK_TYPE_NOTEBOOK:		/* m[gubN		*/
	    q8gr_draw_notebook(x, y, widget->sx, widget->sy,
			       widget, sense_widget);
	    if (child) {
		child->x = x;
		child->y = y;
		widget_draw(child, FALSE, sensitive);
	    }
	    break;
	case Q8TK_TYPE_NOTEPAGE:		/* m[gy[W		*/
	    {
		int select_flag =
			      (widget == (widget->parent)->stat.notebook.page);

		q8gr_draw_notepage((widget->name) ? widget->code
						  : Q8TK_KANJI_ANK,
				   (widget->name) ? widget->name : "",
				   select_flag,
				   /*(select_flag) ? FALSE :*/ focus,
				   widget->parent,
				   sense_widget);
		if (child && select_flag) {
		    child->x = ((widget->parent)->x) + 1;
		    child->y = ((widget->parent)->y) + 3;
		    widget_focus_list_append(widget);
		    widget_draw(child, FALSE, sensitive);
		}
#if	defined(OLD_FOCUS_CHANGE)
		else {
		    widget_focus_list_append(sense_widget);
		}
#endif
	    }
	    break;

	case Q8TK_TYPE_VBOX:			/* {bNX		*/
	    if (child) {
		child->x = x;	x += 0;
		child->y = y;	y += child->sy;
		while (child->next) {
		    child = child->next;
		    child->x = x;	x += 0;
		    child->y = y;	y += child->sy;
		}
		child = widget->child;
		widget_draw(child, FALSE, sensitive);
	    }
	    break;
	case Q8TK_TYPE_HBOX:			/* {bNX		*/
	    if (child) {
		child->x = x;	x += child->sx;
		child->y = y;	y += 0;
		while (child->next) {
		    child = child->next;
		    child->x = x;	x += child->sx;
		    child->y = y;	y += 0;
		}
		child = widget->child;
		widget_draw(child, FALSE, sensitive);
	    }
	    break;

	case Q8TK_TYPE_VSEPARATOR:		/* ؂		*/
	    q8gr_draw_vseparator(x, y, widget->sy);
	    break;
	case Q8TK_TYPE_HSEPARATOR:		/* ؂		*/
	    q8gr_draw_hseparator(x, y, widget->sx);
	    break;

	case Q8TK_TYPE_COMBO:			/* R{{bNX	*/
	    widget->stat.combo.entry->x  = x;
	    widget->stat.combo.entry->y  = y;
	    widget->stat.combo.entry->sx = widget->sx -3;
	    widget_draw(widget->stat.combo.entry, FALSE, sensitive);

#if	defined(OLD_FOCUS_CHANGE)
	    widget_focus_list_append(sense_widget);
#else	/* VȃtH[JXړ */
	    if (widget->stat.combo.entry->stat.entry.editable == FALSE) {
		widget_focus_list_append(sense_widget);
	    }
#endif
	    q8gr_draw_combo(x, y, widget->sx -3, focus, sense_widget);
	    break;

	case Q8TK_TYPE_LISTBOX:			/* Xg{bNX	*/
	    widget_focus_list_append(sense_widget);
	    if (child) {
		child->x = x;	x += 0;
		child->y = y;	y += child->sy;
		while (child->next) {
		    child = child->next;
		    child->x = x;	x += 0;
		    child->y = y;	y += child->sy;
		}
		child = widget->child;
		widget_draw(child, focus, sensitive);
	    }
	    break;

	case Q8TK_TYPE_LIST_ITEM:		/* XgACe	*/
	    if (child) {
		int rev   = (widget->parent->stat.listbox.selected == widget)
								? TRUE : FALSE;
		int under = (widget->parent->stat.listbox.active == widget)
								? TRUE : FALSE;
		if (rev && under) under = FALSE;

		q8gr_draw_list_item(x, y, widget->sx, focus, rev,
				    under, child->code, child->name,
				    sense_widget);
	    }
	    next_focus = focus; 
	    break;

	case Q8TK_TYPE_ADJUSTMENT:		/* AWXgg	*/
	    Q8tkAssert(FALSE, NULL);
	    break;

	case Q8TK_TYPE_HSCALE:			/* XP[		*/
	    if (widget->stat.scale.adj) {
		int a_focus = (focus ||
			       (widget->stat.scale.adj == get_focus_widget()))
								? TRUE : FALSE;
		Q8tkWidget *a_widget = ((sensitive) ? widget->stat.scale.adj
						    : NULL);
		widget_focus_list_append(a_widget);
		widget->stat.scale.adj->x = x;
		widget->stat.scale.adj->y = y;
		q8gr_draw_hscale(x, y,
				 &(widget->stat.scale.adj->stat.adj),
				 a_focus,
				 widget->stat.scale.draw_value,
				 widget->stat.scale.value_pos,
				 a_widget);
	    }
	    break;
	case Q8TK_TYPE_VSCALE:			/* XP[		*/
	    if (widget->stat.scale.adj) {
		int a_focus = (focus ||
			       (widget->stat.scale.adj == get_focus_widget()))
								? TRUE : FALSE;
		Q8tkWidget *a_widget = ((sensitive) ? widget->stat.scale.adj
						    : NULL);
		widget_focus_list_append(a_widget);
		widget->stat.scale.adj->x = x;
		widget->stat.scale.adj->y = y;
		q8gr_draw_vscale(x, y,
				 &(widget->stat.scale.adj->stat.adj),
				 a_focus,
				 widget->stat.scale.draw_value,
				 widget->stat.scale.value_pos,
				 a_widget);
	    }
	    break;

	case Q8TK_TYPE_SCROLLED_WINDOW:		/* XN[hEChE */
	    if (child) {
		int a_focus;
		Q8tkWidget *a_widget;

		int sx = widget->sx;
		int sy = widget->sy;

		if (widget->stat.scrolled.vscrollbar) { sx --; }
		if (widget->stat.scrolled.hscrollbar) { sy --; }

		q8gr_draw_scrolled_window(x, y, sx, sy,
					  Q8TK_SHADOW_ETCHED_OUT,
					  sense_widget);
		q8gr_set_screen_mask(x+1, y+1, sx-2, sy-2);
		widget->stat.scrolled.child_x0
				= widget->stat.scrolled.hadj->stat.adj.value;
		widget->stat.scrolled.child_y0
				= widget->stat.scrolled.vadj->stat.adj.value;
		widget->stat.scrolled.child_sx = sx -2;
		widget->stat.scrolled.child_sy = sy -2;

		child->x = x - widget->stat.scrolled.child_x0 +1;
		child->y = y - widget->stat.scrolled.child_y0 +1;

		widget_draw(child, FALSE, sensitive);
		q8gr_reset_screen_mask();

		if (widget->stat.scrolled.vscrollbar) {
		    a_focus = (focus ||
			(widget->stat.scrolled.vadj == get_focus_widget()))
								? TRUE : FALSE;
		    a_widget = ((sensitive) ? widget->stat.scrolled.vadj
					    : NULL);
		    /* tH[JXXgɂ͓Ȃق̂ł́c */
		    widget_focus_list_append(a_widget);
		    q8gr_draw_vscale(x + sx, y,
				     &(widget->stat.scrolled.vadj->stat.adj),
				     a_focus,
				     FALSE, 0,
				     a_widget);
		}
		if (widget->stat.scrolled.hscrollbar) {
		    a_focus = (focus ||
			(widget->stat.scrolled.hadj == get_focus_widget()))
								? TRUE : FALSE;
		    a_widget = ((sensitive) ? widget->stat.scrolled.hadj
					    : NULL);
		    /* tH[JXXgɂ͓Ȃق̂ł́c */
		    widget_focus_list_append(a_widget);
		    q8gr_draw_hscale(x, y + sy,
				     &(widget->stat.scrolled.hadj->stat.adj),
				     a_focus,
				     FALSE, 0,
				     a_widget);
		}
	    } else {
		q8gr_draw_window(x, y, widget->sx, widget->sy,
				 Q8TK_SHADOW_ETCHED_OUT,
				 NULL);
	    }
	    break;

	case Q8TK_TYPE_ENTRY:			/* Gg		*/
	    if (widget->stat.entry.editable) {
		widget_focus_list_append(sense_widget);
	    }
	    if (focus &&
		widget->stat.entry.editable &&
		widget->stat.entry.cursor_pos < 0) {
		q8tk_entry_set_position(widget,
				      q8gr_strlen(widget->code, widget->name));
	    }

	    q8gr_draw_entry(x, y, widget->sx, widget->code, widget->name,
			    widget->stat.entry.disp_pos,
			    ((focus && widget->stat.entry.editable)
					? widget->stat.entry.cursor_pos: -1),
			    sense_widget);
	    break;

	case Q8TK_TYPE_DIALOG:			/* _CAO		*/
	    Q8tkAssert(FALSE, NULL);
	    break;
	case Q8TK_TYPE_FILE_SELECTION:		/* t@CZNV	*/
	    Q8tkAssert(FALSE, NULL);
	    break;

	default:
	    Q8tkAssert(FALSE, "Undefined type");
	}
    }


	/* g̒ (next) ݂΁AċAIɏ */
  
    if (widget->next) {
	widget = widget->next;
	widget_draw(widget, next_focus, parent_sensitive);
    }
}














/*------------------------------------------------------*/
/* XN[ʂ쐬B
   q8tk_grab_add() Őݒ肳ꂽ WINDOW gbvƂāA
   SĂ̎qEBWFbg̑傫AʒuvZA
   menu_screen[][]ɁA\eݒ肷B
   ɁATAB L[ꂽ́AtH[JX̕ύX
   菇߂ĂB					*/
/*------------------------------------------------------*/

static	void	widget_construct(void)
{
    int		i, j, tmp;
    Q8tkWidget	*widget;

    q8gr_clear_screen();

    for (i=0; i<MAX_WINDOW_LAYER; i++) {

	widget = window_layer[i];

	if (widget) {
	    Q8tkAssert(widget->type == Q8TK_TYPE_WINDOW, NULL);

	    for (j=0; j<2; j++) {

		q8gr_clear_focus_screen();

		widget_size(widget, &tmp, &tmp, &tmp, &tmp);

		if (widget->stat.window.set_position == FALSE) {
		    widget->x = (Q8GR_SCREEN_X - widget->sx) / 2;
		    widget->y = (Q8GR_SCREEN_Y - widget->sy) / 2;
		} else {
		    widget->x = widget->stat.window.x;
		    widget->y = widget->stat.window.y;
		}

		widget_scrollin_adjust_reset();

		widget_focus_list_reset();
		widget_draw(widget, FALSE, widget->sensitive);

		if (widget_scrollin_adjust()) {
		    /* Redraw! */
		} else {
		    break;
		}

	    }

	} else {
	    break;
	}
    }


    if (get_focus_widget() == NULL) {
	q8tk_widget_set_focus(widget_focus_list_get_top());
    }

#if 0
    if (get_drag_widget()) {
	/* none */
    } else {
	Q8tkWidget *w;
	int exist;

	w = q8tk_tab_top_widget;

	if (w) {

	    do {			/* TAB TOP  NOTEPAGE ȊOɐݒ */
		if (w->type != Q8TK_TYPE_NOTEPAGE) break;
		w = w->tab_next;
	    } while (w != q8tk_tab_top_widget);
	    q8tk_tab_top_widget = w;

	    exist = FALSE;		/* event_widget ݂邩`FbN */
	    do {			
		if (w == get_event_widget()) {
		    exist = TRUE;
		    break;
		}
		w = w->tab_next;
	    } while (w != q8tk_tab_top_widget);
	    if (! exist) {		/*    ݂Ȃ NULL ɂĂ */
		set_event_widget(NULL);
	    }
	}
    }
#endif

    if (disp_cursor) {
	q8gr_draw_mouse(mouse.x/8, mouse.y/16);
    }


#if 0
{
 int i, j; const char *c; void *w;
 for (j=0; j<Q8GR_SCREEN_Y; j++) {
  for (i=0; i<Q8GR_SCREEN_X; i++) {
    w = q8gr_get_focus_screen(i, j);
    if      (w == Q8GR_WIDGET_NONE)   c = " ";
    else if (w == Q8GR_WIDGET_WINDOW) c = "*";
    else                              c = debug_type(((Q8tkWidget *)w)->type);
    printf("%c", *c);
  }
  printf("\n");
 }
 printf("\n");
 fflush(0);
}
#endif

#if 0
{
 int i;
 for (i=0; i<MAX_WIDGET_SCROLLIN; i++) {
  Q8tkWidget *w = widget_scrollin[i].widget;
  printf("%d [%s] %p\n",widget_scrollin[i].drawn,(w)?debug_type(w->type):"",w);
 }
 printf("--\n");fflush(0);
}
#endif

#if 0
 for (tmp=0,i=0; i<MAX_WIDGET; i++) { if (widget_table[i]) tmp++; }
 printf("[TOTAL WIDGET] %d/%d : ",tmp,MAX_WIDGET);
 for (tmp=0,i=0; i<MAX_LIST; i++) { if (list_table[i]) tmp++; }
 printf("[TOTAL LIST] %d/%d\n",tmp,MAX_LIST);
#endif
}
